<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// backup.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-admin' ;
	$tran = 'backup' ;
	$enable_vfs = True ;
	require_once('../ck-api/ckapi.inc.php') ;

	$t = exapi_tpl($app);
	$t->set_file('report','confirm.tpl');

/*---------------------------------------------------------------------------------*/
//	Attribute tables are backed up via an independently created $tables array
//	Although department is one of the attribute tables, it is included in the main
//	backup list, because it is also one of the built-in tables for ck-hr

	$tables	= array('md5','category','fund','project','department','achievement',
			'chart','gl','service','remark','currency','acc_trans','bkr_trans',
			'il','inv_trans','parts','assembly','alternate','makemodel',
			'vendor','customer','tax','vendortax','customertax','itemtax',
			'ap','ar','invoice','payment','receipt','p_match','r_match','ipmatch','ismatch',
			'po','so','quote','oitem','sqmatch','qcash','addon','sprice','cashbox',
			'pos','positem','cbtran','defaults','resourcelock','log','errlog',
			'empperson','employee','address','ec','dates','leave','pr','role',
			'attendance','timesheet','ts_trans','leaveapp',
			'payroll','pyrcode','pyrc_trans','pynr_trans','rdtn_trans','cntr_trans',
			'reductn','rdtnrate','rdtnexem','contri','cntrrate','cntrexem','pyrohist',
			'org','person','person_org','person_person','org_person','org_org','comm','status','others',
			'scontract','pcontract','stdterm','spcterm','helpcase','helpcall','salecase','salecall',
			'vendcase','vendcall','rights','i18ncode','i18n','i18nnew') ;

	$result = $adodb->query("SELECT version,attrib1tbl,attrib2tbl,attrib3tbl from ${pre}defaults") ;
	$version = exapi_dbflds($result,'version') ;
	$attrib1tbl = exapi_dbflds($result,'attrib1tbl') ;
	$attrib2tbl = exapi_dbflds($result,'attrib2tbl') ;
	$attrib3tbl = exapi_dbflds($result,'attrib3tbl') ;
	$user	=	$ckapi['hostsys']['username'] ;
	$db_type =	$ckapi['hostsys']['dbtype'] ;
	$host	=	$ckapi['hostsys']['dbhost'] ;
	$database =	$ckapi['hostsys']['dbname'] ;
	$dbuser	=	$ckapi['hostsys']['dbuser'] ;
	$datetime =	date("Y-m-d; h:m:s") ;
	$dir	=	$ckapi['hostsys']['dataarea'] ;
	$date	=	date("Ymd") ;
	$filename =	$dir."/".$database.".".$date.".$db_type.restore.sql" ;
	$backup = exapi_lang("Backup File") ;
	$created = exapi_lang("created") ;
	$headercontent = exapi_lang("Header Content") ;

	umask(000) ;
	$msg = '' ;
	if (!is_dir($dir))	mkdir($dir,0777) ;
	if ($fp = fopen($filename,"w")) {
		$msg.= "<br><font size='+2'>$backup [$filename] $created</font><br>" ;
		$msg.= "<br>$headercontent<br><br>" ;
		$line="-- CK-ERP Backup\n" ;		fputs($fp,$line); $msg.= $line."<br>";
		$line="-- Version:	$version\n" ;	fputs($fp,$line); $msg.= $line."<br>";
		$line="-- Backup'er:	$user\n" ;	fputs($fp,$line); $msg.= $line."<br>";
		$line="-- Host:		$host\n" ;	fputs($fp,$line); $msg.= $line."<br>";
		$line="-- Database:	$database\n" ;	fputs($fp,$line); $msg.= $line."<br>";
		$line="-- DBUser:	$dbuser\n" ;	fputs($fp,$line); $msg.= $line."<br>";
		$line="-- Datetime:	$datetime\n" ;	fputs($fp,$line); $msg.= $line."<br>";
		$line="--\n";				fputs($fp,$line);

		foreach ($tables as $table) {
			$table = $pre.$table ;
			$line = "DROP TABLE $table;\n" ;
			if ($table==$attrib1tbl or $table==$attrib2tbl or $table==$attrib3tbl)	$line='**'.$line;
			fputs($fp,$line);
			}
		fputs($fp,"--\n");
		fputs($fp,"--\n");

		require_once('../ck-admin/adminddl.php') ;
		foreach ($sql as $sqla) {
			list($dummy,$dummy,$table) = explode(" ",$sqla) ;
			$line = "$sqla;\n" ;
			if ($table==$attrib1tbl or $table==$attrib2tbl or $table==$attrib3tbl)	$line='**'.$line;
			fputs($fp,$line);
			}
		fputs($fp,"--\n");
		fputs($fp,"--\n");

		foreach ($tables as $table) {
			$table = $pre.$table ;
			$result = $adodb->query("SELECT * FROM $table") ;
			While ($rs=$result->fetchRow()) {
				$line = "INSERT INTO $table VALUES (" ;
				foreach ($rs as $key => $value)
					if (!is_numeric($key))	$line.= "'".addslashes($value)."'," ;
				$line = substr($line,0,-1).");\n" ;
				if ($table==$attrib1tbl or $table==$attrib2tbl or $table==$attrib3tbl)	$line='**'.$line;
				fputs($fp,$line);
				}
			fputs($fp,"--\n");
			}

		if ($db_type=="pgsql")	{
			$result = $adodb->query("SELECT nextval('id') as id") ;
			$id = exapi_dbflds($result,'id') ;
			$line = "DROP SEQUENCE id;\n" ;			fputs($fp,$line);
			$line = "CREATE SEQUENCE id START $id;\n";	fputs($fp,$line);
			$line="--\n" ;					fputs($fp,$line);
			}

		fclose($fp) ;
		}

	$reminder1=exapi_lang("Please remember to backup additionally the (images) folder within your host system files area") ;
	$reminder2=exapi_lang("Please also maintain separate independent backup of the attribute tables, if they are used by other host system modules") ;
	$msg.= "<br>$reminder1.  $reminder2.<br>";

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('msg',$msg) ;
	$t->set_var('lang_confirm','');
	$t->set_var('lang_yes',exapi_lang('Done'));
	$t->set_var('lang_no',exapi_lang('Done'));
	$t->set_var('yes_action',exapi_link("/$app/index.php")) ;
	$t->set_var('no_action',exapi_link("/$app/index.php")) ;
	$t->pparse('out','report');
	exapi_footer() ;

?>
