<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// controlreport.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-ap' ;
	$tran = 'controlreport' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$repdate = ($_GET["repdate"]) ? $_GET["repdate"] : $_POST["repdate"] ;

	$t = exapi_tpl($app);
	$t->set_file('report','controlreport.tpl');
	$t->set_block('report','block1','block1_section');
	$t->set_block('report','block1a','block1a_section');
	$t->set_block('report','block2','block2_section');
	$t->set_block('report','block2a','block2a_section');

/*---------------------------------------------------------------------------------*/

	$note1 = exapi_lang('Note 1') ;
	$t->set_var('lang_control_report', exapi_lang('Accounts Payable Audit Control Report'));
	$t->set_var('lang_detail', exapi_lang('Detail'));
	$t->set_var('lang_note', exapi_lang('Note'));
	$t->set_var('lang_date', exapi_lang('Date'));
	$t->set_var('lang_vendor', exapi_lang('Vendor'));
	$t->set_var('lang_tax', exapi_lang('Tax Type'));
	$t->set_var('lang_invoice', exapi_lang('Payable'));
	$t->set_var('lang_invoiceitem', exapi_lang('Invoice Item'));
	$t->set_var('lang_payment', exapi_lang('Payment'));
	$t->set_var('lang_requested_status', exapi_lang('REQUESTED STATUS'));
	$t->set_var('lang_current_status', exapi_lang('TOTAL SYSTEM STATUS'));
	$t->set_var('lang_status_asof', exapi_lang('Status as of'));
	$t->set_var('lang_print_date', exapi_lang('Date Report Printed'));
	$t->set_var('lang_status_note', exapi_lang('(note the effect of postdated Invoices)'));
	$t->set_var('lang_note1',$note1);
	$t->set_var('lang_total_amount', exapi_lang('Total Amount'));
	$t->set_var('lang_total_netamount', exapi_lang('Total Amount (Net of Tax)'));
	$t->set_var('lang_total_tax', exapi_lang('Total Tax'));
	$t->set_var('lang_total_count', exapi_lang('Total Record Count'));
	$t->set_var('lang_latest_id', exapi_lang('Latest Audit Trail ID'));
	$note1a = exapi_lang('These lines are for control reconciliation purpose only') ;
	$note1b = exapi_lang('The figures represent an amalgamation of different currency amounts') ;
	$t->set_var('note1',"$note1 - $note1a. $note1b.");

/*-----------------Gather and Write Status Date Info---------------------------------*/

$sql =	"SELECT isocode,sum(amount) as curr_amount FROM ${pre}ap " ;
$sql.=	"WHERE transdate <= '$repdate' GROUP BY isocode ORDER BY isocode" ;
$result = $adodb->query($sql);
if (exapi_dbrc($result)==0)	$t->set_var('block1_section',"");
While ($rs=$result->fetchRow()) {
	$t->set_var(array('isocode'	=> $rs['isocode'],
			'curr_amount'	=> $rs['curr_amount']  ));
	$t->parse('block1_section','block1',true);
	}

$sql =	"SELECT isocode,sum(amount) as curr_amount FROM ${pre}payment " ;
$sql.=	"WHERE transdate <= '$repdate' GROUP BY isocode ORDER BY isocode" ;
$result = $adodb->query($sql);
if (exapi_dbrc($result)==0)	$t->set_var('block1a_section',"");
While ($rs=$result->fetchRow()) {
	$t->set_var(array('isocode'	=> $rs['isocode'],
			'curr_amount'	=> $rs['curr_amount']  ));
	$t->parse('block1a_section','block1a',true);
	}

$result = $adodb->query("SELECT sum(amount) as amount,sum(netamount) as netamount from ${pre}ap WHERE transdate<='$repdate'");
$invoice_amount = exapi_dbflds($result,'amount') ;
$invoice_netamount = exapi_dbflds($result,'netamount') ;

$sql =	"SELECT sum((-qty)*cost-discount-tax1-tax2) as invoice_item_amount from ${pre}invoice a,${pre}ap b ";
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='t'" ;
$result = $adodb->query($sql);
$invoice_item_netamount = exapi_dbflds($result,'invoice_item_amount') ;

$sql =	"SELECT sum((-qty)*cost-discount) as invoice_item_amount from ${pre}invoice a,${pre}ap b " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='f'" ;
$result = $adodb->query($sql);
$invoice_item_netamount += exapi_dbflds($result,'invoice_item_amount') ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 from ${pre}invoice a,${pre}ap b " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$result = $adodb->query($sql);
$invoice_item_tax = exapi_dbflds($result,'tax1')+exapi_dbflds($result,'tax2') ;

$result = $adodb->query("SELECT sum(amount) as amount from ${pre}payment WHERE transdate <= '$repdate'");
$payment_amount = exapi_dbflds($result,'amount') ;

$result = $adodb->query("SELECT count(id) as count from ${pre}ap WHERE transdate <= '$repdate'");
$invoice_count = exapi_dbflds($result,'count') ;

$sql =	"SELECT count(a.id) as count from ${pre}invoice a,${pre}ap b " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$result = $adodb->query($sql);
$invoice_item_count = exapi_dbflds($result,'count') ;

$result = $adodb->query("SELECT count(id) as count from ${pre}payment WHERE transdate <= '$repdate'");
$payment_count = exapi_dbflds($result,'count') ;

$result = $adodb->query("SELECT max(id) as id from ${pre}ap WHERE transdate <= '$repdate'");
$invoice_id = exapi_dbflds($result,'id') ;

$result = $adodb->query("SELECT max(a.id) as id from ${pre}invoice a,${pre}ap b WHERE transdate <= '$repdate' and a.trans_id=b.id");
$invoice_item_id = exapi_dbflds($result,'id') ;

$result = $adodb->query("SELECT max(id) as id from ${pre}payment WHERE transdate <= '$repdate'");
$payment_id = exapi_dbflds($result,'id') ;

$t->set_var('status_date',$repdate) ;
$t->set_var('invoice_amount',sprintf("%01.2f",$invoice_amount)) ;
$t->set_var('invoice_netamount',sprintf("%01.2f",$invoice_netamount)) ;
$t->set_var('invoice_item_netamount',sprintf("%01.2f",$invoice_item_netamount)) ;
$t->set_var('invoice_item_tax',sprintf("%01.2f",$invoice_item_tax)) ;
$t->set_var('payment_amount',sprintf("%01.2f",$payment_amount)) ;
$t->set_var('invoice_count',$invoice_count) ;
$t->set_var('invoice_item_count',$invoice_item_count) ;
$t->set_var('payment_count',$payment_count) ;
$t->set_var('invoice_id',$invoice_id) ;
$t->set_var('invoice_item_id',$invoice_item_id) ;
$t->set_var('payment_id',$payment_id) ;

/*-----------------Gather and Write Total System Info-----------------------------*/

$result = $adodb->query("SELECT isocode,sum(amount) as curr_amount FROM ${pre}ap GROUP BY isocode ORDER BY isocode");
if (exapi_dbrc($result)==0)	$t->set_var('block2_section',"");
While ($rs=$result->fetchRow()) {
	$t->set_var(array('isocode'	=> $rs['isocode'],
			'curr_amount'	=> $rs['curr_amount']  ));
	$t->parse('block2_section','block2',true);
	}

$result = $adodb->query("SELECT isocode,sum(amount) as curr_amount FROM ${pre}payment GROUP BY isocode ORDER BY isocode");
if (exapi_dbrc($result)==0)	$t->set_var('block2a_section',"");
While ($rs=$result->fetchRow()) {
	$t->set_var(array('isocode'	=> $rs['isocode'],
			'curr_amount'	=> $rs['curr_amount']  ));
	$t->parse('block2a_section','block2a',true);
	}

$result = $adodb->query("SELECT sum(amount) as amount,sum(netamount) as netamount from ${pre}ap ");
$invoice_amount = exapi_dbflds($result,'amount') ;
$invoice_netamount = exapi_dbflds($result,'netamount') ;

$sql =	"SELECT sum((-qty)*cost-discount-tax1-tax2) as invoice_item_amount from ${pre}invoice a,${pre}ap b " ;
$sql.=	"WHERE a.trans_id=b.id and b.taxincluded='t'" ;
$result = $adodb->query($sql);
$invoice_item_netamount = exapi_dbflds($result,'invoice_item_amount') ;

$sql =	"SELECT sum((-qty)*cost-discount) as invoice_item_amount from ${pre}invoice a,${pre}ap b " ;
$sql.=	"WHERE a.trans_id=b.id and b.taxincluded='f'" ;
$result = $adodb->query($sql);
$invoice_item_netamount += exapi_dbflds($result,'invoice_item_amount') ;

$result = $adodb->query("SELECT sum(tax1) as tax1, sum(tax2) as tax2 from ${pre}invoice a,${pre}ap b WHERE a.trans_id=b.id");
$invoice_item_tax = exapi_dbflds($result,'tax1')+exapi_dbflds($result,'tax2') ;

$result = $adodb->query("SELECT sum(amount) as amount FROM ${pre}payment");
$payment_amount = exapi_dbflds($result,'amount') ;

$result = $adodb->query("SELECT count(id) as count FROM ${pre}vendor");
$vendor_count = exapi_dbflds($result,'count') ;

$result = $adodb->query("SELECT count(id) as count FROM ${pre}tax WHERE taxgroup='ap'");
$tax_count = exapi_dbflds($result,'count') ;

$result = $adodb->query("SELECT count(id) as count FROM ${pre}ap");
$invoice_count = exapi_dbflds($result,'count') ;

$result = $adodb->query("SELECT count(a.id) as count FROM ${pre}invoice a,${pre}ap b WHERE a.trans_id=b.id");
$invoice_item_count = exapi_dbflds($result,'count') ;

$result = $adodb->query("SELECT count(id) as count FROM ${pre}payment");
$payment_count = exapi_dbflds($result,'count') ;

$result = $adodb->query("SELECT max(id) as id FROM ${pre}vendor");
$vendor_id = exapi_dbflds($result,'id') ;

$result = $adodb->query("SELECT max(id) as id FROM ${pre}tax WHERE taxgroup='ap'");
$tax_id = exapi_dbflds($result,'id') ;

$result = $adodb->query("SELECT max(id) as id FROM ${pre}ap");
$invoice_id = exapi_dbflds($result,'id') ;

$result = $adodb->query("SELECT max(a.id) as id FROM ${pre}invoice a,${pre}ap b WHERE a.trans_id=b.id");
$invoice_item_id = exapi_dbflds($result,'id') ;

$result = $adodb->query("SELECT max(id) as id FROM ${pre}payment");
$payment_id = exapi_dbflds($result,'id') ;

$t->set_var('print_date',date("Y-m-d")) ;
$t->set_var('sys_invoice_amount',sprintf("%01.2f",$invoice_amount)) ;
$t->set_var('sys_invoice_netamount',sprintf("%01.2f",$invoice_netamount)) ;
$t->set_var('sys_invoice_item_netamount',sprintf("%01.2f",$invoice_item_netamount)) ;
$t->set_var('sys_invoice_item_tax',sprintf("%01.2f",$invoice_item_tax)) ;
$t->set_var('sys_payment_amount',sprintf("%01.2f",$payment_amount)) ;
$t->set_var('sys_vendor_count',$vendor_count) ;
$t->set_var('sys_tax_count',$tax_count) ;
$t->set_var('sys_invoice_count',$invoice_count) ;
$t->set_var('sys_invoice_item_count',$invoice_item_count) ;
$t->set_var('sys_payment_count',$payment_count) ;
$t->set_var('sys_vendor_id',$vendor_id) ;
$t->set_var('sys_tax_id',$tax_id) ;
$t->set_var('sys_invoice_id',$invoice_id) ;
$t->set_var('sys_invoice_item_id',$invoice_item_id) ;
$t->set_var('sys_payment_id',$payment_id) ;


/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',exapi_link("/$app/reportfilter.php")) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report');
	exapi_footer() ;

?>
