<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// invpayhist.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-ap' ;
	$tran = $class = 'invoice' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$start = ($_GET["start"]) ? $_GET["start"] : $_POST["start"] ;
	$filter=stripslashes($filter);

	$invoice = newobj($app,$class) ;
	$t = exapi_tpl($app);
	$ckapi[objects][template] = &$t ;
	$t->set_file('report','invpayhistscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',exapi_lang('View Invoice Payment History'));
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','disabled');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

/*------------- Write Invoice to Screen Display ----------------------------*/

	$result = $adodb->query("SELECT * FROM ${pre}ap WHERE id='$id'");
	$ckapi[params_post][dt] = $result->fetchRow() ;
	$duedate = $ckapi[params_post][dt][duedate] ;
	$invamount = $ckapi[params_post][dt][amount] ;
	$netamount = $ckapi[params_post][dt][netamount] ;
	$taxincluded = $ckapi[params_post][dt][taxincluded] ;
	$ckapi[params_post][dt][taxstatus] = ($invamount==$netamount) ? "e" : $taxincluded ;
	$invoice->invoice_header_write() ;

	$t->set_var('lang_date',exapi_lang('Date'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_paymentid',exapi_lang('Payment ID<br>/Days Overdue'));
	$t->set_var('lang_payamount',exapi_lang('Payment Amount'));
	$t->set_var('lang_samount',exapi_lang('Amount Settled<br>against this Invoice'));
	$t->set_var('lang_osamount',exapi_lang('Outstanding<br>Invoice Amount'));
	$t->set_var('lang_title_detail',exapi_lang('Detail'));
	$t->set_var('date',$duedate);
	$t->set_var('description',"<- ".exapi_lang('Due Date')." / ".exapi_lang('Invoice Amount')." ->");
	$t->set_var('paymentid','');
	$t->set_var('payamount','');
	$t->set_var('samount','');
	$t->set_var('osamount',$invamount);
	$t->set_var('lang_item',exapi_lang('Invoice'));
	$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
	$ifilter = urlencode("${markpri}1a.id${marksec}${id}") ;
	$tran1 = ($invamount==$netamount) ? "invoicent" : "invoicewt" ;
	$item = exapi_link("/$app/${tran1}view.php","id=$id&filter=$ifilter");
	$t->set_var('item',$item) ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	$sql = "SELECT transdate,id,paynumber,amount,s_amount FROM ${pre}payment a, ${pre}p_match b " ;
	$sql.= "WHERE invoiceid='$id' and id=paymentid ORDER BY transdate" ;
	$result = $adodb->query($sql);
	$osamount = $invamount ;
	While ($rs=$result->fetchRow()) {
		$t->set_var('date',$rs['transdate']);
		$lang_payno = exapi_lang('Pay#/Cheque#') ;
		$t->set_var('description',"$lang_payno:    ".$rs['paynumber']);
		$id = $rs['id'];
		$t->set_var('paymentid',$id);
		$t->set_var('payamount',$rs['amount']);
		$samount = $rs['s_amount'] ;
		$t->set_var('samount',$samount);
		$osamount -= $samount ;
		$t->set_var('osamount',$osamount);
		$t->set_var('lang_item',exapi_lang('Payment'));
		$pfilter = urlencode("${markpri}1a.id${marksec}${id}") ;
		$item = exapi_link("/$app/paymentview.php","id=$id&filter=$pfilter");
		$t->set_var('item',$item) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('date',date("Y-m-d"));
	$t->set_var('description',"<- ".exapi_lang('System Date')." / ".exapi_lang("Days Overdue")." ->");
	$overdue = (time()-strtotime($duedate))/86400 ;
	$overdue = ($overdue<0 or $osamount<=0) ? exapi_lang("N/A") : floor($overdue) ;
	$t->set_var('paymentid',$overdue);
	$t->set_var('payamount','');
	$t->set_var('samount','');
	$t->set_var('osamount','');
	$t->set_var('lang_item','');
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('action',exapi_link("/$app/${tran1}list.php","filter=$filter")) ;
	$t->set_var('lang_post',exapi_lang('Done'));
	$t->set_var('lang_newrow',exapi_lang('Done'));
	$t->set_var('lang_update',exapi_lang('Done'));
	$t->set_var('done_action',exapi_link("/$app/${tran1}list.php","filter=$filter")) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	$msg = exapi_lang('Press [done] button at Detail screen to work on detail transaction maintenance');
	$t->set_var('message',$msg);
	$t->pparse('out','report',True);
	exapi_footer() ;

?>
