<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.process1.inc.php 0.15.1 2005/09/30 C K Wu

    class process1 {

//---- Process Filter

    function process1_filter() {
	global $ckapi,$exapidir,$exapi ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$search = ($_GET[search]) ? $_GET[search] : $_POST[search] ;
	$err = ($_GET[err]) ? $_GET[err] : $_POST[err] ;

	$t = exapi_tpl('ck-api');
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','select','select_section');
	$t->set_block('report','detail','detail_section');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

	$msg1 = exapi_lang('To search for all items, leave fields blank.') ;
	$msg2 = exapi_lang('Maximum length of search string is 15 characters.') ;
	$t->set_var('std_message',"$msg1  $msg2");

	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;
	if (is_array($ckapi[filter][actlist])) {
		$actnum = ($_GET[actnum]) ? $_GET[actnum] : $_POST[actnum] ;
		if ($actnum=="") {
			Foreach ($ckapi[filter][actlist] as $key=>$choice)	$ckapi[filter][0][selectlist] .= $choice ;
			$actstring = $ckapi[filter][actstring][0] ;
			}
		  else	{
			$ckapi[filter][0][selectlist] = $ckapi[filter][actlist][$actnum];
			$actstring = $ckapi[filter][actstring][$actnum] ;
			}
		}
	if ($err) {
		$t->set_var('lang_search_message',"<b>$err</b>") ;
		foreach ($ckapi[filter] as $key => $row) {
			$varname = $row[varname] ;
			$ckapi[filter][$key][defval] = ($_GET[$varname]) ? $_GET[$varname] : $_POST[$varname] ;
			}
		}
	$detail = $select = False ;
	foreach ($ckapi[filter] as $key => $row)	{
		if (is_array($ckapi[filter][actlist]))
			if (substr_count($actstring,$key)<=0 or !is_numeric($key))	continue ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->set_var('criteria',$row[criteria]);
		$t->set_var('varname',$row[varname]);
		$t->set_var('note',$row[note]);
		switch ($row[type])	:
			case "input" :
				$t->set_var('defval',$row[defval]);
				$t->set_var('checkbox',"");
				$t->set_var('checked',"");
				$t->parse('detail_section','detail', True);
				$detail = True ;
				break ;
			case "checkbox" :
				$t->set_var('defval','yes');
				$t->set_var('checkbox',"type='checkbox'");
				$checked = ($row[defval]=='yes') ? "checked" : "" ;
				$t->set_var('checked',$checked);
				$t->parse('detail_section','detail', True);
				$detail = True ;
				break ;
			case "select" :
				$defval = $row[defval] ;
				$sl = str_replace("'$defval'","'$defval' selected",$row[selectlist]) ;
				$t->set_var('selectlist',$sl);
				$t->parse('select_section','select', True);
				$select = True ;
				break ;
			endswitch ;
		}
	if (!$detail)	$t->set_var('detail_section','');
	if (!$select)	$t->set_var('select_section','');
	$t->parse('out','report',True);

	$getstr = $ckapi[filter][getstr] ;
	if (is_array($ckapi[filter][actlist]) and $actnum=="")	$next="${tran}filter.php"; else $next="${tran}filter_validate.php";
	$t->set_var('search_action',exapi_link("/$app/$next",$getstr)) ;
	if ($doneexit)	$t->set_var('add_action',exapi_link("/$app/$doneexit")) ;
		else	$t->set_var('add_action',exapi_link("/$app/${tran}add.php")) ;
	$t->pparse('out','report',True);
	}

//---- Process Filter Validate

    function process1_filter_validate() {
	global $ckapi,$exapi ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	foreach ($ckapi[sql_filter] as $key => $val)	if (!is_numeric($key))	$$key = ($_GET[$key]) ? $_GET[$key] : $_POST[$key] ;
	
	$err="" ;  $error=exapi_lang("Error") ;  $markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
	foreach ($ckapi[sql_filter] as $key => $val) {
		if ($$key=="")					continue ;
		if ($ckapi[sql_filter][$key][type]=='string') {
			if (strlen($$key)>15)			$err="[".$$key."]".exapi_lang("Search string too long") ;
			if (substr_count($$key,$markpri)>0)	
				$err="[".$$key."]".exapi_lang("Search string contains reserved pattern")." - $markpri";
			if (substr_count($$key,$marksec)>0)	
				$err="[".$$key."]".exapi_lang("Search string contains reserved pattern")." - $marksec";
			if (substr_count($$key," ")>0)	
				$err="[".$$key."]".exapi_lang("Search string should not contain space(s)");
			}
		if ($ckapi[sql_filter][$key][type]=='date') {
			$temp = input2date($$key) ;
			if ($temp=="")				$err="[".$$key."]".exapi_lang("Invalid date"); else $$key = $temp ;
			}
		if ($ckapi[sql_filter][$key][type]=='numeric') {
			if (!is_numeric($$key))			$err="[".$$key."] - ".exapi_lang("not a number");
			}
		}

	$tranobj = newobj($app,$class) ;
	$func = $class."_filter_validate" ;
	if (method_exists($tranobj,$func)) {
		$reterr = $tranobj->$func();
		if ($reterr<>"")				$err = $reterr ;
		}
	if ($err)						$err = "$error:  $err" ;

	if (!$err) {
		foreach ($ckapi[sql_filter] as $key => $val) {
			if ($val[char]=="1") {
				if ($$key<>"ALL")				$filter.=$markpri.$val[char].$val[str1].$marksec.$$key;
				continue ;
				}
			if ($val[char]=="7") {
				if ($$key=="yes")				$filter.= $markpri.$val[char] ;
				continue ;
				}
			if ($val[char]=="8") {
				if ($$key=="yes")				$filter.= $markpri.$val[char].$val[str1] ;
				continue ;
				}
			if (is_numeric($key) or $$key) {
										$filter.= $markpri.$val[char].$val[str1] ;
				if (substr_count("2,3,4,5,6",$val[char])>0)	$filter.= $marksec.$$key ;
				}
			}
		$filter = urlencode($filter) ;
		Header('Location: '.exapi_link("/$app/${tran}list.php","filter=$filter"));
		exit();
		}
	  else	{
		foreach ($ckapi[sql_filter] as $key => $val)	if (!is_numeric($key))	$getstr.= "$key=".$$key."&";
		$getstr.= "err=$err" ;
		Header('Location: '.exapi_link("/$app/${tran}filter.php",$getstr)) ;
		exit();
		}
	}

//---- Process List

    function process1_list() {
	global $ckapi,$exapi,$exapidir,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$filter = urldecode(stripslashes($filter)) ;
	$where = $this->decode_where($filter) ;
	$filter = urlencode($filter) ;

	$tranobj = newobj($app,$class) ;
	$t = exapi_tpl($app);
	$ckapi[objects][template] = &$t ;
	$t->set_file(array('report'=>"${tran}list.tpl", 'detail'=>"${tran}list.tpl"));
	$t->set_block('detail','detail_row','detail_section');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;
	$t->set_var('lang_sorthead',exapi_lang('[click column heading to re-sort table]'));

	$script = "/$app/${tran}list.php" ;
	foreach ($ckapi[columns] as $key => $value)	{$field1=$key; break;}
	$getstr = "id=$id&filter=$filter" ;
	foreach ($ckapi[columns] as $key => $value)
		$t->set_var("sort_${key}",$this->sortlink($value,$script,$key,$sort,$getstr));

	if (!$order)	{if ($sortkey<>"")	$order=$sortkey;	else $order=$field1;}
	if (!$sort)	$sort = "ASC" ;
	$func = $class."_list_sql" ;
	if (method_exists($tranobj,$func)) {
		$ckapi[params_sql] = array('where'=>$where, 'order'=>$order, 'sort'=>$sort, 'getstr'=>$getstr) ;
	 	$sql=$tranobj->$func();
		}
	  else	{
		$func = $tran."_list_sql" ;
		if (method_exists($tranobj,$func)) {
			$ckapi[params_sql] = array('where'=>$where, 'order'=>$order, 'sort'=>$sort) ;
	 		$sql=$tranobj->$func();
			}
		  else	$sql = "SELECT * from $table WHERE $where order by $order $sort" ;
		}
	$result= $adodb->query($sql);
	if (exapi_dbrc($result)==0) {
		foreach ($ckapi[columns] as $key => $value)	$t->set_var($key,"") ;
		$t->set_var("$field1",exapi_lang("No Matching Item Found")) ;
		$return = exapi_link("/$app/${tran}filter.php") ;
		foreach ($ckapi[links] as $key => $value)	$t->set_var($key,$return);
		$t->set_var('log',$return) ;
		foreach ($ckapi[lang_links] as $key => $value)	$t->set_var($key,$value);
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail_row',True);
		}
	while ($dt = $result->fetchRow()) {
		$id = $dt['id'] ;
		$getstr = "id=$id&filter=$filter" ;
		$loggetstr = "return=/$app/${tran}list.php&$getstr" ;
		foreach ($ckapi[columns] as $key => $value)	$t->set_var($key,$dt[$key]) ;
		if (is_array($ckapi[links]))
			foreach ($ckapi[links] as $key => $value)	$t->set_var($key,exapi_link($value,$getstr));
		foreach ($ckapi[lang_links] as $key => $value)	$t->set_var($key,$value);
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$func = $class."_list_adjust" ;
		if (method_exists($tranobj,$func)) {
			$ckapi[params_list] = array('dt'=>$dt, 'filter'=>$filter) ;
		 	$tranobj->$func();
			}
		  else	{
			$func = $tran."_list_adjust" ;
			if (method_exists($tranobj,$func)) {
				$ckapi[params_list] = array('dt'=>$dt, 'filter'=>$filter) ;
			 	$tranobj->$func();
				}
			}
		$t->set_var('log',exapi_link('/ck-admin/loglist.php',$loggetstr)) ;
		$t->parse('detail_section','detail_row',true);
		if (method_exists($tranobj,$func))	foreach ($ckapi[lang_links] as $key => $value)	$t->set_var($key,$value);
		}
	if ($doneexit<>"")	$t->set_var('add_action',exapi_link("/$app/$doneexit",$getstr));
		else		$t->set_var('add_action',exapi_link("/$app/${tran}add.php",$getstr));
	$t->pparse('out','detail','report');
	}

//---- Process View

    function process1_view() {
	global $ckapi,$exapi,$exapidir ;


//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$return = ($_GET["return"]) ? $_GET["return"] : $_POST["return"] ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=stripslashes($filter);

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$tranobj = newobj($app,$class) ;
	$t = exapi_tpl($app);
	$t->set_file(array('view'=>"${tran}screen.tpl", 'report'=>"${tran}screen.tpl"));
	$t->set_block('report','detail','detail_section');
	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','');

	$ckapi[params_post][id] = $id ;
	$ckapi[params_post][posted] = True ;
	$func = $class."_read" ;
	if (method_exists($tranobj,$func))	$ckapi[params_post][dt] = $tranobj->$func() ;
		else	{
			$func = $tran."_read" ;
			if (method_exists($tranobj,$func))	$ckapi[params_post][dt] = $tranobj->$func() ;
			}
	$ckapi[objects][template] = &$t ;
	$func = $class."_write" ;		if (method_exists($tranobj,$func))	$tranobj->$func();
	$func = $class."_header_write" ;	if (method_exists($tranobj,$func))	$tranobj->$func();
	$func = $class."_detail_write" ;	if (method_exists($tranobj,$func))	$tranobj->$func();

	$return = ($return<>"") ? $return : "/$app/${tran}list.php" ;
	$getstr = "filter=$filter&return=$return" ;
	$t->set_var('action',exapi_link($return,$getstr)) ;
	foreach ($ckapi[buttons] as $key => $val)	$t->set_var("lang_$key",exapi_lang('Done'));
	$t->set_var('done_action',exapi_link($return,$getstr)) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report', True );
	}

//---- Process Add

    function process1_add() {
	global $ckapi,$exapi,$exapidir ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $val)	$ckapi[buttons][$key] = ($_GET[$key]) ? $_GET[$key] : $_POST[$key] ;
//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=stripslashes($filter);

	$tranobj = newobj($app,$class) ;
	$t = exapi_tpl($app);
	$t->set_file(array('view'=>"${tran}screen.tpl", 'report'=>"${tran}screen.tpl"));
	$t->set_block('report','detail','detail_section');
	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;
	$t->set_var('readonly','');
	$t->set_var('disabled','');

	$ckapi[params_post][dt] = $_POST ;
	$ckapi[params_post][firstime] = True ;
	foreach ($ckapi[buttons] as $key => $val)	if ($val<>"")	$ckapi[params_post][firstime]=False;
	$firstime = $ckapi[params_post][firstime] ;
	if ($ckapi[params_post][firstime]) {
		$func = $class."_add_init" ;
		if (method_exists($tranobj,$func))	$tranobj->$func();
		}
	$ckapi[objects][template] = &$t ;
	$func = $class."_write";		if (method_exists($tranobj,$func))	$tranobj->$func();
	$func = $class."_header_write" ;	if (method_exists($tranobj,$func))	$tranobj->$func() ;
	$func = $class."_transform" ;		if (method_exists($tranobj,$func))	$tranobj->$func() ;
	$func = $class."_detail_write" ;	if (method_exists($tranobj,$func))	$tranobj->$func();

	if ($ckapi[buttons]['post']<>"") {
		$func = $class."_validate" ;	if (method_exists($tranobj,$func)) 	$err = $tranobj->$func() ;
		$t->set_var('message',$err) ;
		if ($err=='') {
			$ckapi[objects][tranobj] = &$tranobj ;
			$this->process1_post();
			$posted = True ;
			}
		}

	$getstr = "filter=$filter" ;
	if ($doneexit<>"")	$return = $doneexit ;
		else		$return = ($filter=="") ? "${tran}filter.php" : "${tran}list.php" ;
	if ($posted) {
		$t->set_var('action',exapi_link("/$app/$return",$getstr));
		foreach ($ckapi[buttons] as $key => $val)	$t->set_var("lang_$key",exapi_lang('Done'));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$script = $ckapi[params_post][script] ;
		$t->set_var('action',exapi_link("/$app/$script.php",$getstr)) ;
		foreach ($ckapi[buttons] as $key => $val)
			if (isset($ckapi[phrases]["lang_$key"]))	$t->set_var("lang_$key",$ckapi[phrases]["lang_$key"]);
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',exapi_link("/$app/$return",$getstr));
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report',True);
	}

//---- Process Copy

    function process1_copy() {
	global $ckapi,$exapi,$exapidir ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $val)	$ckapi[buttons][$key] = ($_GET[$key]) ? $_GET[$key] : $_POST[$key] ;
//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=stripslashes($filter);

	$tranobj = newobj($app,$class) ;
	$t = exapi_tpl($app);
	$t->set_file(array('view'=>"${tran}screen.tpl", 'report'=>"${tran}screen.tpl"));
	$t->set_block('report','detail','detail_section');
	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;
	$t->set_var('readonly','');
	$t->set_var('disabled','');

	$ckapi[params_post][firstime] = True ;
	foreach ($ckapi[buttons] as $key => $val)	if ($val<>"")	$ckapi[params_post][firstime]=False;
	if ($ckapi[params_post][firstime]) {
		$ckapi[params_post][id] = $id ;
		$func = $class."_read" ;
		if (method_exists($tranobj,$func))	$_POST=$tranobj->$func();
			else	{
				$func = $tran."_read" ;
				if (method_exists($tranobj,$func))	$_POST=$tranobj->$func();
				}
		$_POST['id']="";
		}
	$ckapi[objects][template] = &$t ;
	$ckapi[params_post][dt] = $_POST ;
	$func = $class."_write";		if (method_exists($tranobj,$func))	$tranobj->$func();
	$func = $class."_header_write" ;	if (method_exists($tranobj,$func))	$tranobj->$func() ;
	$func = $class."_transform" ;		if (method_exists($tranobj,$func))	$tranobj->$func() ;
	$func = $class."_detail_write" ;	if (method_exists($tranobj,$func))	$tranobj->$func();

	if ($ckapi[buttons]['post']<>"") {
		$func = $class."_validate" ;	if (method_exists($tranobj,$func)) 	$err = $tranobj->$func() ;
		$t->set_var('message',$err) ;
		if ($err=='') {
			$ckapi[objects][tranobj] = &$tranobj ;
			$this->process1_post();
			$posted = True ;
			}
		}

	$getstr = "filter=$filter" ;
	$return = ($doneexit<>"") ? $doneexit : "${tran}list.php" ;
	if ($posted) {
		$t->set_var('action',exapi_link("/$app/$return",$getstr));
		foreach ($ckapi[buttons] as $key => $val)  $t->set_var("lang_$key",exapi_lang('Done'));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$script = $ckapi[params_post][script] ;
		$t->set_var('action',exapi_link("/$app/$script.php",$getstr)) ;
		foreach ($ckapi[buttons] as $key => $val)
			if (isset($ckapi[phrases]["lang_$key"]))	$t->set_var("lang_$key",$ckapi[phrases]["lang_$key"]);
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',exapi_link("/$app/$return",$getstr));
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report',True);
	}

//---- Process Edit

    function process1_edit() {
	global $ckapi,$exapi,$exapidir ;

	foreach ($ckapi[buttons] as $key => $val)	$ckapi[buttons][$key] = ($_GET[$key]) ? $_GET[$key] : $_POST[$key] ;
//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$return = ($_GET["return"]) ? $_GET["return"] : $_POST["return"] ;
	$filter=stripslashes($filter);
	foreach ($ckapi[params] as $key => $value)	$$key = $value ;	/* This line must lie below the return line */

	$tranobj = newobj($app,$class) ;
	$t = exapi_tpl($app);
	$t->set_file(array('view'=>"${tran}screen.tpl", 'report'=>"${tran}screen.tpl"));
	$t->set_block('report','detail','detail_section');
	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;
	$t->set_var('readonly','');
	$t->set_var('disabled','');

	$ckapi[params_post][firstime] = True ;
	foreach ($ckapi[buttons] as $key => $val)	if ($val<>"")	$ckapi[params_post][firstime]=False ;
	if ($ckapi[params_post][firstime] or $ckapi[buttons][reload]<>"") {
		$ckapi[params_post][id] = $id ;
		$func = $class."_read" ;
		if (method_exists($tranobj,$func))	$_POST = $tranobj->$func() ;
			else	{
				$func = $tran."_read" ;
				if (method_exists($tranobj,$func))	$_POST = $tranobj->$func() ;
				}
		}
	$ckapi[objects][template] = &$t ;
	$ckapi[params_post][dt] = $_POST ;
	$func = $class."_write" ;
	$func = $class."_write";		if (method_exists($tranobj,$func))	$tranobj->$func() ;
	$func = $class."_header_write" ;	if (method_exists($tranobj,$func))	$tranobj->$func() ;
	$func = $class."_transform" ;		if (method_exists($tranobj,$func))	$tranobj->$func() ;
	$func = $class."_detail_write" ;	if (method_exists($tranobj,$func))	$tranobj->$func() ;

	if ($ckapi[buttons]['post']<>"") {
		$func = $class."_validate" ;	if (method_exists($tranobj,$func)) 	$err = $tranobj->$func() ;
		$t->set_var('message',$err) ;
		if ($err=='') {
			$ckapi[objects][tranobj] = &$tranobj ;
			$err = $this->process1_post();
			if ($err<>"")	$t->set_var('message',$err) ;
				else	$posted = True ;
			}
		}

	$return = ($return<>"") ? $return : "/$app/${tran}list.php" ;
	$getstr = "filter=$filter&return=$return" ;
	if ($posted) {
		$t->set_var('action',exapi_link($return,$getstr));
		foreach ($ckapi[buttons] as $key => $val)	$t->set_var("lang_$key",exapi_lang('Done'));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$script = $ckapi[params_post][script] ;
		$t->set_var('action',exapi_link("/$app/$script.php",$getstr));
		foreach ($ckapi[buttons] as $key => $val)
			if (isset($ckapi[phrases]["lang_$key"]))
				$t->set_var("lang_$key",$ckapi[phrases]["lang_$key"]);
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',exapi_link($return,$getstr));
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report',True);
	}

//---- Process Delete

    function process1_delete() {
	global $ckapi,$exapi,$exapidir ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[phrases] as $key => $value)	$$key = $value ;
//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$control = ($_GET["control"]) ? $_GET["control"] : $_POST["control"] ;
	$yes = ($_GET["yes"]) ? $_GET["yes"] : $_POST["yes"] ;
	$filter=stripslashes($filter);

	$tranobj = newobj($app,$class) ;
	$t = exapi_tpl($app);
	$t->set_file('question','confirm.tpl');
	$t->set_file('report',"${tran}screen.tpl") ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_confirm',exapi_lang('Are you sure you want to delete ?'));
	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;
	$t->set_var('msg','') ;
	$t->set_var('message','');
	$t->set_var('readonly',"readonly");
	$t->set_var('disabled',"disabled");

	$ckapi[params_post][id] = $id ;
	$ckapi[params_post][posted] = True ;
	$func = $class."_read" ;
	if (method_exists($tranobj,$func))	$ckapi[params_post][dt] = $tranobj->$func() ;
		else	{
			$func = $tran."_read" ;
			if (method_exists($tranobj,$func))	$ckapi[params_post][dt] = $tranobj->$func() ;
			}
	$ckapi[objects][template] = &$t ;
	$func = $class."_write" ;		if (method_exists($tranobj,$func))	$tranobj->$func();
	$func = $class."_header_write" ;	if (method_exists($tranobj,$func))	$tranobj->$func() ;
	$func = $class."_detail_write" ;	if (method_exists($tranobj,$func))	$tranobj->$func();

	if (!isset($yes)) 	$control = $ckapi[params_post][dt]['control'] ;
	  else	{
		$ckapi[params_post][dt][id] = $id ;
		$ckapi[params_post][dt][control] = $control ;
		$err = $this->delete_validate() ;
		if ($err=="")	if (method_exists($tranobj,"delete_validate"))	$err=$tranobj->delete_validate();
		if ($err<>'')	{unset($yes);	$t->set_var('lang_title',"$lang_title => $err");}
		}
	$getstr="filter=$filter&control=$control";
	$return = ($return<>"") ? $return : "/$app/${tran}list.php" ;
	if (isset($ckapi[params][getstr]))		$getstr.= "&".$ckapi[params][getstr] ;
	if (!isset($yes)) {
		$t->set_var('lang_yes',exapi_lang('Yes'));
		$t->set_var('lang_no',exapi_lang('No'));
		$script = $ckapi[params_post][script] ;
		$getstr .= "&id=$id" ;
		$t->set_var('yes_action', exapi_link("/$app/$script.php",$getstr));
		$t->set_var('no_action',exapi_link($return,$getstr)) ;
		$t->pparse('out','question',True);
		}
	   else {
		$ckapi[objects][tranobj] = &$tranobj ;
		$err = $this->process1_post();
		$t->set_var('lang_yes',exapi_lang('done'));
		$t->set_var('lang_no',exapi_lang('done'));
		$t->set_var('yes_action',exapi_link($return,$getstr)) ;
		$t->set_var('no_action',exapi_link($return,$getstr)) ;
		$t->pparse('out','question',True);
		if ($err<>'')	$t->set_var('lang_title',"$lang_title => $err");
		}

	$getstr = "filter=$filter" ;
	$t->set_var('action',exapi_link($return,$getstr));
	foreach ($ckapi[buttons] as $key => $val)	$t->set_var("lang_$key",exapi_lang('Done'));
	$t->set_var('done_action',exapi_link($return,$getstr));
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report',True);
	}

//---- Process Post (posting data to db table)

    function process1_post() {
	global $ckapi,$exapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	foreach ($ckapi[phrases] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$op = &$ckapi[params_post][op] ;
	$t = &$ckapi[objects][template] ;
	$tranobj = &$ckapi[objects][tranobj] ;

	$db_type = $ckapi[hostsys][dbtype] ;
	if ($op=="copy" or $op=="add")	$op=$ckapi[params_post][op]="new" ;
	$id = ($dt[id]=="") ? 0 : $dt[id] ;
	$ip = ($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'] ;
	$user = $ckapi[hostsys][username];
	$now = mktime() ;
	$iptime = "$ip=$now=$script=$id" ;
	$func = $class."_post_init" ;
	if (method_exists($tranobj,$func))	$tranobj->$func();

	if ($op<>"new") {
		$err=""; $error=exapi_lang('Error') ;
		$lang_deleted = exapi_lang("was deleted while your request was processed") ;
		$lang_modified= exapi_lang("was modified while your request was processed") ;
		$lang_restart = exapi_lang("Please exit current screen and restart action if necessary");
		$result = $adodb->query("SELECT control FROM $table WHERE id = '$id'");
		if (exapi_dbrc($result)==0)
			$err = "<b>$error: $lang_tran [id#$id]: $lang_deleted.  $lang_restart.</b>";
		if ($dt[control] < exapi_dbflds($result,'control'))
			$err ="<b>$error: $lang_tran [id#$id]: $lang_modified.  $lang_restart.</b>";
		if ($err)	return $err ;
		$control = $dt[control] + 1 ;
		}

	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$adodb->query($sql);
	$sql = "INSERT INTO ${pre}log (trans_id,app,script,ip,userid,op,timestamp,iptime) " ;
	$sql.= "VALUES ('$id','$app','$script','$ip','$user','$op','$now','$iptime')" ;
	$adodb->query($sql);
	$result= $adodb->query("SELECT max(id) as id from ${pre}log WHERE iptime='$iptime'");
	$logid = exapi_dbflds($result,'id');

	switch ($op) :
		case "new" :
			$id = $logid ;
			foreach ($ckapi[tables]["parents"] as $key => $val) {
				$sql = "SELECT a.attname as Field, format_type(a.atttypid,a.atttypmod) " ;
				$sql.= "FROM pg_class c,pg_attribute a ";
				$sql.= "WHERE c.relname='$key' and a.attnum>0 and a.attrelid=c.oid";
				if ($db_type=="mysql")		$sql = "describe $key" ;
				$result= $adodb->query($sql);
				$fields = $values = "" ;
				While ($rs = $result->fetchRow()) {
					$fldname = (isset($rs[Field])) ? $rs[Field] : $rs[field] ;
					$value = addslashes($dt[$fldname]) ;
					if ($fldname<>'control' and $fldname<>'id' and $value<>''){
						$fields.="$fldname," ;
						$values.="'$value'," ;
						}
					}
				$adodb->query("INSERT INTO $key ($fields id) VALUES ($values '$id')");
				}
			$ckapi[params_post][id] = $id ;
			$ckapi[params_post][logid] = $logid ;
			$this->update_log_header() ;
			$type = exapi_lang("New") ;
			$actioned = exapi_lang("added") ;
			break ;
		case "edit" :
			foreach ($ckapi[tables]["parents"] as $key => $val) {
				$fields = "" ;
				if ($val<>"skipskip") {
					$sql = "SELECT a.attname as Field, format_type(a.atttypid,a.atttypmod) " ;
					$sql.= "FROM pg_class c,pg_attribute a ";
					$sql.= "WHERE c.relname='$key' and a.attnum>0 and a.attrelid=c.oid";
					if ($db_type=="mysql")		$sql = "describe $key" ;
					$result = $adodb->query($sql);
					While ($rs = $result->fetchRow()) {
						$fldname = (isset($rs[Field])) ? $rs[Field] : $rs[field] ;
						if ($fldname<>'control' and isset($dt["$fldname"])) {
							$value = addslashes($dt[$fldname]) ;
							$fields.="$fldname='$value'," ;
							}
						}
					}
				$adodb->query("UPDATE $key SET $fields control='$control' WHERE id ='$id'");
				}
			$ckapi[params_post][id] = $id ;
			$ckapi[params_post][logid] = $logid ;
			$this->update_log_header() ;
			$this->update_log_header() ;
			if (substr_count($script,'edit')>0)	{
				$type = exapi_lang("Old") ;
				$actioned = exapi_lang("updated") ;
				}
			  else	{
				$type = exapi_lang("New") ;
				$actioned = exapi_lang("added") ;
				}
			break ;
		case "delete" :
			$ckapi[params_post][id] = $id ;
			$ckapi[params_post][logid] = $logid ;
			if ($ckapi[tables]["parents"])	$this->update_log_header() ;
			if ($ckapi[tables]["children"]) $this->update_log_detail() ;
			if ($ckapi[tables]["parents"]) 
				foreach ($ckapi[tables]["parents"] as $key => $val)
					if ($val<>'skipskip')
						$adodb->query("DELETE from $key where id = '$id'");
			$type = exapi_lang("Old") ;
			$actioned = exapi_lang("deleted") ;
			break ;
		case "clear" :
			$ckapi[params_post][id] = $id ;
			$ckapi[params_post][logid] = $logid ;
			if ($ckapi[tables]["parents"])	$this->update_log_header() ;
			if ($ckapi[tables]["children"]) $this->update_log_detail() ;
			if ($ckapi[tables]["parents"])
				foreach ($ckapi[tables]["parents"] as $key => $val)
					if ($val<>'skipskip')
						$adodb->query("DELETE from $key where id = '$id'");
			$type = exapi_lang("Old") ;
			$actioned = exapi_lang("cleared") ;
			break ;
		endswitch ;

	$func = $class."_post_precommit" ;
	if (method_exists($tranobj,$func)) {$ckapi[params_post][dt]=$dt; $tranobj->$func();}
	  else	{
		$func = $tran."_post_precommit" ;
		if (method_exists($tranobj,$func)) {$ckapi[params_post][dt]=$dt; $tranobj->$func();}
		}
	if ($op<>'delete' and $op<>'clear')	$this->update_log_detail() ;

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$adodb->query($sql);
	$func = $class."_post_postcommit" ;
	if (method_exists($tranobj,$func)) {
		$ckapi[phrases]["actioned"]=$actioned;
		$tranobj->$func();
		}
	$reminder = $ckapi[phrases]["reminder"] ;
	$ckapi[phrases]["message"] = $message = "$type $lang_tran [id#$id] $actioned" ; 
	$t->set_var("message","<b>$message.  $reminder.</b>");
	$t->set_var('lang_confirm',"<b>$message.</b>");
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	return $err ;
	}

//---- Update Log Header

    function update_log_header() {
	global $ckapi,$exapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	foreach ($ckapi[tables]["parents"] as $key => $val) {
		$result= $adodb->query("SELECT * FROM $key WHERE id = '$id'");
		if (exapi_dbrc($result)>0)	$headerarr[$key] = $result->fetchRow() ;
		}
	$header = addslashes(serialize($headerarr));
	$fields = "header='$header'" ;
	if ($op=="new")	$fields="trans_id=id,$fields" ;
	$adodb->query("UPDATE ${pre}log SET $fields WHERE id='$logid'");
	}

//---- Update Log Detail

    function update_log_detail() {
	global $ckapi,$exapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	if ($ckapi[tables]["children"]<>"") {
		foreach ($ckapi[tables]["children"] as $key => $val) {
			$result = $adodb->query("SELECT * FROM $key WHERE $val = '$id'");
			For ($i=1;$detailarr[$key][$i]=$result->fetchRow(); $i++)	;
			}
		if ($detailarr)	$detail = addslashes(serialize($detailarr));
		$adodb->query("UPDATE ${pre}log SET detail='$detail' WHERE id='$logid'");
		}
	}

//---- Standard Delete Validation Checks

    function delete_validate() {
	global $ckapi,$exapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$table = $ckapi[params][table] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	$errmsg1 = exapi_lang("This item is in use within an existing") ;
	$journal = exapi_lang("journal") ;
	$id = $dt[id] ;
	$result = $adodb->query("SELECT attrib1tbl,attrib2tbl,attrib3tbl from ${pre}defaults");
	$a1tbl = exapi_dbflds($result,'attrib1tbl') ;
	$a2tbl = exapi_dbflds($result,'attrib2tbl') ;
	$a3tbl = exapi_dbflds($result,'attrib3tbl') ;
	if ($a1tbl == $table) {
		$result = $adodb->query("SELECT * from ${pre}acc_trans WHERE attrib1='$id'");
		if (exapi_dbrc($result)>0)
			$err = "$errmsg1 $journal id#".exapi_dbflds($result,'trans_id') ;
		}
	if ($a2tbl == $table) {
		$result = $adodb->query("SELECT * from ${pre}acc_trans WHERE attrib2='$id'");
		if (exapi_dbrc($result)>0)
			$err = "$errmsg1 $journal id#".exapi_dbflds($result,'trans_id') ;
		}
	if ($a3tbl == $table) {
		$result = $adodb->query("SELECT * from ${pre}acc_trans WHERE attrib3='$id'");
		if (exapi_dbrc($result)>0)
			$err = "$errmsg1 $journal id#".exapi_dbflds($result,'trans_id') ;
		}
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Decode 'where' filter string

    function decode_where($filter) {
	global $ckapi,$exapi ;

	if (trim($filter)<>"") {
		$markpri = $ckapi['params']['markpri'] ;
		$marksec = $ckapi['params']['marksec'] ;
		$markpri = "zzAnDzz" ;
		$marksec = "z2z1z3z" ;
		$pieces = explode($markpri,$filter) ;
		foreach ($pieces as $piece) {
			list($str1,$str2) = explode($marksec,$piece) ;
			$type = substr($str1,0,1) ;
			$str1 = substr($str1,1) ;
			if (strlen($str1)>15 or strlen($str2)>15) {
				echo "Please inform System Admin: Possible (type 1) injected SQL attack -$piece==<br>";
				exit() ;
				}
			if (substr_count($piece," ")>0) {
				echo "Please inform System Admin: Possible (type 2) injected SQL attack -$piece==<br>";
				exit() ;
				}
			switch ($type) :
				case "0" :	$where .= "$str1 $str2" ;		break ;
				case "1" :	$where .= " AND $str1 = '$str2' " ;	break ;
				case "2" :	$where .= " AND $str1 >= '$str2' ";	break ;
				case "3" :	$where .= " AND $str1 > '$str2' ";	break ;
				case "4" :	$where .= " AND $str1 <= '$str2' ";	break ;
				case "5" :	$where .= " AND $str1 < '$str2' ";	break ;
				case "6" :	$where .= " AND lower($str1) like lower('%$str2%') ";  break;
				case "7" :	$where .= " AND OPEN " ;		break ;
				case "8" :	$where .= " AND $str1" ;		break ;
				case "9" :	$where .= " AND position($str1 in $str2)>0" ;		break ;
				endswitch ;
			}
		}
	return $where ;
	}

//---- Generate sort link string

    function sortlink($title,$script,$order,$sort,$getstr='') {
	global $exapi ;

	$sort = ($sort=='ASC') ? 'DESC' : 'ASC' ;
	$getstr = ($getstr<>'') ? "order=$order&sort=$sort&$getstr" : "order=$order&sort=$sort" ;
	$linkage = exapi_link($script,$getstr) ;
	$link = "<a href='$linkage'>$title</a>";
	return $link ;
	}

    }

?>
