<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.process3.inc.php 0.15.1 2005/09/30 C K Wu

    class process3 {

//---- Process acctran

    function process3_acctran() {
	global $ckapi,$exapi,$exapidir,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $val)
		$ckapi[buttons][$key] = $$key = ($_GET[$key]) ? $_GET[$key] : $_POST[$key] ;
	$dt = &$ckapi[params_post][dt] ;

	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=stripslashes($filter);

	$tranobj = newobj($app,$class) ;
	$t = exapi_tpl('ck-api');
	$t->set_file('report','acctranscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;
	$t->set_var('readonly','');
	$t->set_var('disabled','');

	/*------------- Write Journal to Screen Display ----------------------------*/
	$ckapi[params_post][id] = $id ;
	$ckapi[params_post][firstime] = True ;
	foreach ($ckapi[buttons] as $key => $val)	if ($val<>"")	$ckapi[params_post][firstime]=False;
	if ($ckapi[params_post][firstime])		$dt = $this->acctran_read() ;
		else					$dt = $_POST ;

	if (isset($reload))	{
		$temp = array(	'transdate'	=>	$dt[transdate] ,
				'source'	=>	$dt[source] ,
				'total'		=>	$dt[total] ,
				'description'	=>	$dt[description] ,
				'id'		=>	$dt[id] ,
				'control'	=>	$dt[control]		) ;
		$func="${class}_reload";
		$dt=$tranobj->$func();
		foreach ($temp as $key => $val)		$dt[$key] = $val ;
		}
	if (isset($repl_all)) {
		For ($i=1;isset($dt['accno'.$i]);$i++) {
			$dt["attrib1$i"]	=	$dt['attrib1_cap'];
			$dt["attrib2$i"]	=	$dt['attrib2_cap'];
			$dt["attrib3$i"]	=	$dt['attrib3_cap'];
			}
		}
	if (isset($repl_nonbs)) {
		For ($i=1;isset($dt['accno'.$i]);$i++) {
			$accid = $dt['accno'.$i] ;
			$result = $adodb->query("SELECT category FROM ${pre}chart WHERE id='$accid'") ;
			$cat = exapi_dbflds($result,'category') ;
			if ($cat=="I" or $cat=="E") {
				$dt['attrib1'.$i]	=	$dt['attrib1_cap'] ;
				$dt['attrib2'.$i]	=	$dt['attrib2_cap'] ;
				$dt['attrib3'.$i]	=	$dt['attrib3_cap'] ;
				}
			}
		}
	$ckapi[objects][template] = &$t ;
	$ckapi[params_post][dt] = $dt ;
	$this->acctran_header_write() ;
	$func="${class}_accmask";	if (method_exists($tranobj,$func))	$tranobj->$func();
	$this->acctran_detail_write() ;

	$t->parse('out','report',True);

	/*-------------- Post Invoice Accounting Entries ----------------------------------------------*/
	if (isset($post)) {
		$err = $this->acctran_validate() ;
		$t->set_var('message',$err);
		if ($err=='') {
			$proc1 = newobj('ck-api','process1') ;
			$ckapi[params_post][op] = 'edit' ;
			$ckapi[objects][tranobj] = &$tranobj ;
			$err = $proc1->process1_post();
			$type = exapi_lang("Old") ;
			$actioned = exapi_lang("updated") ;
			$lang_tran = $ckapi[phrases][lang_tran] ;
			$msg = "<b>$type $lang_tran [id#$id] $actioned</b>" ;
			if ($err<>"")	$t->set_var('message',$err) ;
				else	{$t->set_var('message',$msg) ;  $posted = True ;}
			}
		}

	/*--------------------Write bottom Section------------------------------------------*/
	$getstr = "filter=$filter" ;
	$return = ($return<>"") ? $return : "/$app/${tran}list.php" ;
	if ($posted) {
		$t->set_var('action',exapi_link($return,$getstr));
		foreach ($ckapi[buttons] as $key => $val)	$t->set_var("lang_$key",exapi_lang("Done"));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$script = $ckapi[params_post][script] ;
		$t->set_var('action',exapi_link("/$app/$script.php","return=$return&$getstr")) ;
		foreach ($ckapi[buttons] as $key => $val)
			if (isset($ckapi[phrases]["lang_$key"]))
				$t->set_var("lang_$key",$ckapi[phrases]["lang_$key"]);
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',exapi_link($return,$getstr));
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report',True);
	}

//---- Acctran Read

    function acctran_read() {
	global $ckapi,$exapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$result = $adodb->query("SELECT * FROM ${pre}gl WHERE id='$id'");
	$dt = $result->fetchRow() ;
	$result = $adodb->query("SELECT sum(amount) as total FROM ${pre}acc_trans WHERE trans_id='$id' and amount>0");
	$dt[total] = exapi_dbflds($result,'total') ;

	$sql = "SELECT chart_id,amount,attrib1,attrib2,attrib3 FROM ${pre}acc_trans a,${pre}chart b ";
	$sql.= "WHERE trans_id='$id'and a.chart_id=b.id ORDER BY a.id" ;
	$result = $adodb->query($sql);
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['accno'.$i]		=	$rs['chart_id'] ;
		$dt['attrib1'.$i]	=	$rs['attrib1'] ;
		$dt['attrib2'.$i]	=	$rs['attrib2'] ;
		$dt['attrib3'.$i]	=	$rs['attrib3'] ;
		$cr			=	sprintf("%01.2f",$rs['amount']);
		$dr			=	sprintf("%01.2f",-$cr) ;
		if ($cr>0)	$dr='';		else $cr='';
		$dt['dr'.$i]		= 	$dr ;
		$dt['cr'.$i]		= 	$cr ;
		}
	return $dt ;
	}

//---- Acctran Validation Checks

    function acctran_validate() {
	global $ckapi,$exapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error") ;
	$date=input2date( $dt[transdate] ) ;
	if ($date=="")					$err=exapi_lang("Invalid Date");
	if ($dt["description"]=="")			$err=exapi_lang("Description Missing");
	$total_dr=''; $total_cr='';
	For ($i=1;isset($dt['accno'.$i]);$i++) {
		$dr			=	$dt['dr'.$i];
		$cr			=	$dt['cr'.$i];
		$total_dr		+=	$dr ;
		$total_cr		+=	$cr	;
		$row = exapi_lang("Row") ; $rowi = "[$row $i]" ;
		if (!ereg('^[0-9]*\\.?[0-9]{0,2}$',$dr) or $dr<0) $err=$rowi.exapi_lang("Invalid Dr");
		if (!ereg('^[0-9]*\\.?[0-9]{0,2}$',$cr) or $cr<0) $err=$rowi.exapi_lang("Invalid Cr");
		if ($dr==0 and $cr==0)	$err=$rowi.exapi_lang("Both Dr&Cr=0 (delete row if needed)");
		if ($dr>0 and $cr>0)	$err=$rowi.exapi_lang("Dr and Cr cannot both have value!");
		}
	if (sprintf("%01.2f",$total_dr)<>sprintf("%01.2f",$total_cr))	$err=exapi_lang("Total Dr <> Cr");
	if (sprintf("%01.2f",$total_cr)<>sprintf("%01.2f",$dt[total]))
			$err=exapi_lang("should not change Original total Dr/Cr amt of ").$dt[total];

	$result = $adodb->query("SELECT attrib1cnval,attrib2cnval,attrib3cnval FROM ${pre}defaults");
	if (exapi_dbflds($result,'attrib1cnval')=="yes") {
		$cnval = True ;
		$atval = $dt['attrib11'] ;
		For ($i=2;isset($dt['accno'.$i]);$i++)
			if ($dt['attrib1'.$i]<>$atval)	$cnval = False ;
		if (!$cnval)			$err = exapi_lang("Attrib1 value not constant") ;
		}
	if (exapi_dbflds($result,'attrib2cnval')=="yes") {
		$cnval = True ;
		$atval = $dt['attrib21'] ;
		For ($i=2;isset($dt['accno'.$i]);$i++)
			if ($dt['attrib2'.$i]<>$atval)	$cnval = False ;
		if (!$cnval)			$err = exapi_lang("Attrib2 value not constant") ;
		}
	if (exapi_dbflds($result,'attrib3cnval')=="yes") {
		$cnval = True ;
		$atval = $dt['attrib31'] ;
		For ($i=2;isset($dt['accno'.$i]);$i++)
			if ($dt['attrib3'.$i]<>$atval)	$cnval = False ;
		if (!$cnval)			$err = exapi_lang("Attrib3 value not constant") ;
		}

	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write Acctran Header to Screen

    function acctran_header_write() {
	global $ckapi,$exapi ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_date',exapi_lang('Date :'));
	$t->set_var('lang_source',exapi_lang('Source :'));
	$t->set_var('lang_description',exapi_lang('Description :'));
	$t->set_var('lang_id',exapi_lang('Audit ID').' :');
	$t->set_var('transdate',$dt[transdate]) ;
	$t->set_var('source',$dt[source]) ;
	$t->set_var('description',$dt[description]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('total',$dt[total]) ;
	$t->parse('out','report',True);
	}

//---- Write Acctran Detail to Screen

    function acctran_detail_write() {
	global $ckapi,$exapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$accmask = $ckapi[params_post][accmask] ;
	$dt = &$ckapi[params_post][dt] ;
	$id = &$ckapi[params_post][id] ;
	$t = &$ckapi[objects][template] ;
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

	$row_ = exapi_lang('Row')." " ;
	$result = $adodb->query("Select * from ${pre}defaults");
	$a1cap = exapi_dbflds($result,'attrib1cap') ;
	$a1tbl = exapi_dbflds($result,'attrib1tbl') ;
	$a1sdf = exapi_dbflds($result,'attrib1sdesc') ;
	$a2cap = exapi_dbflds($result,'attrib2cap') ;
	$a2tbl = exapi_dbflds($result,'attrib2tbl') ;
	$a2sdf = exapi_dbflds($result,'attrib2sdesc') ;
	$a3cap = exapi_dbflds($result,'attrib3cap') ;
	$a3tbl = exapi_dbflds($result,'attrib3tbl') ;
	$a3sdf = exapi_dbflds($result,'attrib3sdesc') ;
	$nullopt="<OPTION value=''></OPTION>";
	$a1slist = $nullopt.selectlist(str_replace($pre,'',$a1tbl),$a1sdf,'','','id',"substring($a1sdf,1,10)") ;
	$a2slist = $nullopt.selectlist(str_replace($pre,'',$a2tbl),$a2sdf,'','','id',"substring($a2sdf,1,10)") ;
	$a3slist = $nullopt.selectlist(str_replace($pre,'',$a3tbl),$a3sdf,'','','id',"substring($a3sdf,1,10)") ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('lang_insert',exapi_lang('Insert<br>before'));
	$t->set_var('lang_accno',exapi_lang('Account Number'));
	$t->set_var('lang_attrib1',exapi_lang("Attribute").":<br>$a1cap");
	$t->set_var('lang_attrib2',exapi_lang("Attribute").":<br>$a2cap");
	$t->set_var('lang_attrib3',exapi_lang("Attribute").":<br>$a3cap");
	$at1cap = $dt[attrib1_cap] ;
	$at2cap = $dt[attrib2_cap] ;
	$at3cap = $dt[attrib3_cap] ;
	$t->set_var('attrib1cap_selectlist',str_replace("'$at1cap'","'$at1cap'"." selected",$a1slist)) ;
	$t->set_var('attrib2cap_selectlist',str_replace("'$at2cap'","'$at2cap'"." selected",$a2slist)) ;
	$t->set_var('attrib3cap_selectlist',str_replace("'$at3cap'","'$at3cap'"." selected",$a3slist)) ;
	$t->set_var('lang_dr',exapi_lang('Debit'));
	$t->set_var('lang_cr',exapi_lang('Credit'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$total_dr = 0;
	$total_cr = 0;
	$acc_list = selectlist('chart','accno',"WHERE charttype='A'",'','id','accno','description') ;

	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['accno'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('accno_fld','accno'.$i) ;
			$t->set_var('attrib1_fld','attrib1'.$i) ;
			$t->set_var('attrib2_fld','attrib2'.$i) ;
			$t->set_var('attrib3_fld','attrib3'.$i) ;
			$t->set_var('dr_fld','dr'.$i);
			$t->set_var('cr_fld','cr'.$i);
			$t->set_var('account_selectlist',$acc_list);
			$t->set_var('attrib1_selectlist',$a1slist) ;
			$t->set_var('attrib2_selectlist',$a2slist) ;
			$t->set_var('attrib3_selectlist',$a3slist) ;
			$t->set_var('dr',"") ;
			$t->set_var('cr',"") ;
			$t->set_var('delrowno',$row_.$i) ;
			$t->set_var('linedisabled',"") ;
			$t->set_var('linereadonly',"") ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;
		$chart_id	=	$dt['accno'.$i] ;
		$attrib1	=	$dt['attrib1'.$i] ;
		$attrib2	=	$dt['attrib2'.$i] ;
		$attrib3	=	$dt['attrib3'.$i] ;
		$dr	=	$dt['dr'.$i] ;
		$cr	=	$dt['cr'.$i] ;
		$total_dr	+=	$dr ;
		$total_cr	+=	$cr ;
		$accno_fld	=	'accno'.$j ;
		$attrib1_fld	=	'attrib1'.$j ;
		$attrib2_fld	=	'attrib2'.$j ;
		$attrib3_fld	=	'attrib3'.$j ;
		$dr_fld		=	'dr'.$j ;
		$cr_fld		=	'cr'.$j ;
		$t->set_var('accno_fld',$accno_fld) ;
		$t->set_var('attrib1_fld',$attrib1_fld) ;
		$t->set_var('attrib2_fld',$attrib2_fld) ;
		$t->set_var('attrib3_fld',$attrib3_fld) ;
		$t->set_var('dr_fld',$dr_fld);
		$t->set_var('cr_fld',$cr_fld);
		$t->set_var('account_selectlist',str_replace("'$chart_id'","'$chart_id' selected",$acc_list));
		$t->set_var('attrib1_selectlist',str_replace("'$attrib1'","'$attrib1'"." selected",$a1slist));
		$t->set_var('attrib2_selectlist',str_replace("'$attrib2'","'$attrib2'"." selected",$a2slist));
		$t->set_var('attrib3_selectlist',str_replace("'$attrib3'","'$attrib3'"." selected",$a3slist));
		$t->set_var('dr',$dr) ;
		$t->set_var('cr',$cr) ;
		if ($posted)	$t->set_var('insrowno',"done") ; else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ; else	$t->set_var('delrowno',$row_.$j) ;
		$t->set_var('linedisabled',"") ;
		$t->set_var('linereadonly',"") ;
		if (substr_count($accmask,$chart_id)>0)	{
			$t->set_var('account_selectlist',selectlist('chart','accno',"WHERE id='$chart_id'",'','id','accno','description'));
			$t->set_var('linedisabled',"disabled") ;
			$t->set_var('linereadonly',"readonly") ;
			}
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==2 and $delrowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('accno_fld','accno'.$i) ;
		$t->set_var('attrib1_fld','attrib1'.$i) ;
		$t->set_var('attrib2_fld','attrib2'.$i) ;
		$t->set_var('attrib3_fld','attrib3'.$i) ;
		$t->set_var('dr_fld','dr'.$i);
		$t->set_var('cr_fld','cr'.$i);
		$t->set_var('account_selectlist',$acc_list);
		$t->set_var('attrib1_selectlist',$a1slist) ;
		$t->set_var('attrib2_selectlist',$a2slist) ;
		$t->set_var('attrib3_selectlist',$a3slist) ;
		$t->set_var('dr',"") ;
		$t->set_var('cr',"") ;
		$t->set_var('delrowno',$row_.$i) ;
		$t->set_var('linedisabled',"") ;
		$t->set_var('linereadonly',"") ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('lang_total',exapi_lang('Total'));
	$t->set_var('total_dr',sprintf("%01.2f",$total_dr)) ;
	$t->set_var('total_cr',sprintf("%01.2f",$total_cr)) ;

	$t->parse('out','report',True);
	}

//---- Display Index Page

    function process3_indexpage() {
	global $ckapi,$exapi,$exapidir ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;

	$t = exapi_tpl('ck-api');
	$t->set_file('report','index.tpl') ;
	$t->set_block('report','detail','detail_row');
	$t->set_block('report','ack','ack_row');
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

	$t->set_var('lang_caption',exapi_lang("Welcome to %1",$app_title));
	$t->set_var('lang_motto',exapi_lang("CK: Common Knowledge - to be shared and developed by all"));
	$t->set_var('lang_user_admin',exapi_lang('User/Administrator'));
	$t->set_var('lang_auditor',exapi_lang('Auditor'));
	$t->set_var('lang_developer',exapi_lang('Developer'));

$usera = exapi_lang("Irrespective of any assertion from any person or source, there are BUGS/ERRORS associated with this module.") ;
$userb = exapi_lang("You are using this module or any derivative of this module at your own risk.") ;
$ckapi[user][1] = "<b>$usera  $userb</b>" ;
$user2 = exapi_lang("Do not expect any help nor assistance on this module from anyone.") ;
$ckapi[user][2] = "<b>$user2</b>" ;
$ckapi[user][3] = "<b>".exapi_lang("You should report to relevant government authority once you have concrete evidence that fictitious entries are being put through the system or the system is being used for illegal purpose, e.g. money laundering.")."</b>" ;
$usera = exapi_lang("This module is intended to run atop Linux, Postgres/MySQL, Apache, PHP and a middle layer application framework.") ;
$userb = exapi_lang("For other similar platforms, it may work, but no guarantees.") ;
$ckapi[user][4]	= "<b>$usera  $userb</b>" ;
$usera = exapi_lang("This software is provided by the copyright holders and contributors 'AS IS'.") ;
$userb = exapi_lang("Any express or implied warranties, including, but not limited to, the implied warranties of merchantability and fitness for a particular purpose are disclaimed.") ;
$userc = exapi_lang("In no event shall the copyright owner or contributors be liable for any direct, indirect, incidental, special, exemplary, or consequential damages (including, but not limited to, procurement of substitute goods or services; loss of use, data, or profits; or business interruption) however caused.") ;
$userd = exapi_lang("Such damages, based on any theory of liability, whether in contract, strict liability, or tort (including negligence or otherwise) arising in any way out of the use of this software, even if advised of the possibility of such damage, are disclaimed.") ;
$ckapi[user][5]	= "$usera  $userb  $userc  $userd" ;
$usera = exapi_lang("This module is designed with simplicity in mind and no attempt is made to speed up execution.") ;
$userb = exapi_lang("Client display is best viewed at 1024x768 or above.");
$ckapi[user][6]	= "$usera  $userb" ;
$usera = exapi_lang("Since this module communicates via http, it is exposed to hacking attempts from inside/outside of the installation site.") ;
$userb = exapi_lang("It is recommended that the server for this module be disconnected physically from the network whenever possible, or putting the server and client on the same machine, so network connection is not necessary.") ;
$ckapi[user][7]  = "$usera  $userb" ;
$usera = exapi_lang("In general, transaction flow is as follows") ;
$userb = exapi_lang("click header menu choice") ;
$userc = exapi_lang("enter search parameters") ;
$userd = exapi_lang("click [start search]") ;
$usere = exapi_lang("list of selected transactions displayed") ;
$userf = exapi_lang("click view, edit, copy, delete links as appropriate to initiate the required action") ;
$ckapi[user][8]  = "$usera :<br><br>$userb<br>$userc; $userd<br>[$usere]<br>$userf" ;
$ckapi[user][9]  = exapi_lang("When emailing document/notifications, you need to ensure your DNS/SMTP environment is correctly setup and your return email address has been entered via Default Values in Administration.") ;
$ckapi[user][10] = exapi_lang("If you are reporting an error and/or bug, please try to recreate the symptoms using the standard test data, so other people can readily recreate the error to help in debugging.") ;

$auditora = exapi_lang("Major database items are assigned a system wide unique audit id.") ;
$auditorb = exapi_lang("Audit trail information (full post-insert, post-edit, pre-delete record image) are stored in the log table.") ;
$auditorc = exapi_lang("Special controls are also added to minimize SQL injection and cross-site scripting attacks.");
$ckapi[auditor][1]  = "<b>$auditora  $auditorb  $auditorc</b>" ;
$ckapi[auditor][2]  = $ckapi[user][2] ;
$ckapi[auditor][3]  = $ckapi[user][3] ;
$ckapi[auditor][4]  = exapi_lang("To ensure data integrity, it is important to print a copy of the audit control report before and after each audit.") ;
$auditora = exapi_lang("Access control is implemented via User/Group accessing features of the underlying application framework.") ;
$auditorb = exapi_lang("However, a user with direct access to the underlying database WILL CIRCUMVENT ALL SUCH CONTROLS.");
$auditorc = exapi_lang("In a PC environment, the existence of such a user must be assumed.") ;
$ckapi[auditor][5]  = "$auditora  $auditorb  $auditorc" ;
$auditora = exapi_lang("Because this module is written in PHP, you should check in detail the entire content of php.ini to ensure that all operating parameters and startup environment are safe and secure.") ;
$auditorb = exapi_lang("These parameters may also be modified by the host system or middle layer software during script execution.") ;
$ckapi[auditor][6] = "$auditora  $auditorb" ;
$ckapi[auditor][7] = exapi_lang("Duplicate entries are easy to create inadvertently via Copy/Modify or Posting twice, therefore, it is important to check for such entries, ie entries with all fields being the same, except for audit id.") ;
$auditora = exapi_lang("Because this module operates within a web environment, the usual vulnerability of a web application applies.") ;
$auditorb = exapi_lang("There are other areas of audit concern regarding the Operating System, middleware, development language, co-existing applications, etc, etc, etc.") ;
$ckapi[auditor][8] = "$auditora  $auditorb" ;

$developera=exapi_lang("If you re-distribute this module (modified or not), it is your moral obligation to display this index page exactly as it is or as translation into a different language without loss of meaning.");
$developerb = exapi_lang("Failure to do so is strong evidence that you intend to defraud users by concealing critical pitfalls and/or shortcomings of this module.") ;
$ckapi[developer][1] = "<b>$developera  $developerb</b>" ;
$developera = exapi_lang("Specifically, there is no development documentation.") ;
$developerb = exapi_lang("The best and most up-to-date reference is the running script.") ;
$ckapi[developer][2] = "<b>$user2  $developera  $developerb</b>" ;
$ckapi[developer][3] = $ckapi[user][3] ;
$ckapi[developer][4] = exapi_lang("This module is intended to be used by SMEs that cannot afford full-blown enterprise business software, therefore, I do not intent to implement any advanced feature beyond a basic vanila accounting system.") ;
$developera = exapi_lang("To follow the logic of this module, you must have basic accounting knowledge.") ;
$developerb = exapi_lang("Just ask how you would create the beginning account balances and/or reverse an accrual entry in a manual ledger environment.") ;
$developerc = exapi_lang("If you are not sure how these are done, pick up an accounting text and work your way through.");
$ckapi[developer][5]  = "$developera  $developerb  $developerc" ;
$developera = exapi_lang("For ease of system maintenance and error recovery, no index/sequence nor interim result/balance are stored.") ;
$developerb = exapi_lang("It follows that judicial addition of index/sequence should speed up execution quite a bit.") ;
$ckapi[developer][6]  = "$developera  $developerb" ;
$developera = exapi_lang("It is perfectly OK to house this module and other associated modules in the default database.");
$developerb = exapi_lang("However, If necessary, this modules may be housed in a distinct database (virtual domain) away from the other non-core application framework modules.") ;
$ckapi[developer][7]  = "$developera  $developerb" ;
$developera = exapi_lang("To study the system, follow the steps:") ;
$developerb = exapi_lang("Administration module -> Admin/Setup -> 1 - Install Test Environment -> Click [Start Action] -> Click [Start Action] again") ;
$developerc = exapi_lang("Check out the various features.") ;
$developerd = exapi_lang("If stuck, repeat the process.") ;
$ckapi[developer][8]  = "$developera<br><br>$developerb<br><br>$developerc  $developerd" ;
$developera	= exapi_lang("Each language / charset has its own set of test data.") ;
$developerb	= exapi_lang("Displaying test data using a charset different from the one through which the test data was created will cause processing errors.") ;
$ckapi[developer][9]  = "$developera  $developerb" ;

	For ($i=1;isset($ckapi[user][$i]);$i++) {
		$t->set_var('user',$ckapi[user][$i]);
		$t->set_var('auditor',$ckapi[auditor][$i]);
		$t->set_var('developer',$ckapi[developer][$i]);
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_row','detail',True);
		}

	$t->set_var('lang_ack',exapi_lang('ACKNOWLEDGEMENT'));
	$t->set_var('lang_date',exapi_lang('Date'));
	$t->set_var('lang_detail',exapi_lang('Detail / Background'));
	$t->set_var('lang_contributor',exapi_lang('Contributor'));

	$ckapi[dates][1] = exapi_lang("Pre-2004-07") ;
	$ckapi[dates][2] = (isset($ckapi[dates][2])) ? $ckapi[dates][2] :exapi_lang("2004-07") ;
	$ckapi[details][1] = exapi_lang("Predecessor of CK-ERP is CK-Ledger") ;
	$ckapi[details][2] = (isset($ckapi[details][2])) ? $ckapi[details][2] : exapi_lang("CK-ERP v.0.8.1; %1 being a sub-module",$app_title) ;
	$ckapi[contributors][1] = exapi_lang("Wu Chiu Kay aka CK Wu aka CK") ;
	$ckapi[contributors][2] = (isset($ckapi[contributors][2])) ? $ckapi[contributors][2] : exapi_lang("Wu Chiu Kay aka CK Wu aka CK") ;

	For ($i=1;isset($ckapi[dates][$i]);$i++) {
		$t->set_var('date',$ckapi[dates][$i]);
		$t->set_var('detail',$ckapi[details][$i]);
		$t->set_var('contributor',$ckapi[contributors][$i]);
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('ack_row','ack',True);
		}

	$t->pparse('out','report', true);

	}

    }

?>
