<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// araging.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-ar' ;
	$tran = 'araging' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$repdate = ($_GET["repdate"]) ? $_GET["repdate"] : $_POST["repdate"] ;
	$db_type = $ckapi['hostsys']['dbtype'] ;

	$t = exapi_tpl($app);
	$t->set_file('report','araging.tpl') ;
	$t->set_block('report','customer_row','customer_section');

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_araging', exapi_lang('ACCOUNTS RECEIVABLE AGING REPORT as of')." $repdate");

	$note1 = exapi_lang('Note 1') ;
	$t->set_var('lang_customername', exapi_lang('Customer Name'));
	$t->set_var('lang_customerid',exapi_lang('Customer ID'));
	$t->set_var('lang_isocode',exapi_lang('Currency'));
	$t->set_var('lang_amount', exapi_lang('Invoice Amount'));
	$t->set_var('lang_paidamount', exapi_lang('Paid'));
	$t->set_var('lang_osamount', exapi_lang('O/S'));
	$t->set_var('lang_separator', '|');
	$t->set_var('lang_notdue', exapi_lang('Not due'));
	$t->set_var('lang_0to30', exapi_lang('0-30'));
	$t->set_var('lang_31to60', exapi_lang('31-60'));
	$t->set_var('lang_61to90', exapi_lang('61-90'));
	$t->set_var('lang_91to120', exapi_lang('91-120'));
	$t->set_var('lang_120plus', exapi_lang('120+'));
	$t->set_var('lang_unallocated', exapi_lang('Unmatched receipt'));
	$t->set_var('lang_net', exapi_lang('Net O/S'));
	$t->set_var('lang_detail', exapi_lang('Detail'));
	$t->set_var('lang_total', exapi_lang('Total'));
	$note1 = exapi_lang('Note 1') ;
	$t->set_var('lang_note1',$note1);
	$note1a = exapi_lang('These lines are for control reconciliation purpose only') ;
	$note1b = exapi_lang('The figures represent an amalgamation of different currency amounts') ;
	$t->set_var('note1',"$note1 :-<br>$note1a.<br>$note1b.");

	$user = $ckapi['hostsys']['username'];
	$temp1 = "${pre}ar1".$user.time() ;
	$temp2 = "${pre}ar2".$user.time() ;
	$format = '000000000000.00' ;
	$sql = "CREATE TABLE $temp1 AS " ;
	$sql.= "SELECT customer,isocode,duedate,id,amount,$format as paidamount ";
	$sql.= "FROM ${pre}ar WHERE transdate <= '$repdate'";
	$adodb->query($sql);

	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT a.customer,a.isocode,duedate,a.id,0.00 as amount,sum(s_amount) as paidamount " ;
	$sql.= "FROM ${pre}ar a, ${pre}r_match b, ${pre}receipt c ";
	$sql.= "WHERE a.transdate<='$repdate' and a.id=b.invoiceid and c.transdate<='$repdate' and c.id=receiptid " ;
	$sql.= "GROUP BY a.customer,a.isocode,duedate,a.id";
	$adodb->query($sql);

	$sql = "CREATE TABLE $temp2 AS " ;
	$sql.= "SELECT customer,isocode,duedate,id,sum(amount) as amount,sum(paidamount) as paidamount,$format as osamount," ;
	$sql.= "000 as age, $format as notdue, $format as age30, $format as age60, $format as age90, " ;
	$sql.= " $format as age120, $format as age120plus, $format as totpaid, $format as matched " ;
	$sql.= "FROM $temp1 GROUP BY customer,isocode,duedate,id ";
	$adodb->query($sql);
	$agecalc = ($db_type=="pgsql") ? "to_date('$repdate','YYYY-MM-DD')-duedate" : "to_days('$repdate')-to_days(duedate)" ;
	$sql = "UPDATE $temp2 SET osamount=amount-paidamount,age=$agecalc" ;
	$adodb->query($sql);

	$adodb->query("UPDATE $temp2 SET notdue=osamount WHERE age<=0");
	$adodb->query("UPDATE $temp2 SET age30=osamount WHERE age>0 and age<31");
	$adodb->query("UPDATE $temp2 SET age60=osamount WHERE age>30 and age<61");
	$adodb->query("UPDATE $temp2 SET age90=osamount WHERE age>60 and age<91");
	$adodb->query("UPDATE $temp2 SET age120=osamount WHERE age>90 and age<121");
	$adodb->query("UPDATE $temp2 SET age120plus=osamount WHERE age>120");

	$sql = "INSERT INTO $temp2 " ;
	$sql.= "SELECT customer,isocode,NULL as duedate,0 as id,0.00 as amount,0.00 as paidamount,0.00 as osamount,";
	$sql.= "0 as age, 0.00 as notdue, 0.00 as age30, 0.00 as age60, 0.00 as age90, 0.00 as age120, " ;
	$sql.= "0.00 as age120plus,sum(amount) as totpaid,0.00 as matched FROM ${pre}receipt " ;
	$sql.= "WHERE transdate<='$repdate' GROUP BY customer,isocode";
	$adodb->query($sql);
	$sql = "INSERT INTO $temp2 " ;
	$sql.= "SELECT customer,isocode,NULL as duedate,0 as id,0.00 as amount,0.00 as paidamount,0.00 as osamount,";
	$sql.= "0 as age, 0.00 as notdue, 0.00 as age30, 0.00 as age60, 0.00 as age90, 0.00 as age120, " ;
	$sql.="0.00 as age120plus,0.00 as totpaid,sum(s_amount) as matched FROM ${pre}receipt a,${pre}r_match b ";
	$sql.= "WHERE transdate<='$repdate' and a.id=receiptid GROUP BY customer,isocode";
	$adodb->query($sql);

$sql ="SELECT customer,name,isocode,sum(amount) as amount,sum(paidamount) as paidamount,sum(osamount) as osamount,";
$sql.= "sum(notdue) as notdue, sum(age30) as age30, sum(age60) as age60, sum(age90) as age90, " ;
$sql.= "sum(age120) as age120, sum(age120plus) as age120plus, " ;
$sql.= "sum(totpaid) as totpaid, sum(matched) as matched FROM $temp2 a, ${pre}customer b " ;
$sql.= "WHERE (osamount>0 or totpaid>0 or matched>0) and a.customer=b.id " ;
$sql.= "GROUP BY customer,name,isocode ORDER BY customer,isocode" ;
$result = $adodb->query($sql) ;
if (exapi_dbrc($result)==0) {
	$t->set_var('customername','No O/S customer receivable') ;
	$t->set_var('customerid','') ;
	$t->set_var('isocode','') ;
	$t->set_var('amount','') ;
	$t->set_var('paidamount','') ;
	$t->set_var('osamount','') ;
	$t->set_var('notdue','') ;
	$t->set_var('0to30','') ;
	$t->set_var('31to60','') ;
	$t->set_var('61to90','') ;
	$t->set_var('91to120','') ;
	$t->set_var('120plus','') ;
	$t->set_var('unallocated','') ;
	$t->set_var('net','') ;
	$t->set_var('lang_history','') ;
	$t->parse('customer_section','customer_row',True);
	}
$sumamount = $sumpaid = $sumos = 0 ;
$sumnotdue = $sum30 = $sum60 = $sum90 = $sum120 = $sum120plus = 0 ;
$sumunallocated = $sumnet = 0 ;
While ($rs=$result->fetchRow()) {
	$amount		=	$rs['amount'] ;
	$paidamount	=	$rs['paidamount'] ;
	$osamount	=	$rs['osamount'] ;
	$notdue		=	$rs['notdue'] ;
	$age30		=	$rs['age30'] ;
	$age60		=	$rs['age60'] ;
	$age90		=	$rs['age90'] ;
	$age120		=	$rs['age120'] ;
	$age120plus	=	$rs['age120plus'] ;
	$unallocated	=	$rs['totpaid'] - $rs['matched'] ;
	$net		=	$osamount - $unallocated ;
	$t->set_var('customername',$rs['name']) ;
	$t->set_var('isocode',$rs['isocode']) ;
	$id = $rs['customer'] ;
	$t->set_var('customerid',$id) ;
	$t->set_var('amount',$amount) ;
	$t->set_var('paidamount',$paidamount) ;
	$t->set_var('osamount',$osamount) ;
	$t->set_var('notdue',$notdue) ;
	$t->set_var('0to30',$age30) ;
	$t->set_var('31to60',$age60) ;
	$t->set_var('61to90',$age90) ;
	$t->set_var('91to120',$age120) ;
	$t->set_var('120plus',$age120plus) ;
	$t->set_var('unallocated',$unallocated) ;
	$t->set_var('net',$net) ;
	$t->set_var('lang_history',exapi_lang('History'));
	$history = exapi_link("/$app/invoiceaging.php","repdate=$repdate&customer=$id");
	$t->set_var('history',$history) ;
	$t->parse('customer_section','customer_row', True);
	$sumamount	+=	$amount ;
	$sumpaid	+=	$paidamount ;
	$sumos		+=	$osamount ;
	$sumnotdue	+=	$notdue ;
	$sum30		+=	$age30 ;
	$sum60		+=	$age60 ;
	$sum90		+=	$age90 ;
	$sum120		+=	$age120 ;
	$sum120plus	+=	$age120plus ;
	$sumunallocated	+=	$unallocated ;
	$sumnet		+=	$net ;
	}
$t->set_var('sumamount',$sumamount) ;
$t->set_var('sumpaid',$sumpaid) ;
$t->set_var('sumos',$sumos) ;
$t->set_var('sumnotdue',$sumnotdue) ;
$t->set_var('sum30',$sum30) ;
$t->set_var('sum60',$sum60) ;
$t->set_var('sum90',$sum90) ;
$t->set_var('sum120',$sum120) ;
$t->set_var('sum120plus',$sum120plus) ;
$t->set_var('sumunallocated',$sumunallocated) ;
$t->set_var('sumnet',$sumnet) ;

$adodb->query("DROP TABLE $temp1, $temp2");

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',exapi_link("/$app/reportfilter.php")) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report');
	exapi_footer() ;

?>
