<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// worksheetlist.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-bank' ;
	$tran = 'worksheet' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$detail = ($_GET["detail"]) ? $_GET["detail"] : $_POST["detail"] ;
	$filter = stripslashes($filter) ;

	$t = exapi_tpl($app);
	$proc = newobj('ck-api','process') ;
	$t->set_file(array(	'report'	=>"${tran}list.tpl",
				'worksheets'	=>"${tran}list.tpl",
				'summary'	=>"${tran}list.tpl"	));
	$t->set_block('worksheets','worksheet_row','worksheet_section');
	$t->set_block('summary','summary_row','summary_section');
	$db_type = $ckapi[hostsys][dbtype] ;
	$float = ($db_type=="mysql") ? "double" : "float" ;

	list($s1,$s2,$s3,$s4) = explode(' AND ',$proc->decode_where($filter)) ;
	list($beginbal,$endbal) = explode(' ',trim($s1)) ;
	list($dummy,$chart_id) = explode("'",$s2);
	list($dummy,$from) = explode("'",$s3);
	list($dummy,$to) = explode("'",$s4);
	$where = "WHERE $s2 AND $s4 AND (substring(source,1,2)='SI' AND $s3 OR substring(source,1,2)<>'SI')" ;

//---------------------------- list variable template-declarations -------------------------

$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
$tr_color2 = $ckapi[hostsys][tr_color2] ;
$t->set_var('tr_color_a',$ckapi[hostsys][tr_color2]) ;
$t->set_var('tr_color_b',$ckapi[hostsys][tr_color1]) ;
$t->set_var('lang_title',exapi_lang('Bank Reconciliation Worksheet'));
$t->set_var('lang_bankac',exapi_lang('Bank Account'));
$result = $adodb->query("SELECT accno,description FROM ${pre}chart WHERE id=$chart_id");
$bankac = exapi_dbflds($result,'accno')."--".exapi_dbflds($result,'description') ;
$t->set_var('bankac',$bankac);

$note = exapi_lang('Item Detail (click column heading to re-sort table)') ;
$t->set_var('lang_note',$note);
$t->set_var('lang_imported',exapi_lang('Imported Ledger Items'));
$t->set_var('lang_suspense',exapi_lang('Suspense Items'));
$t->set_var('lang_bankitem',exapi_lang('Bank Statement Items not included in Ledger'));

	$script = "/$app/${tran}list.php" ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var('sort_transdate',$proc->sortlink(exapi_lang('Item Date'),$script,'transdate',$sort,$getstr));
	$t->set_var('sort_source',$proc->sortlink(exapi_lang('Source'),$script,'source',$sort,$getstr));
	$t->set_var('sort_description',$proc->sortlink(exapi_lang('Description'),$script,'description',$sort,$getstr));
	$t->set_var('sort_refnumber',$proc->sortlink(exapi_lang('Ref Number'),$script,'refnumber',$sort,$getstr));
	$t->set_var('sort_cheque',$proc->sortlink(exapi_lang('Cheque'),$script,'cheque',$sort,$getstr));
	$t->set_var('sort_status',$proc->sortlink(exapi_lang('Status'),$script,'status',$sort,$getstr));
	$t->set_var('sort_payment',$proc->sortlink(exapi_lang('Payment'),$script,'payment',$sort,$getstr));
	$t->set_var('sort_receipt',$proc->sortlink(exapi_lang('Receipt'),$script,'receipt',$sort,$getstr));
	$t->set_var('sort_others',$proc->sortlink(exapi_lang('Others'),$script,'others',$sort,$getstr));
	$t->set_var('sort_suspense',$proc->sortlink(exapi_lang('Suspense<br>Item'),$script,'suspense',$sort,$getstr));
	$t->set_var('sort_cashin',$proc->sortlink(exapi_lang('Cash<br>In'),$script,'cashin',$sort,$getstr));
	$t->set_var('sort_cashout',$proc->sortlink(exapi_lang('Cash<br>Out'),$script,'cashout',$sort,$getstr));
	$t->set_var('sort_interest',$proc->sortlink(exapi_lang('Bank<br>Interest'),$script,'interest',$sort,$getstr));
	$t->set_var('sort_charge',$proc->sortlink(exapi_lang('Bank<br>Charge'),$script,'charge',$sort,$getstr));
	$t->set_var('sort_adjustment',$proc->sortlink(exapi_lang('Bank<br>Adj'),$script,'adjustment',$sort,$getstr));
	$t->set_var('sort_id',$proc->sortlink(exapi_lang('Audit ID'),$script,'id',$sort,$getstr));

$user = $ckapi[hostsys][username];
$temp = "${pre}wsl".$user.time() ;
$sql =	"CREATE TABLE $temp AS " ;
$sql.=	"SELECT *,amount as payment,amount as receipt,amount as others,amount as suspense," ;
$sql.=	"amount as cashin,amount as cashout,amount as interest,amount as charge," ;
$sql.=	"amount as adjustment FROM ${pre}bkr_trans $where ORDER BY amount" ;
//$sql.=	"amount as adjustment,trans_id as id FROM ${pre}bkr_trans $where " ;
$adodb->query($sql);
$adodb->query("UPDATE $temp SET payment='' WHERE source<>'APPY' and source<>'PYPY'");
$adodb->query("UPDATE $temp SET receipt='' WHERE source<>'ARRT'");
$adodb->query("UPDATE $temp SET others='' WHERE source<>'GLJL'");
$adodb->query("UPDATE $temp SET suspense='' WHERE source<>'SUSP'");
$adodb->query("UPDATE $temp SET cashin='' WHERE source<>'SICI'");
$adodb->query("UPDATE $temp SET cashout='' WHERE source<>'SICO'");
$adodb->query("UPDATE $temp SET interest='' WHERE source<>'SIBI'");
$adodb->query("UPDATE $temp SET charge='' WHERE source<>'SIBC'");
$adodb->query("UPDATE $temp SET adjustment='' WHERE source<>'SIBA'");
$adodb->query("UPDATE $temp SET amount='' WHERE status<>'c' or status is null");

if (!$order) $order = "transdate" ;	else $detail = "yes" ;
if (!$sort)  $sort = "ASC" ;
$result = $adodb->query("SELECT * FROM $temp ORDER BY $order $sort") ;

// -------------------------------- end declaration -----------------------------------------

if (exapi_dbrc($result)==0) {
	$t->set_var(array(	'transdate'	=> exapi_lang("No Matching Item Found"),
				'source'	=> "",
				'description'	=> "",
				'refnumber'	=> "",
				'cheque'	=> "",
				'status'	=> "",
				'payment'	=> "",
				'receipt'	=> "",
				'others'	=> "",
				'suspense'	=> "",
				'cashin'	=> "",
				'cashout'	=> "",
				'interest'	=> "",
				'charge'	=> "",
				'adjustment'	=> "",
				'id'		=> ""			));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('worksheet_section','worksheet_row',True);
	}
While ($rs=$result->fetchRow()) {
	$status = "" ;
	if ($rs['status']=='c')	$status = "cleared" ;
	if ($rs['status']=='s')	$status = "stopped" ;
	$payment = ($rs['payment']==0) ? '' : $rs['payment'] ;
	$receipt = ($rs['receipt']==0) ? '' : $rs['receipt'] ;
	$others = ($rs['others']==0) ? '' : $rs['others'] ;
	$suspense = ($rs['suspense']==0) ? '' : $rs['suspense'] ;
	$cashin = ($rs['cashin']==0) ? '' : $rs['cashin'] ;
	$cashout = ($rs['cashout']==0) ? '' : $rs['cashout'] ;
	$interest = ($rs['interest']==0) ? '' : $rs['interest'] ;
	$charge = ($rs['charge']==0) ? '' : $rs['charge'] ;
	$adjustment = ($rs['adjustment']==0) ? '' : $rs['adjustment'] ;
	$t->set_var(array(
		'transdate'	=> $rs['transdate'],
		'source'	=> $rs['source'],
		'description'	=> $rs['description'],
		'refnumber'	=> $rs['refnumber'],
		'cheque'	=> $rs['cheque'],
		'status'	=> $status,
		'payment'	=> $payment,
		'receipt'	=> $receipt,
		'others'	=> $others,
		'suspense'	=> $suspense,
		'cashin'	=> $cashin,
		'cashout'	=> $cashout,
		'interest'	=> $interest,
		'charge'	=> $charge,
		'adjustment'	=> $adjustment,
		'id'		=> $rs['id']				));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('worksheet_section','worksheet_row',true);
	}

$result = $adodb->query("SELECT sum(payment) as payment, sum(amount) as cleared FROM $temp WHERE source='APPY' or source='PYPY'");
$payment = exapi_dbflds($result,'payment') ;
$paymentc= exapi_dbflds($result,'cleared') ;
$result = $adodb->query("SELECT sum(receipt) as receipt, sum(amount) as cleared FROM $temp WHERE source='ARRT'");
$receipt = exapi_dbflds($result,'receipt') ;
$receiptc = exapi_dbflds($result,'cleared') ;
$result = $adodb->query("SELECT sum(others) as others, sum(amount) as cleared FROM $temp WHERE source='GLJL'");
$others = exapi_dbflds($result,'others') ;
$othersc = exapi_dbflds($result,'cleared') ;
$result = $adodb->query("SELECT sum(suspense) as suspense, sum(amount) as cleared FROM $temp WHERE source='SUSP'");
$suspense = exapi_dbflds($result,'suspense') ;
$suspensec = exapi_dbflds($result,'cleared') ;
$result = $adodb->query("SELECT sum(cashin) as cashin, sum(amount) as cleared FROM $temp WHERE source='SICI'");
$cashin = exapi_dbflds($result,'cashin') ;
$cashinc = exapi_dbflds($result,'cleared') ;
$result = $adodb->query("SELECT sum(cashout) as cashout, sum(amount) as cleared FROM $temp WHERE source='SICO'");
$cashout = exapi_dbflds($result,'cashout') ;
$cashoutc = exapi_dbflds($result,'cleared') ;
$result = $adodb->query("SELECT sum(interest) as interest, sum(amount) as cleared FROM $temp WHERE source='SIBI'");
$interest = exapi_dbflds($result,'interest') ;
$interestc = exapi_dbflds($result,'cleared') ;
$result = $adodb->query("SELECT sum(charge) as charge, sum(amount) as cleared FROM $temp WHERE source='SIBC'");
$charge = exapi_dbflds($result,'charge') ;
$chargec = exapi_dbflds($result,'cleared') ;
$result = $adodb->query("SELECT sum(adjustment) as adjustment, sum(amount) as cleared FROM $temp WHERE source='SIBA'");
$adjustment = exapi_dbflds($result,'adjustment') ;
$adjustmentc = exapi_dbflds($result,'cleared') ;

$t->set_var('tr_color',$ckapi[hostsys][th_bg]);
$t->set_var(array(
	'transdate'	=> exapi_lang('Total'),
	'source'	=> '',
	'description'	=> exapi_lang('Amount'),
	'refnumber'	=> '',
	'cheque'	=> '',
	'status'	=> '',
	'payment'	=> $payment,
	'receipt'	=> $receipt,
	'others'	=> $others,
	'suspense'	=> $suspense,
	'cashin'	=> $cashin,
	'cashout'	=> $cashout,
	'interest'	=> $interest,
	'charge'	=> $charge,
	'adjustment'	=> $adjustment,
	'id'		=> ''));
$t->parse('worksheet_section','worksheet_row',true);
$t->set_var(array(
	'transdate'	=> exapi_lang('Total'),
	'source'	=> '',
	'description'	=> exapi_lang('Cleared'),
	'refnumber'	=> '',
	'cheque'	=> '',
	'status'	=> '',
	'payment'	=> $paymentc,
	'receipt'	=> $receiptc,
	'others'	=> $othersc,
	'suspense'	=> $suspensec,
	'cashin'	=> $cashinc,
	'cashout'	=> $cashoutc,
	'interest'	=> $interestc,
	'charge'	=> $chargec,
	'adjustment'	=> $adjustmentc,
	'id'		=> ''));
$t->parse('worksheet_section','worksheet_row',true);

$paymentnc	= $payment-$paymentc;
$receiptnc	= $receipt-$receiptc;
$othersnc	= $others-$othersc;
$suspensenc	= $suspense-$suspensec;
$cashinnc	= $cashin-$cashinc;
$cashoutnc	= $cashout-$cashoutc;
$interestnc	= $interest-$interestc;
$chargenc	= $charge-$chargec;
$adjustmentnc	= $adjustment-$adjustmentc;
$t->set_var(array(
	'transdate'	=> exapi_lang('Total'),
	'source'	=> exapi_lang('Not'),
	'description'	=> exapi_lang('Cleared'),
	'refnumber'	=> '',
	'cheque'	=> '',
	'status'	=> '',
	'payment'	=> $paymentnc,
	'receipt'	=> $receiptnc,
	'others'	=> $othersnc,
	'suspense'	=> $suspensenc,
	'cashin'	=> $cashinnc,
	'cashout'	=> $cashoutnc,
	'interest'	=> $interestnc,
	'charge'	=> $chargenc,
	'adjustment'	=> $adjustmentnc,
	'id'		=> ''));
$t->parse('worksheet_section','worksheet_row',true);

// ---------------------------- Print Reconciliation Section----------------------------------------

$note1a = exapi_lang('Auditor should check in detail each suspense item.') ;
$note1b = exapi_lang('If appropriate, recommend write-off or adjustment according to local GAAP and/or legal requirement.') ;
$note2a = exapi_lang('Bank Statement items not included in ledger and with financial effect occurring before the reconciliation day should be entered back into the ledger.') ;
$note2b =exapi_lang('Subsequently, reconciliation should be re-done to present a simplified Bank Reconciliation.') ;
$note3a = exapi_lang('Long outstanding unpresented check should be voided or stopped via appropriate banking procedure.') ;
$note3b = exapi_lang('The associated payment should be reversed.') ;
$note3c = exapi_lang("The associated payment liability should be placed in the main ledger's suspense account.") ;
$note4a = exapi_lang('Since this worksheet is not persistent over time, a copy of the Bank Reconciliation Statement should be printed after the worksheet is completed.') ;
$note5  = exapi_lang("Non-payment items that (had) appeared in bank statement should also be flagged as 'cleared' in the detail worksheet.") ;
$note6  = exapi_lang("Be careful not to list an item as both uncleared Ledger Item and as Suspense Item.") ;

$t->set_var('lang_note1',exapi_lang("Note 1:")."  $note1a  $note1b");
$t->set_var('lang_note2',exapi_lang("Note 2:")."  $note2a  $note2b");
$t->set_var('lang_note3',exapi_lang("Note 3:")."  $note3a  $note3b  $note3c");
$t->set_var('lang_note4',exapi_lang("Note 4:")."  $note4a");
$t->set_var('lang_note5',exapi_lang("Note 5:")."  $note5");
$t->set_var('lang_note6',exapi_lang("Note 6:")."  $note6");

$t->set_var('lang_reconciliation',exapi_lang('Reconciliation'));
$t->set_var('lang_importednc',exapi_lang('Imported Ledger Items - not yet cleared thru Bank Statement'));

$t->set_var('lang_date',exapi_lang('Date'));
$t->set_var('lang_ledgerbal',exapi_lang('Ledger<br>Balance'));
$t->set_var('lang_payment',exapi_lang('Payment'));
$t->set_var('lang_receipt',exapi_lang('Receipt'));
$t->set_var('lang_others',exapi_lang('Others'));
$t->set_var('lang_suspense',exapi_lang('Suspense'));
$t->set_var('lang_cashin',exapi_lang('Cash<br>In'));
$t->set_var('lang_cashout',exapi_lang('Cash<br>Out'));
$t->set_var('lang_interest',exapi_lang('Bank<br>Interest'));
$t->set_var('lang_charge',exapi_lang('Bank<br>Charge'));
$t->set_var('lang_adjustment',exapi_lang('Bank<br>Adj'));
$t->set_var('lang_bankbal',exapi_lang('Bank<br>Balance'));
$t->set_var('lang_adjust',exapi_lang('Adjusted Balance')) ;
$recnote = exapi_lang('Remember to check the last reconciliation to see if any item needs to be c/f or be discarded') ;
$t->set_var('lang_recnote',$recnote);

$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
$t->set_var('tr_color',$tr_color) ;
$t->set_var('from',$from);
$sql =	"SELECT sum(amount) as balance FROM ${pre}acc_trans WHERE chart_id='$chart_id' and transdate<'$from'" ;
$result = $adodb->query($sql);
$t->set_var('beginledbal',-exapi_dbflds($result,'balance'));
$t->set_var('beginbankbal',$beginbal);
$t->set_var('to',$to);
$sql =	"SELECT sum(amount) as balance FROM ${pre}acc_trans WHERE chart_id='$chart_id' and transdate<'$to'" ;
$result = $adodb->query($sql);
$endledbal = -exapi_dbflds($result,'balance') ;
$t->set_var('endledbal',$endledbal);
$t->set_var('endbankbal',$endbal);

$adjustbankbal = $endbal+$paymentnc+$receiptnc+$othersnc+$suspensenc ;
$adjustledbal = $endledbal+$cashin+$cashout+$interest+$charge+$adjustment ;
$t->set_var('adjustbankbal',$adjustbankbal);
$t->set_var('adjustledbal',$adjustledbal);

$t->set_var('lang_discrepancy',exapi_lang('Discrepancy'));
$t->set_var('discrepancy',sprintf("%01.2f",$adjustbankbal-$adjustledbal));

$adodb->query("DROP TABLE $temp");

$button = ($detail=='yes') ? exapi_lang('Suppress Item Detail') : exapi_lang('Show Item Detail') ;
$t->set_var('lang_add',$button);
if ($detail<>"yes")	$t->set_var('worksheet_section','');
$detail = ($detail=='yes') ? '' : 'yes' ;
$getstr = "filter=$filter&detail=$detail" ;
$t->set_var('add_action',exapi_link("/$app/${tran}list.php",$getstr));

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','worksheets','report');
	exapi_footer() ;

?>
