<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// importfilter_validate.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-contact' ;
	$tran = 'import' ;
	$noheader = $nonavbar = True ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$pass2 = ($_GET["pass2"]) ? $_GET["pass2"] : $_POST["pass2"] ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$actnum = ($_GET["actnum"]) ? $_GET["actnum"] : $_POST["actnum"] ;
	$oname = ($_GET["oname"]) ? $_GET["oname"] : $_POST["oname"] ;
	$omask = ($_GET["omask"]) ? $_GET["omask"] : $_POST["omask"] ;
	$fname = ($_GET["fname"]) ? $_GET["fname"] : $_POST["fname"] ;
	$fmask = ($_GET["fmask"]) ? $_GET["fmask"] : $_POST["fmask"] ;

/* --------------------- Validation Check Start ----------------------------	*/

	$err="" ;  $error = exapi_lang("Error") ;
	$lang_oname = exapi_lang("Organization Name") ;
	$lang_omask = exapi_lang("Char1 Org Name Mask") ;
	$lang_fname = exapi_lang("Family/Last Name") ;
	$lang_fmask = exapi_lang("Char1 Family/Last Name Mask") ;
	$result = $adodb->query("SELECT sum(amount) as amount FROM ${pre}acc_trans");
	$net = sprintf("%01.2f",exapi_dbflds($result,'amount')) ;
	if ($net<>0)		$err=exapi_lang("Dr/Cr Imbalance detected.  Pls inform System Admin immediately.") ;
	if (strlen($oname)>15)	$err="[$lang_oname]".exapi_lang("Search string too long") ;
	if (substr_count($oname," ")>0)	
		$err="[$lang_oname]".exapi_lang("Search string should not contain space(s)");
	if (strlen($omask)>15)	$err="[$lang_omask]".exapi_lang("Mask string too long") ;
	if (substr_count($omask," ")>0)	
		$err="[$lang_omask]".exapi_lang("Mask string should not contain space(s)");
	if (strlen($fname)>15)	$err="[$lang_fname]".exapi_lang("Search string too long") ;
	if (substr_count($fname," ")>0)	
		$err="[$lang_fname]".exapi_lang("Search string should not contain space(s)");
	if (strlen($fmask)>15)	$err="[$lang_fmask]".exapi_lang("Mask string too long") ;
	if (substr_count($fmask," ")>0)	
		$err="[$lang_fmask]".exapi_lang("Mask string should not contain space(s)");
	if ($actnum<1 or $actnum>3)	$err=exapi_lang("Invalid Choice of import data set") ;
	
	if ($err)	$err="<b>$error: $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

	if (!$err)	{ 
		switch ($actnum) {
			case 1:	$markpri="zzAnDzz";  $marksec="z2z1z3z"; $markter="zzDnAzz";
				if ($oname) $filter.="${markpri}6name${marksec}${oname}";
				if ($omask) $filter.="${markpri}9$markter${marksec}'${omask}'";
				$filter = urlencode($filter) ;
				$getstr = "oname=$oname&omask=$omask&filter=$filter" ;
				Header('Location: '.exapi_link("/$app/importorgslist.php",$getstr));
				exit();
			case 2:	$markpri="zzAnDzz";  $marksec="z2z1z3z"; $markter="zzDnAzz";
				if ($fname) $filter.="${markpri}6last_name${marksec}${fname}";
				if ($fmask) $filter.="${markpri}9$markter${marksec}'${fmask}'";
				$filter = urlencode($filter) ;
				$getstr = "fname=$fname&fmask=$fmask&filter=$filter" ;
				Header('Location: '.exapi_link("/$app/importprsslist.php",$getstr));
				exit();
			case 3:	Header('Location: '.exapi_link("/$app/importorgprslist.php"));
				exit();
			case 4:	exit();
			case 5:	exit();
			default:
				echo "Should not be here.  Weird import Number" ;
			}
		}
	else
		{
		$getstr = "actnum=$actnum&oname=$oname&omask=$omask&" ;
		$getstr.= "fname=$fname&fmask=$fmask&err=$err" ;
		Header('Location: '.exapi_link("/$app/importfilter.php",$getstr));
		}

?>
