<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// contractfilter.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-crm' ;
	$tran = 'contract' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$ckapi[phrases] = array('lang_title'	=> exapi_lang("Search among existing Contracts :") ,
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Contract") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$contractmsg = exapi_lang('Contracts falling within (from/to) period will be listed.') ;
	$opennote = exapi_lang("Click box if only current and unexpired contracts are to be retrieved") ;
	$ckapi[filter][] = array(criteria	=>	exapi_lang('Target Customer') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.selectlist('customer','name','','','id','name','id') ,
				varname		=>	'customer' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for contracts of the target customer') );
				
	$ckapi[filter][] = array(criteria	=>	exapi_lang('Period From') ,
				type		=>	'input' ,
				varname		=>	'datefrom' ,
				defval		=>	'' ,
				note		=>	"$contractmsg  $dateformat"		) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Period To') ,
				type		=>	'input' ,
				varname		=>	'dateto' ,
				defval		=>	'' ,
				note		=>	"$contractmsg  $dateformat"		) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Contract Name/#') ,
				type		=>	'input' ,
				varname		=>	'cntnumber' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for target key word in the contract name/# field') );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Open Contracts Only') ,
				type		=>	'checkbox' ,
				varname		=>	'opentran' ,
				defval		=>	"" ,
				note		=>	$opennote				 );

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
