<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.dailyatt.inc.php 0.15.1 2005/09/30 C K Wu

    class dailyatt {

//---- Attendance List SQL Formation

    function dailyatt_list_sql() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$app = $ckapi[params][app] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	if (!$order) {$order = "" ; }
	if (!$sort)  {$sort = "ASC" ; }

	$lang_signin = exapi_lang('sign-in') ;
	$lang_signout = exapi_lang('sign-out') ;
	$user = $ckapi[hostsys][username] ;
	$ckapi[params_sql][temp] = $dalist = "${pre}dalist".$user.time() ;
	$ckapi[params_sql][temp1] = $daempdate = "${pre}daempdate".$user.time() ;
	$float = ($ckapi[hostsys][dbtype]=="mysql") ? "double default 0" : "float default 0" ;

	$sql="CREATE TABLE $dalist(empid int,transdate date,si1 text,so1 text,si2 text,so2 text,si3 text,so3 text,hrs $float)";
	$adodb->query($sql);
	$sql = "CREATE TABLE $daempdate AS select empid,transdate FROM ${pre}attendance " ;
	$sql.= "WHERE 1=1 $where GROUP BY empid,transdate ORDER BY empid,transdate" ;
	$adodb->query($sql);
	$result = $adodb->query("SELECT * FROM $daempdate");
	while ($rs=$result->fetchRow())		$empdate[]=$rs;
	foreach ($empdate as $rs1) {
		$empid = $rs1['empid'] ;
		$transdate = $rs1['transdate'] ;
		$sql = "SELECT type,time FROM ${pre}attendance " ;
		$sql.= "WHERE empid='$empid' and transdate='$transdate' ORDER BY empid,transdate,time" ;
		$result = $adodb->query($sql);
		unset($typetime) ;
		while ($rs=$result->fetchRow())		$typetime[]=$rs;
		$si1 = $si2 = $si3 = $so1 = $so2 = $so3 = $err = '' ;
		$expect = 'si1' ;
		foreach ($typetime as $rs2) {
			switch ($expect) {
			  case	si1:
				if ($rs2['type']==$lang_signin)	{$si1=$rs2['time'];$expect='so1';}
				if ($rs2['type']==$lang_signout){$so1=$rs2['time'];$expect='si2';$err='*';}
				break ;
			  case	so1:
				if ($rs2['type']==$lang_signin)	{$si2=$rs2['time'];$expect='so2';$err='*';}
				if ($rs2['type']==$lang_signout){$so1=$rs2['time'];$expect='si2';}
				break ;
			  case	si2:
				if ($rs2['type']==$lang_signin)	{$si2=$rs2['time'];$expect='so2';}
				if ($rs2['type']==$lang_signout){$so2=$rs2['time'];$expect='si3';$err='*';}
				break ;
			  case	so2:
				if ($rs2['type']==$lang_signin)	{$si3=$rs2['time'];$expect='so3';$err='*';}
				if ($rs2['type']==$lang_signout){$so2=$rs2['time'];$expect='si3';}
				break ;
			  case	si3:
				if ($rs2['type']==$lang_signin)	{$si3=$rs2['time'];$expect='so3';}
				if ($rs2['type']==$lang_signout){$so3=$rs2['time'];$expect='si4';$err='*';}
				break ;
			  case	so3:
				if ($rs2['type']==$lang_signin)	{$si4=$rs2['time'];$expect='so4';$err='*';}
				if ($rs2['type']==$lang_signout){$so3=$rs2['time'];$expect='si4';}
				break ;
				}
			}
		if ($err<>'')	$hrs = -1 ;
		  else {
			list($hr,$mn,$sec)=explode(':',$si1);	$si1time=mktime($hr,$mn,$sec,0,0,2000) ;
			list($hr,$mn,$sec)=explode(':',$so1);	$so1time=mktime($hr,$mn,$sec,0,0,2000) ;
			list($hr,$mn,$sec)=explode(':',$si2);	$si2time=mktime($hr,$mn,$sec,0,0,2000) ;
			list($hr,$mn,$sec)=explode(':',$so2);	$so2time=mktime($hr,$mn,$sec,0,0,2000) ;
			list($hr,$mn,$sec)=explode(':',$si3);	$si3time=mktime($hr,$mn,$sec,0,0,2000) ;
			list($hr,$mn,$sec)=explode(':',$so3);	$so3time=mktime($hr,$mn,$sec,0,0,2000) ;
			$hrs=sprintf('%01.2f',(($so1time-$si1time)+($so2time-$si2time)+($so3time-$si3time))/3600);
			}
		$sql = "INSERT INTO $dalist (empid,transdate,si1,so1,si2,so2,si3,so3,hrs) " ;
		$sql.= "VALUES ('$empid','$transdate','$si1','$so1','$si2','$so2','$si3','$so3','$hrs')" ;
		$adodb->query($sql);
		}

	$sql =  "SELECT b.name,c.description as dept,a.* FROM $dalist a,${pre}employee b,${pre}department c " ;
	$sql.=	"WHERE empid=b.id and b.dept=c.id ORDER BY $order $sort" ;
	return $sql ;
	}

//---- Daily Attendance List Link Adjustement

    function dailyatt_list_adjust() {
	global $ckapi ;

	$app = $ckapi[params][app] ;
	$tran = $ckapi[params][tran] ;
	foreach ($ckapi[params_list] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;

	$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
	$name = $dt['name'] ;
	$transdate = $dt['transdate'] ;
	$filter  = "${markpri}1b.name${marksec}$name" ;
	$filter .= "${markpri}2transdate${marksec}$transdate" ;
	$filter .= "${markpri}4transdate${marksec}$transdate" ;
	$filter = urlencode($filter) ;
	$getstr = "filter=$filter" ;

	$return = "/$app/${tran}list.php" ;
	$getstr = "filter=$filter&return=$return" ;
	$t->set_var('further',exapi_link("/$app/attendlist.php",$getstr)) ;
	if ($dt['hrs']<0)	$t->set_var('hrs',exapi_lang('[incomplete data]')) ;
	}

    }

?>
