<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.pr.inc.php 0.15.1 2005/09/30 C K Wu

    class pr {

//---- Performance Review Read

    function pr_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$result = $adodb->query("SELECT * FROM ${pre}employee WHERE id='$id'");
	$dt = $result->fetchRow() ;

	$result = $adodb->query("SELECT * FROM ${pre}pr where empid='$id' order by prfrom");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$prfrom			=	$rs['prfrom'] ;
		$dt['fromyear'.$i]	=	substr($prfrom,0,4) ;
		$dt['frommonth'.$i]	=	substr($prfrom,5,2) ;
		$dt['fromday'.$i]	=	substr($prfrom,8,2) ;
		$prto			=	$rs['prto'] ;
		$dt['toyear'.$i]	=	substr($prto,0,4) ;
		$dt['tomonth'.$i]	=	substr($prto,5,2) ;
		$dt['today'.$i]		=	substr($prto,8,2) ;
		$dt['prcode'.$i]	=	$rs['prcode'] ;
		$dt['comment'.$i]	=	$rs['comment'] ;
		$dt['reviewer'.$i]	=	$rs['reviewer'] ;
		$pddate			=	$rs['pddate'] ;
		$dt['pdyear'.$i]	=	substr($pddate,0,4) ;
		$dt['pdmonth'.$i]	=	substr($pddate,5,2) ;
		$dt['pdday'.$i]		=	substr($pddate,8,2) ;
		}
	return $dt ;
	}

//---- pr Validation Checks

    function pr_validate() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error") ;
	$row = exapi_lang("Row") ;
	if (!isset($dt[fromyear1]))			return $err ;
	$al=$cl=$ji=$js=$ml=$sl=$ua=$ul = "" ;
	For ($i=1;isset($dt['fromyear'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		$fromdate = input2date($dt['fromyear'.$i].'-'.$dt['frommonth'.$i].'-'.$dt['fromday'.$i]) ;
		if ($fromdate=="") {
			$err=$rowi.exapi_lang("Invalid Period From Date");
			$errRow[$i] = True ;
			}
		$todate = input2date($dt['toyear'.$i].'-'.$dt['tomonth'.$i].'-'.$dt['today'.$i]) ;
		if ($todate=="") {
			$err=$rowi.exapi_lang("Invalid Period To Date");
			$errRow[$i] = True ;
			}
		$pddate = input2date($dt['pdyear'.$i].'-'.$dt['pdmonth'.$i].'-'.$dt['pdday'.$i]) ;
		if ($pddate=="") {
			$err=$rowi.exapi_lang("Invalid (discussion with staff) Date");
			$errRow[$i] = True ;
			}
		$prfrom[$i] = strtotime($fromdate) ;
		$prto[$i] = strtotime($todate) ;
		$prpd[$i] = strtotime($pddate) ;
		if ($fromdate<>"" and $todate<>"" and $prfrom[$i]>$prto[$i]) {
			$err=$rowi.exapi_lang("Period From Date later than Period To Date") ;
			$errRow[$i] = True ;
			}
		if ($todate<>"" and $pddate<>"" and $prpd[$i]<$prto[$i]) {
			$err=$rowi.exapi_lang("Discussion made before Period End") ;
			$errRow[$i] = True ;
			}
		if ($dt[id]==$dt['reviewer'.$i]) {
			$err=$rowi.exapi_lang("Staff cannot review one's ownself") ;
			$errRow[$i] = True ;
			}
		}
	$size = $i-1 ;
	For ($i=1;$i<$size;$i++) {
		For ($j=$i+1;$j<=$size;$j++) {
			$rowij = "[$row $i/$j]" ;
			if (!$errRow[$i] and !$errRow[$j] and $prfrom[$j]>=$prfrom[$i] and $prfrom[$j]<=$prto[$i])
							$err=$rowij.exapi_lang("Overlapping performance periods") ;
			if (!$errRow[$i] and !$errRow[$j] and $prto[$j]>=$prfrom[$i] and $prto[$j]<=$prto[$i])
							$err=$rowij.exapi_lang("Overlapping performance periods") ;
			if (!$errRow[$i] and !$errRow[$j] and $prfrom[$i]>=$prfrom[$j] and $prfrom[$i]<=$prto[$j])
							$err=$rowij.exapi_lang("Overlapping performance periods") ;
			if (!$errRow[$i] and !$errRow[$j] and $prto[$i]>=$prfrom[$j] and $prto[$i]<=$prto[$j])
							$err=$rowij.exapi_lang("Overlapping performance periods") ;
			}
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Performance Review Header

    function pr_header_write() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_name',exapi_lang('Employee Name/# :'));
	$t->set_var('lang_id',exapi_lang('Audit ID').' :');
	$t->set_var('name',$dt[name]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('disabled','');
	$t->parse('out','report',True);
	}

//---- Write Performance Review Detail

    function pr_detail_write() {
	global $ckapi ;

	$app = $ckapi[params][app] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;

	$row_ = exapi_lang('Row')." " ;
	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_from',exapi_lang('Period From'));
	$t->set_var('lang_to',exapi_lang('Period To'));
	$t->set_var('lang_performance',exapi_lang('Performance Level'));
	$t->set_var('lang_pddate',exapi_lang('Discussed with Staff On'));
	$t->set_var('lang_insert',exapi_lang('Insert<br>before'));
	$t->set_var('lang_year',exapi_lang('Year'));
	$t->set_var('lang_month',exapi_lang('Month'));
	$t->set_var('lang_day',exapi_lang('Day'));
	$t->set_var('lang_hyphen','-');
	$t->set_var('lang_prcode',exapi_lang("Code -- Description")."<br>".exapi_lang("[TBC - to be considered]") );
	$t->set_var('lang_comment',exapi_lang('Comment by Reviewer'));
	$t->set_var('lang_reviewer',exapi_lang('Performance reviewed by'));
	$t->set_var('lang_delete',exapi_lang('Delete'));

	$blankopt = "<OPTION value=''></OPTION>" ;
	$lang_pr = strtolower(exapi_lang('pr')) ;
	$year_sl = ymwd_selectlist('','','y') ;
	$month_sl = ymwd_selectlist('','','m') ;
	$day_sl = ymwd_selectlist('','','d') ;
	$prcode_sl = selectlist('category','name',"WHERE app='$app' and type='$lang_pr'",'','name','name','substring(description,1,25)') ;
	$reviewer_sl = selectlist('employee','name','','','id','name','id') ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['fromyear'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('fromyear_fld','fromyear'.$i) ;
			$t->set_var('frommonth_fld','frommonth'.$i) ;
			$t->set_var('fromday_fld','fromday'.$i) ;
			$t->set_var('toyear_fld','toyear'.$i) ;
			$t->set_var('tomonth_fld','tomonth'.$i) ;
			$t->set_var('today_fld','today'.$i) ;
			$t->set_var('prcode_fld','prcode'.$i) ;
			$t->set_var('comment_fld','comment'.$i);
			$t->set_var('reviewer_fld','reviewer'.$i);
			$t->set_var('pdyear_fld','pdyear'.$i) ;
			$t->set_var('pdmonth_fld','pdmonth'.$i) ;
			$t->set_var('pdday_fld','pdday'.$i) ;
			$t->set_var('fromyear_selectlist',$year_sl);
			$t->set_var('frommonth_selectlist',$month_sl) ;
			$t->set_var('fromday_selectlist',$day_sl) ;
			$t->set_var('toyear_selectlist',$year_sl);
			$t->set_var('tomonth_selectlist',$month_sl) ;
			$t->set_var('today_selectlist',$day_sl) ;
			$t->set_var('prcode_selectlist',$prcode_sl) ;
			$t->set_var('comment','') ;
			$t->set_var('reviewer_selectlist',$reviewer_sl) ;
			$t->set_var('pdyear_selectlist',$year_sl);
			$t->set_var('pdmonth_selectlist',$month_sl) ;
			$t->set_var('pdday_selectlist',$day_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$fromyear	=	$dt['fromyear'.$i] ;
		$frommonth	=	$dt['frommonth'.$i] ;
		$fromday	=	$dt['fromday'.$i] ;
		$toyear		=	$dt['toyear'.$i] ;
		$tomonth	=	$dt['tomonth'.$i] ;
		$today		=	$dt['today'.$i] ;
		$prcode		=	$dt['prcode'.$i] ;
		$comment	=	$dt['comment'.$i] ;
		$reviewer	=	$dt['reviewer'.$i] ;
		$pdyear		=	$dt['pdyear'.$i] ;
		$pdmonth	=	$dt['pdmonth'.$i] ;
		$pdday		=	$dt['pdday'.$i] ;

		$t->set_var('fromyear_fld','fromyear'.$j) ;
		$t->set_var('frommonth_fld','frommonth'.$j) ;
		$t->set_var('fromday_fld','fromday'.$j) ;
		$t->set_var('toyear_fld','toyear'.$j) ;
		$t->set_var('tomonth_fld','tomonth'.$j) ;
		$t->set_var('today_fld','today'.$j) ;
		$t->set_var('prcode_fld','prcode'.$j) ;
		$t->set_var('comment_fld','comment'.$j);
		$t->set_var('reviewer_fld','reviewer'.$j);
		$t->set_var('pdyear_fld','pdyear'.$j) ;
		$t->set_var('pdmonth_fld','pdmonth'.$j) ;
		$t->set_var('pdday_fld','pdday'.$j) ;
		$t->set_var('fromyear_selectlist',str_replace("'$fromyear'","'$fromyear' selected",$year_sl)) ;
		$t->set_var('frommonth_selectlist',str_replace("'$frommonth'","'$frommonth' selected",$month_sl)) ;
		$t->set_var('fromday_selectlist',str_replace("'$fromday'","'$fromday' selected",$day_sl)) ;
		$t->set_var('toyear_selectlist',str_replace("'$toyear'","'$toyear' selected",$year_sl)) ;
		$t->set_var('tomonth_selectlist',str_replace("'$tomonth'","'$tomonth' selected",$month_sl)) ;
		$t->set_var('today_selectlist',str_replace("'$today'","'$today' selected",$day_sl)) ;
		$t->set_var('prcode_selectlist',str_replace("'$prcode'","'$prcode' selected",$prcode_sl)) ;
		$t->set_var('comment',$comment) ;
		$t->set_var('reviewer_selectlist',str_replace("'$reviewer'","'$reviewer' selected",$reviewer_sl)) ;
		$t->set_var('pdyear_selectlist',str_replace("'$pdyear'","'$pdyear' selected",$year_sl)) ;
		$t->set_var('pdmonth_selectlist',str_replace("'$pdmonth'","'$pdmonth' selected",$month_sl)) ;
		$t->set_var('pdday_selectlist',str_replace("'$pdday'","'$pdday' selected",$day_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done") ;	else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ;	else	$t->set_var('delrowno',$row_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('fromyear_fld','fromyear'.$i) ;
		$t->set_var('frommonth_fld','frommonth'.$i) ;
		$t->set_var('fromday_fld','fromday'.$i) ;
		$t->set_var('toyear_fld','toyear'.$i) ;
		$t->set_var('tomonth_fld','tomonth'.$i) ;
		$t->set_var('today_fld','today'.$i) ;
		$t->set_var('prcode_fld','prcode'.$i) ;
		$t->set_var('comment_fld','comment'.$i);
		$t->set_var('reviewer_fld','reviewer'.$i);
		$t->set_var('pdyear_fld','pdyear'.$i) ;
		$t->set_var('pdmonth_fld','pdmonth'.$i) ;
		$t->set_var('pdday_fld','pdday'.$i) ;
		$t->set_var('fromyear_selectlist',$year_sl);
		$t->set_var('frommonth_selectlist',$month_sl) ;
		$t->set_var('fromday_selectlist',$day_sl) ;
		$t->set_var('toyear_selectlist',$year_sl);
		$t->set_var('tomonth_selectlist',$month_sl) ;
		$t->set_var('today_selectlist',$day_sl) ;
		$t->set_var('prcode_selectlist',$prcode_sl) ;
		$t->set_var('comment','') ;
		$t->set_var('reviewer_selectlist',$reviewer_sl) ;
		$t->set_var('pdyear_selectlist',$year_sl);
		$t->set_var('pdmonth_selectlist',$month_sl) ;
		$t->set_var('pdday_selectlist',$day_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

//---- Performance Review Post - PreCommit Routine

    function pr_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')		$adodb->query("DELETE FROM ${pre}pr where empid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['fromyear'.$i]);$i++) {
			$prfrom	=	$dt['fromyear'.$i].'-'.$dt['frommonth'.$i].'-'.$dt['fromday'.$i] ;
			$prto	=	$dt['toyear'.$i].'-'.$dt['tomonth'.$i].'-'.$dt['today'.$i] ;
			$prcode	=	$dt['prcode'.$i] ;
			$comment =	addslashes($dt['comment'.$i]) ;
			$reviewer =	$dt['reviewer'.$i] ;
			$prpd	=	$dt['pdyear'.$i].'-'.$dt['pdmonth'.$i].'-'.$dt['pdday'.$i] ;
			$sql = "INSERT INTO ${pre}pr (empid,prfrom,prto,prcode,comment,reviewer,pddate) " ;
			$sql.= "VALUES ('$id','$prfrom','$prto','$prcode','$comment','$reviewer','$prpd')" ;
			$adodb->query($sql);
			}
		}
	}

    }

?>
