<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.role.inc.php 0.15.1 2005/09/30 C K Wu

    class role {

//---- Role Read

    function role_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$result = $adodb->query("SELECT * FROM ${pre}employee WHERE id='$id'");
	$dt = $result->fetchRow() ;

	$result = $adodb->query("SELECT * FROM ${pre}role where empid='$id' order by rolecode");
	For ($i=1;$rs=$result->fetchRow();$i++)	$dt['rolecode'.$i] = $rs['rolecode'] ;
	return $dt ;
	}

//---- Role Validation Checks

    function role_validate() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error") ;
	$row = exapi_lang("Row") ;
	$AccAdm=$AccMgr=$APAdm=$APMgr=$ARAdm=$ARMgr=$CSAdm=$CSMgr=$HRAdm=$HRMgr= "" ;
	$InvAdm=$InvMgr=$PurAdm=$PurMgr=$SalAdm=$SalMgr=$SvcAdm=$SvcMgr=$SysAdm= "" ;
	For ($i=1;isset($dt['rolecode'.$i]);$i++) {
		switch ($dt['rolecode'.$i]) :
			case "AccAdm" :	if ($AccAdm<>"") $err="[$row $i]".exapi_lang("Duplicate AccAdm role"); $AccAdm=True; break;
			case "AccMgr" :	if ($AccMgr<>"") $err="[$row $i]".exapi_lang("Duplicate AccMgr role"); $AccMgr=True; break;
			case "APAdm" :	if ($APAdm<>"") $err="[$row $i]".exapi_lang("Duplicate APAdm role"); $APAdm=True; break;
			case "APMgr" :	if ($APMgr<>"") $err="[$row $i]".exapi_lang("Duplicate APMgr role"); $APMgr=True; break;
			case "ARAdm" :	if ($ARAdm<>"") $err="[$row $i]".exapi_lang("Duplicate ARAdm role"); $ARAdm=True; break;
			case "ARMgr" :	if ($ARMgr<>"") $err="[$row $i]".exapi_lang("Duplicate ARMgr role"); $ARMgr=True; break;
			case "CSAdm" :	if ($CSAdm<>"") $err="[$row $i]".exapi_lang("Duplicate CSAdm role"); $CSAdm=True; break;
			case "CSMgr" :	if ($CSMgr<>"") $err="[$row $i]".exapi_lang("Duplicate CSMgr role"); $CSMgr=True; break;
			case "HRAdm" :	if ($HRAdm<>"") $err="[$row $i]".exapi_lang("Duplicate HRAdm role"); $HRAdm=True; break;
			case "HRMgr" :	if ($HRMgr<>"") $err="[$row $i]".exapi_lang("Duplicate HRMgr role"); $HRMgr=True; break;
			case "InvAdm" :	if ($InvAdm<>"") $err="[$row $i]".exapi_lang("Duplicate InvAdm role"); $InvAdm=True; break;
			case "InvMgr" :	if ($InvMgr<>"") $err="[$row $i]".exapi_lang("Duplicate InvMgr role"); $InvMgr=True; break;
			case "PurAdm" :	if ($PurAdm<>"") $err="[$row $i]".exapi_lang("Duplicate PurAdm role"); $PurAdm=True; break;
			case "PurMgr" :	if ($PurMgr<>"") $err="[$row $i]".exapi_lang("Duplicate PurMgr role"); $PurMgr=True; break;
			case "SalAdm" :	if ($SalAdm<>"") $err="[$row $i]".exapi_lang("Duplicate SalAdm role"); $SalAdm=True; break;
			case "SalMgr" :	if ($SalMgr<>"") $err="[$row $i]".exapi_lang("Duplicate SalMgr role"); $SalMgr=True; break;
			case "SvcAdm" :	if ($SvcAdm<>"") $err="[$row $i]".exapi_lang("Duplicate SvcAdm role"); $SvcAdm=True; break;
			case "SvcMgr" :	if ($SvcMgr<>"") $err="[$row $i]".exapi_lang("Duplicate SvcMgr role"); $SvcMgr=True; break;
			case "SysAdm" :	if ($SysAdm<>"") $err="[$row $i]".exapi_lang("Duplicate SysAdm role"); $SysAdm=True; break;
			endswitch ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Role Header

    function role_header_write() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_name',exapi_lang('Employee Name/# :'));
	$t->set_var('lang_id',exapi_lang('Audit ID').' :');
	$t->set_var('name',$dt[name]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('disabled','');
	$t->parse('out','report',True);
	}

//---- Write Role Detail

    function role_detail_write() {
	global $ckapi ;

	$app = $ckapi[params][app] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;

	$row_ = exapi_lang('Row')." " ;
	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_insert',exapi_lang('Insert<br>before'));
	$t->set_var('lang_rolecode',exapi_lang("Role Code -- Description") );
	$t->set_var('lang_delete',exapi_lang('Delete'));

	$lang_role = strtolower(exapi_lang('role')) ;
	$rolecode_sl = selectlist('category','name',"WHERE app='$app' and type='$lang_role'",'','name','name','substring(description,1,25)') ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['rolecode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('rolecode_fld','rolecode'.$i) ;
			$t->set_var('rolecode_selectlist',$rolecode_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$rolecode	=	$dt['rolecode'.$i] ;
		$t->set_var('rolecode_fld','rolecode'.$j) ;
		$t->set_var('rolecode_selectlist',str_replace("'$rolecode'","'$rolecode' selected",$rolecode_sl)) ;

		if ($posted)	$t->set_var('insrowno',"done") ; else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ; else	$t->set_var('delrowno',$row_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('rolecode_fld','rolecode'.$i) ;
		$t->set_var('rolecode_selectlist',$rolecode_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

//---- Role Post - PreCommit Routine

    function role_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')		$adodb->query("DELETE FROM ${pre}role where empid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['rolecode'.$i]);$i++) {
			$rolecode = $dt['rolecode'.$i] ;
			$sql = "INSERT INTO ${pre}role (empid,rolecode) " ;
			$sql.= "VALUES ('$id','$rolecode')" ;
			$adodb->query($sql);
			}
		}
	}

    }

?>
