<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// tipcommon.php 0.15.1 2005/06/15 C K Wu

	$app = 'ck-i18n' ;
	$tran = 'tip' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}i18nnew"		) ;
	$ckapi[tables]["parents"] = array("${pre}i18nnew"	=> ""		) ;

	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter = urldecode(stripslashes($filter)) ;
	$proc1 = newobj('ck-api','process1') ;
	$where = $proc1->decode_where($filter) ;
	list($dummy,$module,$dummy,$langcode) = explode("'",$where) ;

	$t = exapi_tpl($app);
	$t->set_file('report','confirm.tpl');
	$t->set_file('msg','message.tpl');

/* ------------- Read and Write Journal Detail --------------------------- */

	$msg.= '<br><br>'.exapi_lang('This action may not retrieve all New Common Phrases') ;
	$msg.= '<br>'.exapi_lang('You may have to add missed New Common Phrases into TIP manually') ;
	$t->set_var('message',$msg);
	$t->pparse('out','msg',True);

	$commonphrases = array() ;
	$commoncnt = array() ;
	$phrases = array() ;
	$marker = 'exapi_lang(';
	$basehdl = opendir($basedir) ;
	while ($module = readdir($basehdl))	{
		if (!strstr($module,'ck-'))					continue ;
		$moddir = $basedir.'/'.$module ;
		if (!is_dir($moddir))						continue ;
		$modhdl = opendir($moddir) ;
		while ($msdir = readdir($modhdl))	{
			if ($msdir=='..')					continue ;
			$modsdir = ($msdir=='.') ? $moddir : $moddir.'/'.$msdir ;
			if (!is_dir($modsdir))					continue ;
			if (strstr('doc,images,setup,templates',$msdir))	continue ;
			$modshdl = opendir($modsdir) ;
			while ($targetfile = readdir($modshdl))	{
				if (!strstr($targetfile,'.php'))		continue ;
				if (strstr($targetfile,'.php~'))		continue ;
				$infile = $modsdir.'/'.$targetfile ;
				$lines = file($infile);
				foreach($lines as $line) {
					if (!strstr($line,$marker))		continue ;
					unset($dummy,$str1,$str2,$str3,$str4,$str5) ;
					list($dummy,$str1,$str2,$str3,$str4,$str5) = explode($marker,$line) ;
					if ($str1)	processstr($str1) ;	else continue ;
					if ($str2)	processstr($str2) ;	else continue ;
					if ($str3)	processstr($str3) ;	else continue ;
					if ($str4)	processstr($str4) ;	else continue ;
					if ($str5)	processstr($str5) ;	else continue ;
					}
				}
			}
		}

	foreach($commonphrases as $key => $val)	if ($commoncnt[$key]<=1)	unset($commonphrases[$key]) ;

	foreach($commonphrases as $key => $val) {
		$skey = addslashes($key) ;	
		$sql = "SELECT * FROM ${pre}i18nnew WHERE module='ck-api' and langcode='$langcode' and i18nkey='$skey'" ;
		$result = $adodb->query($sql);
		if (exapi_dbrc($result)>0)	unset($commonphrases[$key]) ;
		}
	foreach($commonphrases as $key => $val) {	
		$skey = addslashes($key) ;	
		$sql="SELECT * FROM ${pre}i18n WHERE module='ck-api' and langcode='$langcode' and i18nkey='$skey'";
		$result = $adodb->query($sql);
		if (exapi_dbrc($result)>0)	unset($commonphrases[$key]) ;
		}

	$user = $ckapi[hostsys][username];
	$temp = $pre.'tipcommon'.$user.time() ;
	$sql = "CREATE TABLE $temp (module text,langcode text, i18nkey text, i18nval text,header text,iptime text)" ;
	$adodb->query($sql);
	$ip =($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'] ;
	$now = mktime() ;
	$iptime0 = "$ip=$now=$script" ;
	$len_iptime0 = strlen($iptime0) ;

	$sql = ($ckapi[hostsys][dbtype]=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$adodb->query($sql);

	foreach ($commonphrases as $key => $val) {
		if ($langcode<>'en-hk')	$val = '' ;
		$headerarr[$pre.'i18nnew'] = array('module'=>'ck-api','langcode'=>$langcode,'i18nkey'=>$key,'i18nval'=>$val,'control'=>100);
		$header = addslashes(serialize($headerarr));
		$key = addslashes($key) ;
		$val = addslashes($val) ;
		$iptime = "$iptime0=$key" ;
		$sql = "INSERT INTO $temp (module,langcode,i18nkey,i18nval,header,iptime) " ;
		$sql.=		"VALUES ('ck-api','$langcode','$key','$val','$header','$iptime')";
		$adodb->query($sql);
		$sql = "INSERT INTO ${pre}log (app,script,ip,userid,op,timestamp,header,iptime) " ;
		$sql.= "VALUES ('$app','$script','$ip','$user','new','$now','$header','$iptime')";
		$adodb->query($sql) ;
		}
	$sql = "INSERT INTO ${pre}i18nnew " ;
	$sql.= "SELECT id,module,langcode,i18nkey,i18nval,100 FROM $temp a,${pre}log b WHERE a.iptime=b.iptime";
	$adodb->query($sql);
	$sql = "UPDATE ${pre}log SET trans_id=id WHERE substring(iptime,1,$len_iptime0)='$iptime0'";
	$adodb->query($sql);

	$sql = ($ckapi[hostsys][dbtype]=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$adodb->query($sql);

	$adodb->query("DROP TABLE $temp");

/*--------------------Write bottom Section------------------------------------------*/

	$msg1 = count($commonphrases).' '.exapi_lang('New Common Phrases found') ;
//	$msg2 = count($phrases).' '.exapi_lang('Module Phrases found') ;
	$t->set_var('lang_confirm',$msg1);
	$t->set_var('lang_yes',exapi_lang('Done'));
	$t->set_var('lang_no',exapi_lang('Done'));
	$t->set_var('yes_action',exapi_link("/$app/${tran}filter.php")) ;
	$t->set_var('no_action',exapi_link("/$app/${tran}filter.php")) ;

	$t->pparse('out','report',True);
	exapi_footer() ;


    function processstr($str) {
	global $commonphrases, $commoncnt, $phrases, $module ;

	$str = trim($str) ;
	if ($str=="';")					return ;
	list($dummy,$phrase) = explode(chr(ord($str)),$str) ;
	$phrase = stripslashes(trim($phrase)) ;
	$phrasekey = strtolower($phrase) ;

	if (isset($commonphrases[$phrasekey])) 		{$commoncnt[$phrasekey]++ ;return ;}
	if ($phrases[$phrasekey]===$module)		return ;
	if (isset($phrases[$phrasekey])) {
		$commonphrases[$phrasekey] = $phrase ;
		$commoncnt[$phrasekey]++ ;
		unset($phrases[$phrasekey]) ;
		}
	$phrases[$phrasekey] = $module ;
	return ;
	}

?>
