<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.alternate.inc.php 0.15.1 2005/09/30 C K Wu

    class alternate {

//---- Alternate List SQL Formation

    function alternate_list_sql() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$sql =  "SELECT distinct a.* from ${pre}parts a,${pre}alternate b " ;
	$sql.=  "WHERE a.id=b.alternate_id $where order by ".$order." ".$sort ;
	return $sql ;
	}

//---- Alternate Read

    function alternate_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$result = $adodb->query("SELECT control FROM ${pre}parts WHERE id='$id'");
	$dt = $result->fetchRow() ;

	$result = $adodb->query("SELECT * from ${pre}alternate WHERE alternate_id='$id' order by id");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['item_id'.$i] = $rs['item_id'] ;
		$dt['qty'.$i] = $rs['qty'] ;
		}
	$dt[target] = $dt[id] = $id ;
	return $dt ;
	}

//---- Alternate Add Initialisation

    function alternate_add_init() {
	global $ckapi ;

	$ckapi[params_post][dt]['item_id1'] = "" ;
	}


//---- Alternate Validation Checks

    function alternate_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$op = $ckapi[params_post][op] ;

	$err=""; $error=exapi_lang("Error") ;
	if ($op<>'edit')	{
		$result = $adodb->query("SELECT distinct * from ${pre}alternate where alternate_id=$dt[target]");
		if (exapi_dbrc($result)>0)		$err=exapi_lang("Alternate already exists");
		}
	For ($i=1;isset($dt['item_id'.$i]);$i++) {
		$row = exapi_lang("Row") ; $rowi = "[$row $i]" ;
		if ($dt['item_id'.$i]==$dt[target])	$err=$rowi.exapi_lang("Alternate cannot be itself");
		For ($j=1;isset($dt['item_id'.$j]);$j++) {
			$rowij = "[$row $i/$j]" ;
			if ($dt['item_id'.$i]==$dt['item_id'.$j] and $i<>$j)
							$err=$rowij.exapi_lang("Duplicative Alternate");
			}
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Alternate Header

    function alternate_header_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_ginfo',exapi_lang("General Information"));
	$t->set_var('lang_target',exapi_lang("Target Part"));
	$t->set_var('lang_id',exapi_lang("Audit ID").' :');

	$where = (!$uniwhere) ? " WHERE id='$dt[target]' " : $uniwhere;
	$t->set_var('part_sl',selectlist('parts','partnumber',$where,$dt[target],'id','partnumber','description','id')) ;
	if ($dt[target]<>$dt[lasttarget]) {
		$result = $adodb->query("SELECT control FROM ${pre}parts WHERE id='$dt[target]'");
		$dt[control] = exapi_dbflds($result,'control');
		}
	$t->set_var('lasttarget',$dt[target]) ;
	$t->set_var('id',$dt[target]) ;
	$dt[id] = $dt[target] ;
	$t->set_var('control',$dt[control]);
	$t->parse('out','report',True);
	}

//---- Write Alternate Detail

    function alternate_detail_write() {
	global $ckapi ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = exapi_lang('Row')." " ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_alt',exapi_lang('Alternate Part/Service'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$t->set_var('lang_newrow',exapi_lang('Add New Row'));
	$t->set_var('control',$dt[control]);
	$item_list = item_selectlist("",'') ;

	if (isset($delete)) {$rowno = intval(str_replace($row_,"",$delete)); }
	For ($i=1;isset($dt['item_id'.$i]);$i++) {
		if ($i<>$rowno) {
			$item_id = $dt['item_id'.$i] ;
			if (isset($delete) and $i>$rowno) {$j=$i-1;} else {$j=$i;}
			$t->set_var('item_fld','item_id'.$j) ;
			$t->set_var('item_sl',str_replace("'$item_id'","'$item_id' selected",$item_list));
			if ($posted)	$t->set_var('rowno',"done") ;	else $t->set_var('rowno',$row_.$j) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			}
		}
	if ($i==2 and $rowno==1)		$i=1 ;
	if ($i==1)				$newrow=True ;
	if ($newrow) {
		$t->set_var('item_fld','item_id'.$i) ;
		$t->set_var('item_sl',$item_list);
		$t->set_var('rowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->parse('out','report',True);
	}

//---- Alternate Post Initialisation

    function alternate_post_init() {
	global $ckapi ;

	if ($ckapi[params_post][op]=='new')	$ckapi[params_post][op] = 'edit' ;
	}

//---- Alternate Post - PreCommit Routine

    function alternate_post_precommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	$id = $dt[target] ;
	if ($op<>'new')	$adodb->query("DELETE FROM ${pre}alternate WHERE alternate_id=$id");
	if ($op<>'delete') {
		$sql1 = "INSERT INTO ${pre}alternate (alternate_id,item_id) " ;
		For ($i=1;isset($dt['item_id'.$i]);$i++) {
			$item_id	= $dt['item_id'.$i];
			$sql = "$sql1 VALUES ('$id','$item_id')" ;
			$adodb->query($sql);
			}
		}
	}

    }

?>