<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.service.inc.php 0.15.1 2005/09/30 C K Wu

	class service {

//---- Service Read

    function service_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$uniqueflds = $ckapi[params][uniqueflds] ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$result = $adodb->query("select * from ${pre}service where id='$id'");
	$dt = $result->fetchRow() ;
	$sql = "SELECT tax_id FROM ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=1 and a.tax_id=b.id and b.taxgroup='ap'";
	$result = $adodb->query($sql);
	$dt[aptax1] = exapi_dbflds($result,'tax_id') ;
	$sql = "SELECT tax_id FROM ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=2 and a.tax_id=b.id and b.taxgroup='ap'";
	$result = $adodb->query($sql);
	$dt[aptax2] = exapi_dbflds($result,'tax_id') ;
	$sql = "SELECT tax_id FROM ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=1 and a.tax_id=b.id and b.taxgroup='ar'";
	$result = $adodb->query($sql);
	$dt[artax1] = exapi_dbflds($result,'tax_id') ;
	$sql = "SELECT tax_id FROM ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=2 and a.tax_id=b.id and b.taxgroup='ar'";
	$result = $adodb->query($sql);
	$dt[artax2] = exapi_dbflds($result,'tax_id') ;
	$sql = "SELECT tax_id FROM ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=1 and a.tax_id=b.id and b.taxgroup='cs'";
	$result = $adodb->query($sql);
	$dt[cstax1] = exapi_dbflds($result,'tax_id') ;
	$sql = "SELECT tax_id FROM ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=2 and a.tax_id=b.id and b.taxgroup='cs'";
	$result = $adodb->query($sql);
	$dt[cstax2] = exapi_dbflds($result,'tax_id') ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- Service Addition Initiation

    function service_add_init() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$result = $adodb->query("select * from ${pre}defaults");
	$ckapi[params_post][dt][income_accno_id] =  exapi_dbflds($result,'income_accno_id') ;
	$ckapi[params_post][dt][expense_accno_id] =  exapi_dbflds($result,'expense_accno_id') ;
	}
	
//---- Service Detail Validation Checks

    function service_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error") ;
	if ($dt[servicenumber]=="")			$err=exapi_lang("Service Name/Number Missing");
	if ($dt[listprice] and !is_numeric($dt[listprice]))
							$err=exapi_lang("Invalid list price, must be numeric");
	if ($dt[price] and !is_numeric($dt[price]))	$err=exapi_lang("Invalid selling price, must be numeric");
	if ($dt[cost] and !is_numeric($dt[cost]))	$err=exapi_lang("Invalid Cost, must be numeric") ;
	if ($dt[listprice] and $dt[price] and ($dt[listprice]<$dt[price]))
							$err=exapi_lang("List Price < Selling Price") ;
	if ($dt[servicenumber]<>$dt[oldservicenumber]) {
		$result = $adodb->query("SELECT * FROM ${pre}service where servicenumber='$dt[servicenumber]'");
		if (exapi_dbrc($result)>0)		$err=exapi_lang("Service Name/# already exists") ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Service Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	$invoice = exapi_lang('invoice') ; $order = exapi_lang('order');
	$quote = exapi_lang('quotation'); $cashsale = exapi_lang('cash sale') ;
	$errmsg1 = exapi_lang("This service item is in use within an existing") ;
	$id = $dt[id] ;
	$result = $adodb->query("SELECT * from ${pre}invoice WHERE itemid='$id'");
	if (exapi_dbrc($result)>0)	$err = "$errmsg1 $invoice id#".exapi_dbflds($result,'trans_id') ;
	$result = $adodb->query("SELECT * from ${pre}oitem WHERE itemid='$id'");
	if (exapi_dbrc($result)>0)	$err = "$errmsg1 $order/$quote id#".exapi_dbflds($result,'trans_id') ;
	$result = $adodb->query("SELECT * from ${pre}positem WHERE itemid='$id'");
	if (exapi_dbrc($result)>0)	$err = "$errmsg1 $cashsale id#".exapi_dbflds($result,'trans_id') ;
	
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Service Detail

    function service_write() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_tbi',exapi_lang("(To be implemented)"));
	$t->set_var('lang_ginfo',exapi_lang("General Information"));
	$t->set_var('lang_number',exapi_lang("Name/Number"));
	$t->set_var('lang_description',exapi_lang("Description"));
	$t->set_var('lang_id',exapi_lang("Audit ID").' :');
	$t->set_var('lang_quantity',exapi_lang("Quantity"));
	$t->set_var('lang_unit',exapi_lang("Unit"));
	$t->set_var('lang_pricecost',exapi_lang("Price/Cost"));
	$t->set_var('lang_listprice',exapi_lang("List Price"));
	$t->set_var('lang_price',exapi_lang("Selling Price"));
	$t->set_var('lang_priceupdate',exapi_lang("Price Last Updated on"));
	$t->set_var('lang_cost',exapi_lang("Standard Cost"));
	$t->set_var('lang_costupdate',exapi_lang("Cost Last Updated on"));
	$t->set_var('lang_notes',exapi_lang("Notes"));
	$t->set_var('lang_linkageaccount',exapi_lang("Link to Ledger Accounts"));
	$t->set_var('lang_income_accno',exapi_lang("Income"));
	$t->set_var('lang_expense_accno',exapi_lang("Expense"));
	$t->set_var('lang_aptax1',exapi_lang("Primary Tax Paid to Vendor"));
	$t->set_var('lang_aptax2',exapi_lang("Secondary Tax Paid to Vendor"));
	$t->set_var('lang_artax1',exapi_lang("Primary Tax from Customer"));
	$t->set_var('lang_artax2',exapi_lang("Secondary Tax from Customer"));
	$t->set_var('lang_cstax1',exapi_lang("Primary Tax for Cash Sale"));
	$t->set_var('lang_cstax2',exapi_lang("Secondary Tax for Cash Sale"));
	$t->set_var('lang_reserved',exapi_lang("Reserved Space")) ;

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('servicenumber',$dt[servicenumber]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('description',$dt[description]);
	$t->set_var('notes',$dt[notes]);
	$t->set_var('unit',$dt[unit]);
	$t->set_var('listprice',$dt[listprice]);
	$t->set_var('price',$dt[price]);
	$t->set_var('oldprice',$dt[oldprice]);
	$t->set_var('priceupdate',$dt[priceupdate]);
	$t->set_var('cost',$dt[cost]);
	$t->set_var('oldcost',$dt[oldcost]);
	$t->set_var('costupdate',$dt[costupdate]);
	$inc_accno = $dt[income_accno_id] ;
	$t->set_var('income_accno',$inc_accno);
	$t->set_var('inc_acc_option_block', selectlist('chart','accno',"WHERE link like '%SV_income%'",$inc_accno,'id','accno','description'));
	$exp_accno = $dt[expense_accno_id] ;
	$t->set_var('expense_accno',$exp_accno);
	$t->set_var('exp_acc_option_block',selectlist('chart','accno',"WHERE link like '%SV_expense%'",$exp_accno,'id','accno','description'));
	$notax = "<OPTION value=''>".exapi_lang('No Tax')."</OPTION>" ;
	$rate = ($ckapi[hostsys][dbtype]=="mysql") ? "concat(rate*100,'%')" : "(rate*100||'%')" ;
	$t->set_var('aptax1_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='ap'",$dt[aptax1],'id',$rate,'taxnumber','id'));
	$t->set_var('aptax2_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='ap'",$dt[aptax2],'id',$rate,'taxnumber','id'));
	$t->set_var('artax1_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='ar'",$dt[artax1],'id',$rate,'taxnumber','id'));
	$t->set_var('artax2_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='ar'",$dt[artax2],'id',$rate,'taxnumber','id'));
	$t->set_var('cstax1_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='cs'",$dt[cstax1],'id',$rate,'taxnumber','id'));
	$t->set_var('cstax2_selectlist',$notax.selectlist('tax','taxnumber',"WHERE taxgroup='cs'",$dt[cstax2],'id',$rate,'taxnumber','id'));

	$t->parse('out','report',True);
	}

//---- Service Post Initialisation

    function service_post_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$op = &$ckapi[params_post][op] ;

	$dt[priceupdate] = ($dt[oldprice]<>$dt[price] or $op=='new') ? date("Y-m-d") : $dt[priceupdate] ;
	$dt[costupdate] = ($dt[oldcost]<>$dt[cost] or $op=='new') ? date("Y-m-d") : $dt[costupdate] ;
	}

//---- Service Post - PreCommit Routine

    function service_post_precommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	if ($op<>'new')		$adodb->query("DELETE FROM ${pre}itemtax WHERE item_id=$id") ;
	if ($op<>'delete') {
		$sql="INSERT INTO ${pre}itemtax (item_id,tax_id,taxtype) " ;
		if ($dt[aptax1]<>"")	$adodb->query("$sql VALUES ('$id','$dt[aptax1]','1')");
		if ($dt[aptax2]<>"")	$adodb->query("$sql VALUES ('$id','$dt[aptax2]','2')");
		if ($dt[artax1]<>"")	$adodb->query("$sql VALUES ('$id','$dt[artax1]','1')");
		if ($dt[artax2]<>"")	$adodb->query("$sql VALUES ('$id','$dt[artax2]','2')");
		if ($dt[cstax1]<>"")	$adodb->query("$sql VALUES ('$id','$dt[cstax1]','1')");
		if ($dt[cstax2]<>"")	$adodb->query("$sql VALUES ('$id','$dt[cstax2]','2')");
		}
	}

    }

?>
