<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.sqmatch.inc.php 0.15.1 2005/09/30 C K Wu

    class sqmatch {

//---- SQmatch List SQL Formation

    function sqmatch_list_sql() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$db_type = $ckapi[hostsys][dbtype] ;

	$last10 = substr($where,strlen($where)-10,10) ;
	$fields = "transdate,name,sonumber,isocode,amount,a.id" ;
	if ($last10==' AND OPEN '){
		$where = substr($where,0,strlen($where)-10) ;
		$sql1 =	"SELECT $fields FROM ${pre}so a, ${pre}customer b WHERE 1=1 $where AND a.customer=b.id " ;
		$sql2 =	"SELECT $fields FROM ${pre}so a,${pre}customer b,${pre}sqmatch c " ;
		$sql2.=	"WHERE 1=1 $where AND a.customer=b.id AND a.id=c.soid " ;
		$sql2.=	"GROUP BY $fields HAVING sum(a_amount)>=amount " ;
		if ($db_type=="mysql")	{
			$user = $ckapi[hostsys][username] ;
			$ckapi[params_sql][temp1] = $temp1 = "${pre}sql1".$user.time() ;
			$ckapi[params_sql][temp2] = $temp2 = "${pre}sql2".$user.time() ;
			$adodb->query("CREATE TABLE $temp1 AS $sql1");
			$adodb->query("CREATE TABLE $temp2 AS $sql2");
			$sql = "SELECT $temp1.* from $temp1 LEFT JOIN $temp2 " ;
			$sql.= "ON $temp1.id=$temp2.id WHERE $temp2.id IS NULL" ;
			}
			else	$sql="$sql1 EXCEPT $sql2 ORDER BY $order $sort" ;
		}
	   else	$sql =  "SELECT $fields FROM ${pre}so a, ${pre}customer b WHERE 1=1 $where AND a.customer=b.id ORDER BY $order $sort" ;
	return $sql ;
	}

//---- SQmatch Data Read

    function sqmatch_read() {
	global $ckapi ;

	$op = $ckapi[params_post][op] ;
	$this->sqmatch_header_read() ;
	$this->sqmatch_allotted_read() ;
	$this->sqmatch_pending_read() ;
	return $ckapi[params_post][dt] ;
	}

//---- SQmatch Data Header Read

    function sqmatch_header_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$dt = &$ckapi[params_post][dt] ;

	$result = $adodb->query("SELECT * FROM ${pre}so WHERE id='$id'");
	$dt = $result->fetchRow() ;
	}

//---- SQmatch Data (Allotment) Read

    function sqmatch_allotted_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$dt = &$ckapi[params_post][dt] ;

	$sql = "SELECT quotenumber,id,duedate,amount,a_amount FROM ${pre}quote, ${pre}sqmatch " ;
	$sql.= "WHERE soid='$id' and id=quoteid and customer='$dt[customer]' and isocode='$dt[isocode]'";
	$result = $adodb->query($sql);
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['aquotenumber'.$i]	=	$rs['quotenumber'] ;
		$dt['aquoteid'.$i]	=	$rs['id'] ;
		$dt['aduedate'.$i]	=	$rs['duedate'] ;
		$dt['aquoteamount'.$i]	=	$rs['amount'] ;
		$dt['aa_amount'.$i]	=	$rs['a_amount'] ;
		$dt['anewaamount'.$i]	=	"" ;
		}
	}

//---- SQmatch Data (Pending) Read

    function sqmatch_pending_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	$dt = &$ckapi[params_post][dt] ;

	$user = $ckapi[hostsys][username];
	$temp1 = "${pre}sq1".$user.time() ;
	$temp2 = "${pre}sq2".$user.time() ;
	$format = '000000000000.00' ;
	$sql = "CREATE TABLE $temp1 AS " ;
	$fields = "quotenumber,id,duedate" ;
	$sql.="SELECT $fields,amount,$format as a_amount,$format as acceptedamount " ;
	$sql.="FROM ${pre}quote WHERE customer='$dt[customer]' and isocode='$dt[isocode]'";
	$adodb->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT $fields,0.00 as amount,a_amount,0.00 as acceptedamount " ;
	$sql.= "FROM ${pre}quote, ${pre}sqmatch WHERE id=quoteid and soid='$id'";
	$adodb->query($sql);
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT $fields,0.00 as amount,0.00 as a_amount,sum(a_amount) as acceptedamount " ;
	$sql.= "FROM ${pre}quote a, ${pre}sqmatch b ";
	$sql.= "WHERE customer='$dt[customer]' and a.id=b.quoteid GROUP BY $fields";
	$adodb->query($sql);
	$sql = "CREATE TABLE $temp2 AS " ;
	$sql.= "SELECT $fields,sum(amount) as amount,sum(a_amount) as a_amount,sum(acceptedamount) as acceptedamt ";
	$sql.= "FROM $temp1 GROUP BY $fields";
	$adodb->query($sql);
	$sql = "SELECT * FROM $temp2 WHERE amount > 0 ORDER BY quotenumber" ;
	$result = $adodb->query($sql) ;
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$quoteamount		=	$rs['amount'] ;
		$acceptedamt		=	$rs['acceptedamt'] ;
		$dt['pdquotenumber'.$i]	=	$rs['quotenumber'] ;
		$dt['pdquoteid'.$i]	=	$rs['id'] ;
		$dt['pdduedate'.$i]	=	$rs['duedate'] ;
		$dt['pdquoteamount'.$i]	=	$quoteamount ;
		$a_amount = ($op=='add' or $op=='copy') ? 0 : $rs['a_amount'] ;
		$dt['pda_amount'.$i]	=	$a_amount ;
		$dt['pda_othamt'.$i]	=	$acceptedamt - $a_amount ;
		$dt['pdacceptedamt'.$i]	=	$acceptedamt ;
		$dt['pdosamount'.$i]	=	$quoteamount - $acceptedamt ;
		}
	$adodb->query("DROP TABLE $temp1, $temp2");
	}

//---- SQmatch Data Transformation

    function sqmatch_transform() {
	global $ckapi ;

	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;

	if (isset($clear))		{$msg = $this->match_clear() ; $t->set_var('message1',$msg) ;}
	if (isset($match_equal))	{$msg = $this->match_equal() ; $t->set_var('message1',$msg) ;}
	if (isset($match_fifo))		{$msg = $this->match_fifo() ; $t->set_var('message1',$msg) ;}
	}

//---- sqmatch Detail Validation Checks

    function sqmatch_validate() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error");
	$row = exapi_lang("Row") ;
	$sum_anewaamt = 0 ;
	For ($i=1;isset($dt['aquoteid'.$i]);$i++) {
		$anewaamt = $dt['anewaamount'.$i] ;
		$rowi = "[$row $i]" ;
		if ($anewaamt<0)		$err=$rowi.exapi_lang("New Amount Accepted must be +ve");
		if ($anewaamt>$dt[amount])	$err=$rowi.exapi_lang("New Amount Accepted > SO Amt");
		if (!is_numeric($anewaamt) and strlen($anewaamt)>0)
						$err=$rowi.exapi_lang("New Amt Accepted must be numeric");
		$sum_anewaamt += ($anewaamt=="") ? $dt['aa_amount'.$i] : $anewaamt ;
		}
	$sum_anewaamt2 = sprintf("%01.2f",$sum_anewaamt) ;
	$dt_amount2 = sprintf("%01.2f",$dt[amount]) ;
	if ($sum_anewaamt2>$dt_amount2)		$err=exapi_lang('Total Amount Accepted > SO Amount');
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write SQmatch (Sales Order) Header

    function sqmatch_header_write() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$result = $adodb->query("SELECT nativecurr FROM ${pre}defaults");
	$loc_for = (exapi_dbflds($result,'nativecurr')==$dt[isocode]) ? exapi_lang('Local') : exapi_lang('*** Foreign ***') ;
	$t->set_var('lang_customer',exapi_lang('Customer'));
	$t->set_var('lang_sonumber',exapi_lang('Sales Order#:'));
	$t->set_var('lang_id',exapi_lang('Audit ID').':');
	$t->set_var('lang_curr_so',exapi_lang('Currency Sales Order'));
	$t->set_var('lang_loc_for',$loc_for);
	$t->set_var('lang_amount',exapi_lang('SO Amount:'));
	$t->set_var('lang_transdate',exapi_lang('SO Date:'));
	$t->set_var('lang_duedate',exapi_lang('Due Date:'));
	$t->set_var('lang_isocode',exapi_lang('Currency'));
	$t->set_var('lang_exrate',exapi_lang('Exchange Rate'));
	$t->set_var('customer',$dt[customer]) ;
	$t->set_var('customer_selectlist',selectlist('customer','name',"WHERE id=$dt[customer]",'','id','name','id')) ;
	$t->set_var('sonumber',$dt[sonumber]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('amount',$dt[amount]) ;
	$t->set_var('transdate',$dt[transdate]) ;
	$t->set_var('duedate',$dt[duedate]) ;
	$t->set_var('isocode_selectlist',selectlist('currency','isocode',"WHERE isocode='$dt[isocode]'",'','isocode','isocode','description')) ;
	$t->set_var('exrate',$dt[exrate]) ;
	$t->parse('out','report',True);
	}

//---- Write Sqmatch Detail

    function sqmatch_detail_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	if ($op=="view" or $op=="delete")       $posted = True ;
	$t->set_block('report','acceptedlist','acceptedlist_section');
	$t->set_block('report','pendinglist','pendinglist_section');
	$moverow_ = exapi_lang('Move Row')." " ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_altitle',exapi_lang('List of Fully/Partially ACCEPTED %1 Quotation confirmed by this SO',$dt[isocode]));
	$t->set_var('lang_aquotenumber',exapi_lang('Quotation#'));
	$t->set_var('lang_aquoteid',exapi_lang('Quotation ID'));
	$t->set_var('lang_aduedate',exapi_lang('Due Date'));
	$t->set_var('lang_afullamount',exapi_lang('Full Quotation Amount'));
	$t->set_var('lang_aacepted',exapi_lang('Amount Accepted<br>via this SO'));
	$t->set_var('lang_anewaamount',exapi_lang('Amount Accepted via this<br>SO to be Updated to'));
	$sum_aquoteamount = $sum_aa_amount = $sum_anewaamount = 0 ;
	For ($i=1;isset($dt['aquoteid'.$i]);$i++) {
		$t->set_var('aquotenumber_fld','aquotenumber'.$i);
		$t->set_var('aquoteid_fld','aquoteid'.$i);
		$t->set_var('aduedate_fld','aduedate'.$i);
		$t->set_var('aquoteamount_fld','aquoteamount'.$i);
		$t->set_var('aa_amount_fld','aa_amount'.$i) ;
		$t->set_var('anewaamount_fld','anewaamount'.$i);
		$t->set_var('aquotenumber',$dt['aquotenumber'.$i]) ;
		$aquoteid = $dt['aquoteid'.$i] ;
		$t->set_var('aquoteid',$aquoteid) ;
		$t->set_var('aduedate',$dt['aduedate'.$i]) ;
		$t->set_var('aquoteamount',$dt['aquoteamount'.$i]) ;
		$t->set_var('aa_amount',$dt['aa_amount'.$i]) ;
		$anewaamount = $dt['anewaamount'.$i] ;
		if (is_numeric($anewaamount))		$t->set_var('anewaamount',"") ;
			else				$t->set_var('anewaamount',$anewaamount) ;
		if (strlen($anewaamount)>0 and is_numeric($anewaamount)) {
			For ($j=1;isset($dt['pdquoteid'.$j]);$j++) {
				if ($aquoteid==$dt['pdquoteid'.$j]) {
					$dt['pda_amount'.$j] = $anewaamount ;
					$dt['pdacceptedamt'.$j]= $dt['pda_amount'.$j] + $dt['pda_othamt'.$j];
					$dt['pdosamount'.$j] = $dt['pdquoteamount'.$j] - $dt['pdacceptedamt'.$j] ;
					break ;
					}
				}
			if (!isset($dt['pdquoteid'.$j])) {
				$user = $ckapi[hostsys][username];
				$tmp = "${pre}ism".$user.time() ;
				$fields = "quotenumber,id,duedate,amount" ;
				$sql = "CREATE TABLE $tmp AS " ;
				$sql.=	"SELECT $fields,0.00 as a_amount,sum(a_amount) as acceptedamt ";
				$sql.=	"FROM ${pre}quote,${pre}sqmatch " ;
				$sql.=	"WHERE id='$aquoteid' and quoteid='$aquoteid' GROUP BY $fields" ;
				$adodb->query($sql);
				$sql = "INSERT INTO $tmp " ;
				$sql.=	"SELECT $fields,a_amount,0.00 as acceptedamt " ;
				$sql.=	"FROM ${pre}quote,${pre}sqmatch ";
				$sql.=	"WHERE id='$aquoteid' and quoteid='$aquoteid' and soid='$dt[id]' " ;
				$adodb->query($sql);
				$sql = "SELECT $fields,sum(a_amount) as a_amount,sum(acceptedamt) as acceptedamt " ;
				$sql.= "FROM $tmp GROUP BY $fields " ;
				$result = $adodb->query($sql) ;

				While ($rs=$result->fetchRow()) {
					$dt['pdquotenumber'.$j]	=	$rs['quotenumber'] ;
					$dt['pdquoteid'.$j]	=	$rs['id'] ;
					$dt['pdduedate'.$j]	=	$rs['duedate'] ;
					$dt['pdquoteamount'.$j]	=	$rs['amount'] ;
					$dt['pda_amount'.$j]	=	$anewaamount ;
					$dt['pda_othamt'.$j]	=	$rs['acceptedamt']-$rs['a_amount'];
					$dt['pdacceptedamt'.$j]	=	$dt['pda_amount'.$j] + $dt['pda_othamt'.$j];
					$dt['pdosamount'.$j]	=	$dt['pdquoteamount'.$j] - $dt['pdacceptedamt'.$j] ;
					$j++ ;
					}
				$adodb->query("DROP TABLE $tmp");
				}
			$t->set_var('aa_amount',$anewaamount) ;
			$dt['aa_amount'.$i] = $anewaamount ;
			}
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('acceptedlist_section','acceptedlist', True);
		$sum_aquoteamount	+= $dt['aquoteamount'.$i] ;
		$sum_aa_amount		+= $dt['aa_amount'.$i] ;
		}
	if ($i==1)	$t->set_var('acceptedlist_section',"");
	$movrowno = intval(str_replace($moverow_,"",$dt[move])) ;
	if ($movrowno<>0) {
		$t->set_var('aquotenumber_fld','aquotenumber'.$i);
		$t->set_var('aquoteid_fld','aquoteid'.$i);
		$t->set_var('aduedate_fld','aduedate'.$i);
		$t->set_var('aquoteamount_fld','aquoteamount'.$i);
		$t->set_var('aa_amount_fld','aa_amount'.$i) ;
		$t->set_var('anewaamount_fld','anewaamount'.$i);
		$t->set_var('aquotenumber',$dt['pdquotenumber'.$movrowno]) ;
		$t->set_var('aquoteid',$dt['pdquoteid'.$movrowno]) ;
		$t->set_var('aduedate',$dt['pdduedate'.$movrowno]) ;
		$t->set_var('aquoteamount',$dt['pdquoteamount'.$movrowno]) ;
		$t->set_var('aa_amount',0) ;
		$t->set_var('anewaamount',"") ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('acceptedlist_section','acceptedlist', True);
		$sum_aquoteamount	+= $dt['pdquoteamount'.$movrowno] ;
		}
	$msg = ($dt[amount]>$sum_aa_amount) ? exapi_lang("[SO underallocated to Quotation]") : "" ;
	$t->set_var('lang_total',exapi_lang('Total Amount')." <b>".$msg."</b>");
	$t->set_var('sum_aquoteamount',$sum_aquoteamount);
	$t->set_var('sum_aa_amount',$sum_aa_amount);
	$t->set_var('sum_anewaamount',$sum_anewaamount);
	$t->set_var('lang_pdltitle',exapi_lang('List of %1 Quotations accrued on this customer',$dt[isocode]));
	$t->set_var('lang_pdquotenumber',exapi_lang('Quotation#'));
	$t->set_var('lang_pdquoteid',exapi_lang('Quotation ID'));
	$t->set_var('lang_pdduedate',exapi_lang('Due Date'));
	$t->set_var('lang_pdfullamount',exapi_lang('Full Quotation Amount'));
	$t->set_var('lang_pda_amount',exapi_lang('Amount Accepted via this SO'));
	$t->set_var('lang_pda_othamt',exapi_lang('Amount Accepted via other SOs'));
	$t->set_var('lang_pdacceptedamt',exapi_lang('Total Amount Accepted'));
	$t->set_var('lang_pdosamount',exapi_lang('Outstanding Pending Amount'));
	$t->set_var('lang_pdmove2accepted',exapi_lang('Move to Accepted List'));
	For ($i=1;isset($dt['pdquoteid'.$i]);$i++) {
		$t->set_var('pdquotenumber_fld','pdquotenumber'.$i);
		$t->set_var('pdquoteid_fld','pdquoteid'.$i);
		$t->set_var('pdduedate_fld','pdduedate'.$i);
		$t->set_var('pdquoteamount_fld','pdquoteamount'.$i);
		$t->set_var('pda_amount_fld','pda_amount'.$i);
		$t->set_var('pda_othamt_fld','pda_othamt'.$i);
		$t->set_var('pdacceptedamt_fld','pdacceptedamt'.$i) ;
		$t->set_var('pdosamount_fld','pdosamount'.$i);
		$t->set_var('pdquotenumber',$dt['pdquotenumber'.$i]) ;
		$t->set_var('pdquoteid',$dt['pdquoteid'.$i]) ;
		$t->set_var('pdduedate',$dt['pdduedate'.$i]) ;
		$t->set_var('pdquoteamount',$dt['pdquoteamount'.$i]) ;
		$t->set_var('pda_amount',$dt['pda_amount'.$i]) ;
		$t->set_var('pda_othamt',$dt['pda_othamt'.$i]) ;
		$t->set_var('pdacceptedamt',$dt['pdacceptedamt'.$i]) ;
		$t->set_var('pdosamount',$dt['pdosamount'.$i]) ;
		$t->set_var('rowno',$moverow_.$i) ;
		For ($j=1;isset($dt['aquoteid'.$j]);$j++)
			if ($dt['pdquoteid'.$i]==$dt['aquoteid'.$j])
				$t->set_var('rowno',exapi_lang("already in the list"));
		if ($movrowno==$i)		$t->set_var('rowno',exapi_lang("already in the list")) ;
		if ($posted)			$t->set_var('rowno',"done") ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('pendinglist_section','pendinglist', True);
		}
	if ($i==1)	$t->set_var('pendinglist_section',"");
	}

//---- Perform SO/Quotation Matching on Balance Amount by Matching Equal Amount

    function match_equal() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;

	/* no empty quotation pending list handling */
	$temp = $dt ;
	For ($j=1;isset($dt['pdquoteid'.$j]);$j++)	$duedate[$j] = $temp['pdduedate'.$j] ;
	asort($duedate) ;
	reset($duedate) ;
	$j = 1 ;
	while (list($key,$val)=each($duedate)) {
		$dt['pdquotenumber'.$j]	=	$temp['pdquotenumber'.$key] ;
		$dt['pdquoteid'.$j]	=	$temp['pdquoteid'.$key] ;
		$dt['pdduedate'.$j]	=	$val ;
		$dt['pdquoteamount'.$j]	=	$temp['pdquoteamount'.$key] ;
		$dt['pda_amount'.$j]	=	$temp['pda_amount'.$key] ;
		$dt['pda_othamt'.$j]	=	$temp['pda_othamt'.$key] ;
		$dt['pdacceptedamt'.$j]	=	$temp['pdacceptedamt'.$key] ;
		$dt['pdosamount'.$j]	=	$temp['pdosamount'.$key] ;
		$j++ ;
		}
	$bal = $dt[amount] ;
	For ($i=1;isset($dt['aquoteid'.$i]);$i++)	{
		$bal -= $dt['aa_amount'.$i] ;
		$dt['anewaamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = exapi_lang("SO is alreadly fully allocated") ;
	   else {
		For ($j=1;isset($dt['pdquoteid'.$j]);$j++) {
			if ($dt['pdosamount'.$j]==$bal) {
				$dt['pda_amount'.$j] += $bal ;
				$dt['pdacceptedamt'.$j] += $bal ;
				$dt['pdosamount'.$j]  = 0 ;
				$quoteid = $dt['pdquoteid'.$j] ;
				For ($i=1;isset($dt['aquoteid'.$i]);$i++) {
					if ($dt['aquoteid'.$i]==$quoteid) {
						$dt['aa_amount'.$i] += $bal ;
						$dt['anewaamount'.$i] = "" ;
						break ;
						}
					}
				if (!isset($dt['aquoteid'.$i])) {
					$dt['aquotenumber'.$i]	= $dt['pdquotenumber'.$j] ;
					$dt['aquoteid'.$i]	= $dt['pdquoteid'.$j] ;
					$dt['aduedate'.$i]	= $dt['pdduedate'.$j] ;
					$dt['aquoteamount'.$i]	= $dt['pdquoteamount'.$j];
					$dt['aa_amount'.$i]	= $bal ;
					$dt['anewaamount'.$i]	= "" ;
					}
				break ;
				}
			}
		}
	if (isset($dt['pdquoteid'.$j]))
		$message3 = exapi_lang("Matching completed.  If result OK, click POST button to update.") ;
	$message = exapi_lang("No (equal) matching item found") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	if (isset($message3))		$message = $message3 ;
	return "<b>$message</b>" ;
	}

//---- Perform SO/Quotation Matching on Balance Amount by FIFO Scheme

    function match_fifo() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;

	/* no empty quotation pending list handling */
	$temp = $dt ;
	For ($j=1;isset($dt['pdquoteid'.$j]);$j++)	$duedate[$j] = $temp['pdduedate'.$j] ;
	asort($duedate) ;
	reset($duedate) ;
	$j = 1 ;
	while (list($key,$val)=each($duedate)) {
		$dt['pdquotenumber'.$j]	=	$temp['pdquotenumber'.$key] ;
		$dt['pdquoteid'.$j]	=	$temp['pdquoteid'.$key] ;
		$dt['pdduedate'.$j]	=	$val ;
		$dt['pdquoteamount'.$j]	=	$temp['pdquoteamount'.$key] ;
		$dt['pda_amount'.$j]	=	$temp['pda_amount'.$key] ;
		$dt['pda_othamt'.$j]	=	$temp['pda_othamt'.$key] ;
		$dt['pdacceptedamt'.$j]	=	$temp['pdacceptedamt'.$key] ;
		$dt['pdosamount'.$j]	=	$temp['pdosamount'.$key] ;
		$j++ ;
		}

	$bal = $dt[amount] ;
	For ($i=1;isset($dt['aquoteid'.$i]);$i++)	{
		$bal -= $dt['aa_amount'.$i] ;
		$dt['anewaamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = exapi_lang("SO is alreadly fully allocated") ;
	   else {
		For ($j=1;isset($dt['pdquoteid'.$j]);$j++) {
			$pdosamt = $dt['pdosamount'.$j] ;
			if ($pdosamt>0) {
				if ($bal>=$pdosamt) {
					$dt['pda_amount'.$j] += $pdosamt ;
					$dt['pdacceptedamt'.$j] += $pdosamt ;
					$dt['pdosamount'.$j]  = 0 ;
					$quoteid = $dt['pdquoteid'.$j] ;
					For ($i=1;isset($dt['aquoteid'.$i]);$i++) {
						if ($dt['aquoteid'.$i]==$quoteid) {
							$dt['aa_amount'.$i] += $pdosamt ;
							$dt['anewaamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($dt['aquoteid'.$i])) {
						$dt['aquotenumber'.$i]	= $dt['pdquotenumber'.$j] ;
						$dt['aquoteid'.$i]	= $quoteid ;
						$dt['aduedate'.$i]	= $dt['pdduedate'.$j] ;
						$dt['aquoteamount'.$i]	= $dt['pdquoteamount'.$j];
						$dt['aa_amount'.$i]	+= $pdosamt ;
						$dt['anewaamount'.$i]	= "" ;
						}
					$bal -= $pdosamt ;
					}
				   else {
					$dt['pda_amount'.$j] += $bal ;
					$dt['pdacceptedamt'.$j] += $bal ;
					$dt['pdosamount'.$j]  -= $bal ;
					$quoteid = $dt['pdquoteid'.$j] ;
					For ($i=1;(isset($dt['aquoteid'.$i]) and $bal>0);$i++) {
						if ($dt['aquoteid'.$i]==$quoteid) {
							$dt['aa_amount'.$i] += $bal ;
							$dt['anewaamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($dt['aquoteid'.$i])) {
						$dt['aquotenumber'.$i]	= $dt['pdquotenumber'.$j] ;
						$dt['aquoteid'.$i]	= $quoteid ;
						$dt['aduedate'.$i]	= $dt['pdduedate'.$j] ;
						$dt['aquoteamount'.$i]	= $dt['pdquoteamount'.$j];
						$dt['aa_amount'.$i]	= $bal ;
						$dt['anewaamount'.$i]	= "" ;
						}
					$bal = 0 ;
					}
				}
			}
		}
	$message = exapi_lang("Matching completed.  If result OK, click POST button to update.") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	return "<b>$message</b>" ;
	}

//---- Clear current on-screen SO/Quotation Matching

    function match_clear() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;

	For ($i=1;isset($dt['aquoteid'.$i]);$i++)	{
		$quoteid = $dt['aquoteid'.$i] ;
		$aaamt = $dt['aa_amount'.$i] ;
		For ($j=1;isset($dt['pdquoteid'.$j]);$j++) {
			if ($dt['pdquoteid'.$j]==$quoteid) {
				$dt['pda_amount'.$j] = 0 ;
				$dt['pdacceptedamt'.$j] -= $aaamt ;
				$dt['pdosamount'.$j]  += $aaamt ;
				break ;
				}
			}
		if (!isset($dt['pdquoteid'.$j])) {
			$dt['pdquotenumber'.$j]	=	$dt['aquotenumber'.$i] ;
			$dt['pdquoteid'.$j]	=	$quoteid ;
			$dt['pdduedate'.$j]	=	$dt['aduedate'.$i] ;
			$dt['pdquoteamount'.$j]	=	$dt['aquoteamount'.$i] ;
			$dt['pda_amount'.$j]	=	0 ;
			$dt['pda_othamt'.$j]	=	$dt['aquoteamount'.$i] - $aaamt ;
			$dt['pdacceptedamt'.$j]	=	$dt['pda_othamt'.$j] ;
			$dt['pdosamount'.$j]	=	$aaamt ;
			}
		unset($dt['aquoteid'.$i]) ;
		}
	$message = exapi_lang("All (on-screen) matchings for current SO cleared") ;
	return "<b>$message</b>" ;
	}

//---- SQmatch Post - PreCommit Routine

    function sqmatch_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$id = &$ckapi[params_post][id] ;
	$op = &$ckapi[params_post][op] ;

	$adodb->query("DELETE from ${pre}sqmatch where soid=$id");
	if ($op<>'clear') {
		For ($i=1;isset($dt['aquoteid'.$i]);$i++) {
			$a_amt = $dt['anewaamount'.$i]=="" ? $dt['aa_amount'.$i] : $dt['anewaamount'.$i] ;
			if ($a_amt<>0) {
				$quoteid = $dt['aquoteid'.$i] ;
				$sql = "INSERT INTO ${pre}sqmatch (quoteid,soid,a_amount) " ;
				$sql.= "VALUES ('$quoteid','$id','$a_amt')";
				$adodb->query($sql);
				}
			}
		}
	}

    }

?>

