<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.payroll.inc.php 0.15.1 2005/09/30 C K Wu

    class payroll {

//---- Payroll List SQL Formation

    function payroll_list_sql() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$lang_from = strtolower(exapi_lang('*from*')) ;
	$lang_to = strtolower(exapi_lang('*to*')) ;
	$frommarker = $lang_from.'::' ;  $frmarkerlen=strlen($frommarker);
	$tomarker = $lang_to.'::' ;  $tomarkerlen = strlen($tomarker) ;
	$frompos = "position('$frommarker' in description)+$frmarkerlen" ;
	$topos = "position('$tomarker' in description)+$tomarkerlen" ;
	$descdatefrom = "substring(description,$frompos,10)" ;
	$descdateto = "substring(description,$topos,10)" ;

	if (substr_count($where,"datefrom")>0) {
		list($dummy,$datestr) = explode("datefrom",$where) ;
		list($dummy,$datefrom) = explode("'",$datestr) ;
		}
	if (substr_count($where,"dateto")>0) {
		list($dummy,$datestr) = explode("dateto",$where) ;
		list($dummy,$dateto) = explode("'",$datestr) ;
		}
	$where = "" ;
	if ($datefrom)	$where .= " AND $descdatefrom>='$datefrom' and $descdatefrom<='$dateto' ";
	if ($dateto)	$where .= " AND $descdateto>='$datefrom' and $descdateto<='$dateto' ";

	$sql =	"SELECT name as staff,$descdatefrom as datefrom,$descdateto as dateto,description,b.id,empid " ;
	$sql.=	"FROM ${pre}pyrohist a, ${pre}gl b, ${pre}employee c " ;
	$sql.=	"WHERE contactid='$_GET[contactid]' and source='PYRO' and trans_id=b.id and " ;
	$sql.=	"type='NETP' and empid=c.id $where " ;
	$sql.=	"order by $order $sort" ;

	return $sql ;
	}

//---- Payroll List Link Adjustement

    function payroll_list_adjust() {
	global $ckapi ;

	$t = &$ckapi[objects][template] ;
	$app = $ckapi[params][app] ;
	$tran = $ckapi[params][tran] ;
	$id = $ckapi[params_list][dt][id] ;
	$filter = $ckapi[params_list][filter] ;
	$empid = $ckapi[params_list][dt][empid] ;
	$description = $ckapi[params_list][dt][description] ;
	$getstr = "id=$id&empid=$empid&description=$description&filter=$filter" ;
	$t->set_var('view',exapi_link("/$app/${tran}view.php",$getstr));
	}

//---- Payroll Read

    function payroll_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;

	if ($op=="view")	{$dt = $this->payroll_past_read() ; return $dt ;}
	$sql = "SELECT a.id FROM ${pre}payroll a, ${pre}employee b " ;
	$sql.= "WHERE a.empid=b.id and contactid='$_GET[contactid]'";
	$result = $adodb->query($sql);
	$id=exapi_dbflds($result,'id');

	$result = $adodb->query("SELECT * FROM ${pre}payroll WHERE id='$id'");
	$dt = $result->fetchRow() ;

	$result = $adodb->query("SELECT * FROM ${pre}pyrc_trans WHERE pyroid='$id' ORDER BY id");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['eaid'.$i]		=	$rs['pyrcodeid'] ;
		$dt['qty'.$i]		=	$rs['qty'] ;
		$dt['rate'.$i]		=	$rs['rate'] ;
		$dt['amount'.$i]	=	$rs['amount'] ;
		$dt['comment'.$i]	=	$rs['comment'] ;
		}
	$sql = "SELECT * FROM ${pre}pynr_trans WHERE empid='$dt[empid]' and approved_by<>'' ORDER BY id";
	$result = $adodb->query($sql);
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['nreaid'.$i]	=	$rs['pyrcodeid'] ;
		$dt['nrapproved_by'.$i]	=	$rs['approved_by'] ;
		$dt['nrqty'.$i]		=	$rs['qty'] ;
		$dt['nrunit'.$i]	=	$rs['unit'] ;
		$dt['nrunitamt'.$i]	=	$rs['unitamt'] ;
		$dt['nrrate'.$i]	=	$rs['rate'] ;
		$dt['nramount'.$i]	=	$rs['amount'] ;
		$dt['nrcomment'.$i]	=	$rs['comment'] ;
		}
	$result = $adodb->query("SELECT * FROM ${pre}rdtn_trans WHERE pyroid='$id' ORDER BY id");
	For ($i=1;$rs=$result->fetchRow();$i++)	$dt['rdtnid'.$i] = $rs['rdtnid'] ;
	$result = $adodb->query("SELECT * FROM ${pre}cntr_trans WHERE pyroid='$id' ORDER BY id");
	For ($i=1;$rs=$result->fetchRow();$i++)	$dt['cntrid'.$i] = $rs['cntrid'] ;

	return $dt ;
	}


//---- Payroll Read

    function payroll_past_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$empid = ($_GET["empid"]) ? $_GET["empid"] : $_POST["empid"] ;

	$result = $adodb->query("SELECT * FROM ${pre}payroll WHERE empid='$empid'");
	$dt = $result->fetchRow() ;

	$sql = "SELECT * FROM ${pre}pyrohist WHERE trans_id='$id' and empid='$empid' and type='PYRC'";
	$result = $adodb->query($sql);
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['eaid'.$i]		=	$rs['codeid'] ;
		$dt['basis'.$i]		=	$rs['basis'] ;
		$dt['qty'.$i]		=	$rs['qty'] ;
		$dt['unit'.$i]		=	$rs['unit'] ;
		$dt['unitamt'.$i]	=	$rs['unitamt'] ;
		$dt['rate'.$i]		=	$rs['rate'] ;
		$dt['amount'.$i]	=	-$rs['amount'] ;
		$dt['comment'.$i]	=	$rs['comment'] ;
		}
	$sql = "SELECT * FROM ${pre}pyrohist WHERE trans_id='$id' and empid='$empid' and type='PYNR'" ;
	$result = $adodb->query($sql);
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['nreaid'.$i]	=	$rs['codeid'] ;
		$dt['nrapproved_by'.$i]	=	$rs['approved_by'] ;
		$dt['nrbasis'.$i]	=	$rs['basis'] ;
		$dt['nrqty'.$i]		=	$rs['qty'] ;
		$dt['nrunit'.$i]	=	$rs['unit'] ;
		$dt['nrunitamt'.$i]	=	$rs['unitamt'] ;
		$dt['nrrate'.$i]	=	$rs['rate'] ;
		$dt['nramount'.$i]	=	-$rs['amount'] ;
		$dt['nrcomment'.$i]	=	$rs['comment'] ;
		}
	$sql = "SELECT * FROM ${pre}pyrohist WHERE trans_id='$id' and empid='$empid' and type='RDTN'" ;
	$result = $adodb->query($sql);
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['rdtnid'.$i] = $rs['codeid'] ;
		$dt['rdbase'.$i] = $rs['base'] ;
		$dt['rdfloor'.$i] = $rs['floor'] ;
		$dt['rdrate'.$i] = $rs['rate'] ;
		$dt['rdsubtract'.$i] = $rs['subtract'] ;
		$dt['rdamount'.$i] = $rs['amount'] ;
		$dt['rdcomment'.$i] = $rs['comment'] ;
		}
	$sql = "SELECT * FROM ${pre}pyrohist WHERE trans_id='$id' and empid='$empid' and type='CTCR'" ;
	$result = $adodb->query($sql);
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['cntrid'.$i] = $rs['codeid'] ;
		$dt['ctbase'.$i] = $rs['base'] ;
		$dt['ctfloor'.$i] = $rs['floor'] ;
		$dt['ctrate'.$i] = $rs['rate'] ;
		$dt['ctsubtract'.$i] = $rs['subtract'] ;
		$dt['ctamount'.$i] = $rs['amount'] ;
		$dt['ctcomment'.$i] = $rs['comment'] ;
		}
	return $dt ;
	}
//---- Write Payroll Header

    function payroll_header_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$tran = $ckapi[params][tran] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_block('report','nrdetail','nrdetail_section');
	$t->set_block('report','rdtn','rdtn_section');
	$t->set_block('report','cntr','cntr_section');

	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor FROM ${pre}defaults" ;
	$result = $adodb->query($sql);
	switch ($dt[period]) :
		case "mn" :	$dt[daypay] = $dt[salary]/exapi_dbflds($result,'mndfactor') ;
				$dt[hourpay] = $dt[salary]/exapi_dbflds($result,'mnhfactor') ;	break ;
		case "sm" :	$dt[daypay] = $dt[salary]/exapi_dbflds($result,'smdfactor') ;
				$dt[hourpay] = $dt[salary]/exapi_dbflds($result,'smhfactor') ;	break ;
		case "wk" :	$dt[daypay] = $dt[salary]/exapi_dbflds($result,'wkdfactor') ;
				$dt[hourpay] = $dt[salary]/exapi_dbflds($result,'wkhfactor') ;	break ;
		case "dy" :	$dt[daypay] = $dt[salary] ;
				$dt[hourpay] = $dt[salary]/exapi_dbflds($result,'dyhfactor') ;	break ;
		case "hr" :	$dt[daypay] = $dt[salary] * exapi_dbflds($result,'dyhfactor') ;
				$dt[hourpay] = $dt[salary] ;				break ;
		endswitch ;
	$dt[daypay] = sprintf("%01.2f",$dt[daypay]) ;
	$dt[hourpay] = sprintf("%01.2f",$dt[hourpay]) ;
	$t->set_var('lang_empid',exapi_lang('Employee'));
	$t->set_var('lang_id',exapi_lang('Audit ID').' :');
	$t->set_var('lang_salary',exapi_lang('Current Basic Salary'));
	$t->set_var('lang_period',exapi_lang('Current Pay Period'));
	$t->set_var('lang_daypay',exapi_lang('Imputed Current Daily Pay'));
	$t->set_var('lang_hourpay',exapi_lang('Imputed Current Hourly Pay'));
	$t->set_var('employee_selectlist',selectlist('employee','name',"WHERE id=$dt[empid]",'','id','name','id')) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('salary',$dt[salary]) ;
	$t->set_var('period',$dt[period]) ;
	$t->set_var('daypay',$dt[daypay]) ;
	$t->set_var('hourpay',$dt[hourpay]) ;
	$t->parse('out','report',True);
	}


//---- Write Payroll Detail

    function payroll_detail_write() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_eaid',exapi_lang("Recurring Item"));
	$t->set_var('lang_basis',exapi_lang("Basis of Calculation"));
	$t->set_var('lang_qty',exapi_lang("Quantity"));
	$t->set_var('lang_unit',exapi_lang("Unit"));
	$t->set_var('lang_unitamt',exapi_lang("Unit Amount"));
	$t->set_var('lang_rate',exapi_lang("Pay Rate"));
	$t->set_var('lang_amount',exapi_lang("Amount"));
	$t->set_var('lang_comment',exapi_lang("Comment"));
	$t->set_var('lang_total',exapi_lang('Total Recurring'));

	$t->set_var('lang_nreaid',exapi_lang("Non-Recurring Allowance/Deduction"));
	$t->set_var('lang_nrapproved_by',exapi_lang("Approved By"));
	$t->set_var('lang_nrbasis',exapi_lang("Basis of Calculation"));
	$t->set_var('lang_nrqty',exapi_lang("Quantity"));
	$t->set_var('lang_nrunit',exapi_lang("Unit"));
	$t->set_var('lang_nrunitamt',exapi_lang("Unit Amount"));
	$t->set_var('lang_nrrate',exapi_lang("Pay Rate"));
	$t->set_var('lang_nramount',exapi_lang("Amount"));
	$t->set_var('lang_nrcomment',exapi_lang("Comment"));
	$t->set_var('lang_nrtotal',exapi_lang('Total Non-Recurring (Expense/Allowance Claim)'));

	$t->set_var('lang_reductn',exapi_lang("Summary Level Reduction"));
	$t->set_var('lang_rdtnid',exapi_lang("Reduction Type"));
	$t->set_var('lang_rdbaseamt',exapi_lang("Base"));
	$t->set_var('lang_rdfloor',exapi_lang("Floor"));
	$t->set_var('lang_rdrate',exapi_lang("Rate"));
	$t->set_var('lang_rdsubtract',exapi_lang("Subtract"));
	$t->set_var('lang_rdamount',exapi_lang("Amount"));
	$t->set_var('lang_rdremark',exapi_lang("Remark"));
	$t->set_var('lang_rdtotal',exapi_lang("Total Reduction"));
	$t->set_var('lang_net',exapi_lang("Net Payroll This Period"));

	$t->set_var('lang_contri',exapi_lang("Company Contribution"));
	$t->set_var('lang_cntrid',exapi_lang("Contribution Type"));
	$t->set_var('lang_ctbaseamt',exapi_lang("Base"));
	$t->set_var('lang_ctfloor',exapi_lang("Floor"));
	$t->set_var('lang_ctrate',exapi_lang("Rate"));
	$t->set_var('lang_ctsubtract',exapi_lang("Subtract"));
	$t->set_var('lang_ctamount',exapi_lang("Amount"));
	$t->set_var('lang_ctremark',exapi_lang("Remark"));
	$t->set_var('lang_cttotal',exapi_lang("Total Contribution"));

	$float = ($ckapi[hostsys][dbtype]=="mysql") ? "double" : "float" ;
	$user = $ckapi[hostsys][username];
	$temp = "pyr".$user.time() ;
	$adodb->query("CREATE TABLE $temp (pyrcodeid int,amount $float)");

	$tot_amount = 0 ;	$t->set_var('detail_section','') ;
	For ($i=1;isset($dt['eaid'.$i]);$i++) {
		if ($period=='PAST') {
			$eaid	=	$dt['eaid'.$i] ;
			$basis	=	$dt['basis'.$i] ;
			$qty	=	$dt['qty'.$i] ;
			$unit	=	$dt['unit'.$i] ;
			$unitamt=	$dt['unitamt'.$i] ;
			$rate	=	$dt['rate'.$i] ;
			$amount	=	$dt['amount'.$i] ;
			}
		   else {
			$qty = 1 ;
			$eaid	=	$dt['eaid'.$i] ;
			$result = $adodb->query("SELECT * from ${pre}pyrcode where id='$eaid'");
			$basis		= exapi_dbflds($result,'basis') ;
			$unit		= exapi_dbflds($result,'unit') ;
			$unitamt	= (substr_count($basis,'pc')>0) ? exapi_dbflds($result,'unitamt') : 1 ;
			$rate		= exapi_dbflds($result,'rate') ;
			if (substr_count($basis,'qty')>0)	$qty = $dt['qty'.$i];
			if (substr_count($basis,'bs')>0)	$unitamt = $dt[salary] ;
			if (substr_count($basis,'hp')>0)	$unitamt = $dt[hourpay] ;
			if (substr_count($basis,'dp')>0)	$unitamt = $dt[daypay] ;
			$amount = sprintf("%01.2f",sprintf("%01.4f",$qty*$unitamt*$rate)) ;
			if (substr_count($basis,'amt')>0)	$amount=$dt['amount'.$i];
			}
		$t->set_var('eaid_selectlist',selectlist('pyrcode','name',"WHERE id=$eaid",'','id','name')) ;
		$t->set_var('basis',$basis) ;
		$t->set_var('qty',$qty) ;
		$t->set_var('unit',$unit) ;
		$t->set_var('unitamt',$unitamt) ;
		$t->set_var('rate',$rate) ;
		$t->set_var('amount',$amount) ;
		$dt['qty'.$j] = $qty ;
		$dt['amount'.$j] = $amount ;
		$t->set_var('comment',exapi_lang('recurring')) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);

		$adodb->query("INSERT INTO $temp(pyrcodeid,amount) VALUES('$eaid','$amount')");
		$tot_amount += $amount ;
		}
	$t->set_var('tot_amount',$tot_amount) ;

	$tot_nramount = 0 ;	$t->set_var('nrdetail_section','') ;
	For ($i=1;isset($dt['nreaid'.$i]);$i++) {
		if ($period=='PAST') {
			$nreaid		=	$dt['nreaid'.$i] ;
			$nrbasis	=	$dt['nrbasis'.$i] ;
			$nrqty		=	$dt['nrqty'.$i] ;
			$nrunit		=	$dt['nrunit'.$i] ;
			$nrunitamt	=	$dt['nrunitamt'.$i] ;
			$nrrate		=	$dt['nrrate'.$i] ;
			$nramount	=	$dt['nramount'.$i] ;
			$nrcomment	=	$dt['nrcomment'.$i] ;
			}
		   else {
			$nrqty = 1 ;
			$nreaid	=	$dt['nreaid'.$i] ;
			$result = $adodb->query("SELECT * from ${pre}pyrcode where id='$nreaid'");
			$nrbasis	= exapi_dbflds($result,'basis') ;
			$nrunit		= exapi_dbflds($result,'unit') ;
			$nrunitamt	= (substr_count($nrbasis,'pc')>0) ? exapi_dbflds($result,'unitamt') : 1 ;
			$nrrate		= exapi_dbflds($result,'rate') ;
			if (substr_count($nrbasis,'qty')>0)	$nrqty = $dt['nrqty'.$i];
			if (substr_count($nrbasis,'bs')>0)	$nrunitamt = $dt[salary] ;
			if (substr_count($nrbasis,'hp')>0)	$nrunitamt = $dt[hourpay] ;
			if (substr_count($nrbasis,'dp')>0)	$nrunitamt = $dt[daypay] ;
			$nramount = sprintf("%01.2f",sprintf("%01.4f",$nrqty*$nrunitamt*$nrrate)) ;
			if (substr_count($nrbasis,'amt')>0)	$nramount=$dt['nramount'.$i];
			}
		$t->set_var('nreaid_selectlist',selectlist('pyrcode','name',"WHERE id=$nreaid",'','id','name')) ;
		$t->set_var('nrapproved_by',$dt['nrapproved_by'.$i]) ;
		$t->set_var('nrbasis',$nrbasis) ;
		$t->set_var('nrqty',$nrqty) ;
		$t->set_var('nrunit',$nrunit) ;
		$t->set_var('nrunitamt',$nrunitamt) ;
		$t->set_var('nrrate',$nrrate) ;
		$t->set_var('nramount',$nramount) ;
		$dt['nrqty'.$j] = $nrqty ;
		$dt['nramount'.$j] = $nramount ;
		$t->set_var('nrcomment',$dt['nrcomment'.$i]) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('nrdetail_section','nrdetail', True);

		$adodb->query("INSERT INTO $temp(pyrcodeid,amount) VALUES('$nreaid','$nramount')");
		$tot_nramount += $nramount ;
		}
	$t->set_var('tot_nramount',$tot_nramount) ;

	$tot_rdamount = 0 ;	$t->set_var('rdtn_section','') ;
	For ($i=1;isset($dt['rdtnid'.$i]);$i++) {
		if ($period=='PAST') {
			$rdtnid		=	$dt['rdtnid'.$i] ;
			$rdbaseamt	=	$dt['rdbase'.$i] ;
			$rdfloor	=	$dt['rdfloor'.$i] ;
			$rdrate		=	$dt['rdrate'.$i] ;
			$rdsubtract	=	$dt['rdsubtract'.$i] ;
			$rdamount	=	$dt['rdamount'.$i] ;
			$rdremark	=	$dt['rdcomment'.$i] ;
			}
		   else {
			$rdtnid = $dt['rdtnid'.$i] ;
			$sql =	"SELECT sum(amount) as exemamt from $temp a,${pre}rdtnexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and rdtnid='$rdtnid' " ;
			$sql.=		"and amount>=min and amount<=max" ;
			$result = $adodb->query($sql);
			$exemamt = exapi_dbflds($result,'exemamt') ;
			$sql =	"SELECT sum(min) as exemmin from $temp a,${pre}rdtnexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and rdtnid='$rdtnid' " ;
			$sql.=		"and amount<min and actmin='lmt'" ;
			$result = $adodb->query($sql);
			$exemmin = exapi_dbflds($result,'exemmin') ;
			$sql =	"SELECT sum(max) as exemmax from $temp a,${pre}rdtnexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and rdtnid='$rdtnid' " ;
			$sql.=		"and amount>max and actmax='lmt'" ;
			$result = $adodb->query($sql);
			$exemmax = exapi_dbflds($result,'exemmax') ;
			$rdbaseamt = $tot_amount+$tot_nramount-$exemamt-$exemmin-$exemmax ;

			$sql =	"SELECT max(step) as rdstep from ${pre}rdtnrate a,${pre}reductn b " ;
			$sql.=	"WHERE ($rdbaseamt-floor)>=step and rdtnid='$rdtnid' and b.id='$rdtnid'" ;
			$result = $adodb->query($sql);
			$rdstep = exapi_dbflds($result,'rdstep') ;
			$sql =	"SELECT floor,rate,subtract,min,actmin,max,actmax " ;
			$sql.=	"FROM ${pre}rdtnrate a, ${pre}reductn b " ;
			$sql.=	"WHERE step='$rdstep' and rdtnid='$rdtnid' and b.id='$rdtnid'" ;
			$result = $adodb->query($sql);
			$rdfloor = exapi_dbflds($result,'floor') ;
			$rdrate = exapi_dbflds($result,'rate') ;
			$rdsubtract = exapi_dbflds($result,'subtract') ;
			$rdmin = exapi_dbflds($result,'min') ;
			$rdactmin = exapi_dbflds($result,'actmin') ;
			$rdmax = exapi_dbflds($result,'max') ;
			$rdactmax = exapi_dbflds($result,'actmax') ;
			$rdamount = sprintf("%01.2f",($rdbaseamt-$rdfloor) * $rdrate - $rdsubtract) ;
			$rdremark = "" ;
			if ($rdamount<$rdmin) {
				$rdamount = ($rdactmin=="lmt") ? $rdmin : 0 ;
				$rdremark = ($rdactmin=="lmt") ? exapi_lang('Set to Min') : exapi_lang('Min Reject') ;
				}
			if ($rdamount>$rdmax) {
				$rdamount = ($rdactmax=="lmt") ? $rdmax : 0 ;
				$rdremark = ($rdactmax=="lmt") ? exapi_lang('Set to Max') : exapi_lang('Max Reject') ;
				}
			}
		$t->set_var('rdtnid_selectlist',selectlist('reductn','name',"WHERE id=$rdtnid",'','id','name','id')) ;
		$t->set_var('rdbaseamt',$rdbaseamt) ;
		$t->set_var('rdfloor',$rdfloor) ;
		$t->set_var('rdrate',$rdrate) ;
		$t->set_var('rdsubtract',$rdsubtract) ;
		$t->set_var('rdamount',$rdamount) ;
		$t->set_var('rdremark',$rdremark) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('rdtn_section','rdtn', True);
		$tot_rdamount += $rdamount ;
		}
	$t->set_var('tot_rdamount',$tot_rdamount) ;
	$t->set_var('net',$tot_amount+$tot_nramount-$tot_rdamount) ;

	$tot_ctamount = 0 ;	$t->set_var('cntr_section','') ;
	For ($i=1;isset($dt['cntrid'.$i]);$i++) {
		if ($period=='PAST') {
			$cntrid		=	$dt['cntrid'.$i] ;
			$ctbaseamt	=	$dt['ctbase'.$i] ;
			$ctfloor	=	$dt['ctfloor'.$i] ;
			$ctrate		=	$dt['ctrate'.$i] ;
			$ctsubtract	=	$dt['ctsubtract'.$i] ;
			$ctamount	=	$dt['ctamount'.$i] ;
			$ctremark	=	$dt['ctcomment'.$i] ;
			}
		   else {
			$cntrid = $dt['cntrid'.$i] ;
			$sql =	"SELECT sum(amount) as exemamt from $temp a,${pre}cntrexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and cntrid='$cntrid' " ;
			$sql.=		"and amount>=min and amount<=max" ;
			$result = $adodb->query($sql);
			$exemamt = exapi_dbflds($result,'exemamt') ;
			$sql =	"SELECT sum(min) as exemmin from $temp a,${pre}cntrexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and cntrid='$cntrid' " ;
			$sql.=		"and amount<min and actmin='lmt'" ;
			$result = $adodb->query($sql);
			$exemmin = exapi_dbflds($result,'exemmin') ;
			$sql =	"SELECT sum(max) as exemmax from $temp a,${pre}cntrexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and cntrid='$cntrid' " ;
			$sql.=		"and amount>max and actmax='lmt'" ;
			$result = $adodb->query($sql);
			$exemmax = exapi_dbflds($result,'exemmax') ;
			$ctbaseamt = $tot_amount+$tot_nramount-$exemamt-$exemmin-$exemmax ;

			$sql =	"SELECT max(step) as ctstep from ${pre}cntrrate a,${pre}contri b " ;
			$sql.=	"WHERE ($ctbaseamt-floor)>=step and cntrid='$cntrid' and b.id='$cntrid'" ;
			$result = $adodb->query($sql);
			$ctstep = exapi_dbflds($result,'ctstep') ;
			$sql =	"SELECT floor,rate,subtract,min,actmin,max,actmax " ;
			$sql.=	"FROM ${pre}cntrrate a, ${pre}contri b " ;
			$sql.=	"WHERE step='$ctstep' and cntrid='$cntrid' and b.id='$cntrid'" ;
			$result = $adodb->query($sql);
			$ctfloor = exapi_dbflds($result,'floor') ;
			$ctrate = exapi_dbflds($result,'rate') ;
			$ctsubtract = exapi_dbflds($result,'subtract') ;
			$ctmin = exapi_dbflds($result,'min') ;
			$ctactmin = exapi_dbflds($result,'actmin') ;
			$ctmax = exapi_dbflds($result,'max') ;
			$ctactmax = exapi_dbflds($result,'actmax') ;
			$ctamount = sprintf("%01.2f",($ctbaseamt-$ctfloor) * $ctrate - $ctsubtract) ;
			$ctremark = "" ;
			if ($ctamount<$ctmin) {
				$ctamount = ($ctactmin=="lmt") ? $ctmin : 0 ;
				$ctremark = ($ctactmin=="lmt") ? exapi_lang('Set to Min') : exapi_lang('Min Reject') ;
				}
			if ($ctamount>$ctmax) {
				$ctamount = ($ctactmax=="lmt") ? $ctmax : 0 ;
				$ctremark = ($ctactmax=="lmt") ? exapi_lang('Set to Max') : exapi_lang('Max Reject') ;
				}
			}
		$t->set_var('cntrid_selectlist',selectlist('contri','name',"WHERE id=$cntrid",'','id','name','id')) ;
		$t->set_var('ctbaseamt',$ctbaseamt) ;
		$t->set_var('ctfloor',$ctfloor) ;
		$t->set_var('ctrate',$ctrate) ;
		$t->set_var('ctsubtract',$ctsubtract) ;
		$t->set_var('ctamount',$ctamount) ;
		$t->set_var('ctremark',$ctremark) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('cntr_section','cntr', True);
		$tot_ctamount += $ctamount ;
		}
	$t->set_var('tot_ctamount',$tot_ctamount) ;
	$t->set_var('net',$tot_amount+$tot_nramount-$tot_rdamount) ;

	$t->parse('out','report',True);

	$adodb->query("DROP TABLE $temp");

	}

    }

?>

