<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.ismatch.inc.php 0.15.1 2005/09/30 C K Wu

    class ismatch {

//---- ISmatch List SQL Formation

    function ismatch_list_sql() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$db_type = $ckapi[hostsys][dbtype] ;

	$last10 = substr($where,strlen($where)-10,10) ;
	if ($last10==' AND OPEN '){
		$where = substr($where,0,strlen($where)-10) ;
		$sql1 =	"SELECT transdate,b.name as customer,invnumber,isocode,amount,a.id as id " ;
		$sql1.=	"FROM ${pre}ar a, ${pre}customer b WHERE 1=1 $where AND a.customer=b.id " ;
		$sql2 =	"SELECT transdate,b.name as customer,invnumber,isocode,amount,a.id as id " ;
		$sql2.=	"FROM ${pre}ar a,${pre}customer b,${pre}ismatch c " ;
		$sql2.=	"WHERE 1=1 $where AND a.customer=b.id AND a.id=c.invoiceid " ;
		$sql2.=	"GROUP BY transdate,b.name,invnumber,isocode,amount,a.id " ;
		$sql2.=	"HAVING sum(b_amount)>=amount " ;
		if ($db_type=="mysql")	{
			$user = $ckapi[hostsys][username] ;
			$ckapi[params_sql][temp1] = $temp1 = "${pre}isl1".$user.time() ;
			$ckapi[params_sql][temp2] = $temp2 = "${pre}isl2".$user.time() ;
			$adodb->query("CREATE TABLE $temp1 AS $sql1");
			$adodb->query("CREATE TABLE $temp2 AS $sql2");
			$sql = "SELECT $temp1.* from $temp1 LEFT JOIN $temp2 " ;
			$sql.= "ON $temp1.id=$temp2.id WHERE $temp2.id IS NULL" ;
			}
			else	$sql="$sql1 EXCEPT $sql2 ORDER BY $order $sort" ;
		}
	   else	{
		$sql =  "SELECT transdate,b.name as customer,invnumber,isocode,amount,a.id as id ";
		$sql.=	"FROM ${pre}ar a, ${pre}customer b WHERE 1=1 $where AND a.customer=b.id ORDER BY $order $sort" ;
		}
	return $sql ;
	}

//---- ISmatch Data Read

    function ismatch_read() {
	global $ckapi ;

	$op = $ckapi[params_post][op] ;
	$this->ismatch_header_read() ;
	$this->ismatch_allotted_read() ;
	$this->ismatch_pending_read() ;
	return $ckapi[params_post][dt] ;
	}

//---- ISmatch Data Header Read

    function ismatch_header_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$dt = &$ckapi[params_post][dt] ;

	$result = $adodb->query("SELECT * FROM ${pre}ar WHERE id='$id'");
	$dt = $result->fetchRow() ;
	}

//---- ISmatch Data (Allotment) Read

    function ismatch_allotted_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$dt = &$ckapi[params_post][dt] ;

	$sql = "SELECT sonumber,id,duedate,amount,b_amount FROM ${pre}so, ${pre}ismatch " ;
	$sql.= "WHERE invoiceid='$id' and id=soid and customer='$dt[customer]' and isocode='$dt[isocode]'";
	$result = $adodb->query($sql);
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['bsonumber'.$i]	=	$rs['sonumber'] ;
		$dt['bsoid'.$i]		=	$rs['id'] ;
		$dt['bduedate'.$i]	=	$rs['duedate'] ;
		$dt['bsoamount'.$i]	=	$rs['amount'] ;
		$dt['bb_amount'.$i]	=	$rs['b_amount'] ;
		$dt['bnewbamount'.$i]	=	"" ;
		}
	}

//---- IPmatch Data (Pending) Read

    function ismatch_pending_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	$dt = &$ckapi[params_post][dt] ;

	$user = $ckapi[hostsys][username];
	$temp1 = "${pre}is1".$user.time() ;
	$temp2 = "${pre}is2".$user.time() ;
	$sql = "CREATE TABLE $temp1 AS " ;
	$fields = "sonumber,id,duedate" ;
	$sql.="SELECT $fields,amount,0.00 as b_amount,0.00 as billedamount " ;
	$sql.="FROM ${pre}so WHERE customer='$dt[customer]' and isocode='$dt[isocode]'";
	$adodb->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT $fields,0.00 as amount,b_amount,0.00 as billedamount " ;
	$sql.= "FROM ${pre}so, ${pre}ismatch WHERE id=soid and invoiceid='$id'";
	$adodb->query($sql);
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT $fields,0.00 as amount,0.00 as b_amount,sum(b_amount) as billedamount " ;
	$sql.= "FROM ${pre}so a, ${pre}ismatch b ";
	$sql.= "WHERE customer='$dt[customer]' and a.id=b.soid GROUP BY $fields";
	$adodb->query($sql);
	$sql = "CREATE TABLE $temp2 AS " ;
	$sql.= "SELECT $fields,sum(amount) as amount,sum(b_amount) as b_amount,sum(billedamount) as billedamt ";
	$sql.= "FROM $temp1 GROUP BY $fields";
	$adodb->query($sql);
	$sql = "SELECT * FROM $temp2 WHERE amount > billedamt ORDER BY sonumber" ;
	$result = $adodb->query($sql) ;
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$soamount		=	$rs['amount'] ;
		$billedamt		=	$rs['billedamt'] ;
		$dt['ubsonumber'.$i]	=	$rs['sonumber'] ;
		$dt['ubsoid'.$i]	=	$rs['id'] ;
		$dt['ubduedate'.$i]	=	$rs['duedate'] ;
		$dt['ubsoamount'.$i]	=	$soamount ;
		$b_amount = ($op=='add' or $op=='copy') ? 0 : $rs['b_amount'] ;
		$dt['ubb_amount'.$i]	=	$b_amount ;
		$dt['ubb_othamt'.$i]	=	$billedamt - $b_amount ;
		$dt['ubbilledamt'.$i]	=	$billedamt ;
		$dt['ubosamount'.$i]	=	$soamount - $billedamt ;
		}
	$adodb->query("DROP TABLE $temp1, $temp2");
	}

//---- ISmatch Data Transformation

    function ismatch_transform() {
	global $ckapi ;

	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;

	if (isset($clear))		{$msg = $this->match_clear() ; $t->set_var('message1',$msg) ;}
	if (isset($match_equal))	{$msg = $this->match_equal() ; $t->set_var('message1',$msg) ;}
	if (isset($match_fifo))		{$msg = $this->match_fifo() ; $t->set_var('message1',$msg) ;}
	}

//---- ISmatch Detail Validation Checks

    function ismatch_validate() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error");
	$row = exapi_lang("Row") ;
	$sum_bnewbamt = 0 ;
	For ($i=1;isset($dt['bsoid'.$i]);$i++) {
		$bnewbamt = $dt['bnewbamount'.$i] ;
		$rowi = "[$row $i]" ;
		if ($bnewbamt<0)		$err=$rowi.exapi_lang("New Amount Billed must be +ve");
		if ($bnewbamt>$dt[amount])	$err=$rowi.exapi_lang("New Amount Billed > Invoice Amt");
		if ($bnewbamt>$dt['bsoamount'.$i])	$err=$rowi.exapi_lang("New Amount Billed > SO Amount");
		if (!is_numeric($bnewbamt) and strlen($bnewbamt)>0)
						$err=$rowi.exapi_lang("New Amt Billed must be numeric");
		$sum_bnewbamt += ($bnewbamt=="") ? $dt['bb_amount'.$i] : $bnewbamt ;
		}
	$sum_bnewbamt2 = sprintf("%01.2f",$sum_bnewbamt) ;
	$dt_amount2 = sprintf("%01.2f",$dt[amount]) ;
	if ($sum_bnewbamt2>$dt_amount2)		$err=exapi_lang("Total Amount Billed > Invoice Amount");
	For ($i=1;isset($dt['ubsoid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		if ($dt['ubosamount'.$i]<0)	$err=$rowi.exapi_lang("UNBILLED SO overbilled");
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write Ismatch (Invoice) Header

    function ismatch_header_write() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$result = $adodb->query("SELECT nativecurr FROM ${pre}defaults");
	$loc_for = (exapi_dbflds($result,'nativecurr')==$dt[isocode]) ? exapi_lang('Local') : exapi_lang('*** Foreign ***') ;
	$t->set_var('lang_customer',exapi_lang('Customer'));
	$t->set_var('lang_invnumber',exapi_lang('Invoice#:'));
	$t->set_var('lang_id',exapi_lang('Audit ID').':');
	$t->set_var('lang_curr_invoice',exapi_lang('Currency Invoice'));
	$t->set_var('lang_loc_for',$loc_for);
	$t->set_var('lang_amount',exapi_lang('Invoice Amount:'));
	$t->set_var('lang_transdate',exapi_lang('Invoice Date:'));
	$t->set_var('lang_duedate',exapi_lang('Due Date:'));
	$t->set_var('lang_isocode',exapi_lang('Currency'));
	$t->set_var('lang_exrate',exapi_lang('Exchange Rate'));
	$t->set_var('customer',$dt[customer]) ;
	$t->set_var('customer_selectlist',selectlist('customer','name',"WHERE id=$dt[customer]",'','id','name','id')) ;
	$t->set_var('invnumber',$dt[invnumber]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('amount',$dt[amount]) ;
	$t->set_var('transdate',$dt[transdate]) ;
	$t->set_var('duedate',$dt[duedate]) ;
	$t->set_var('isocode_selectlist',selectlist('currency','isocode',"WHERE isocode='$dt[isocode]'",'','isocode','isocode','description')) ;
	$t->set_var('exrate',$dt[exrate]) ;
	$t->parse('out','report',True);
	}

//---- Write Ismatch Detail

    function ismatch_detail_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	if ($op=="view" or $op=="delete")       $posted = True ;
	$t->set_block('report','billedlist','billedlist_section');
	$t->set_block('report','unbilledlist','unbilledlist_section');
	$moverow_ = exapi_lang('Move Row')." " ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_bltitle',exapi_lang('List of Fully/Partially BILLED %1 SO billed by this Invoice',$dt[isocode]));
	$t->set_var('lang_bsonumber',exapi_lang('SO#'));
	$t->set_var('lang_bsoid',exapi_lang('SO ID'));
	$t->set_var('lang_bduedate',exapi_lang('Due Date'));
	$t->set_var('lang_bfullamount',exapi_lang('Full SO Amount'));
	$t->set_var('lang_bbilled',exapi_lang('Amount Billed<br>via this Invoice'));
	$t->set_var('lang_bnewbamount',exapi_lang('Amount Billed via this<br>Invoice to be Updated to'));
	$sum_bsoamount = $sum_bb_amount = $sum_bnewbamount = 0 ;
	For ($i=1;isset($dt['bsoid'.$i]);$i++) {
		$t->set_var('bsonumber_fld','bsonumber'.$i);
		$t->set_var('bsoid_fld','bsoid'.$i);
		$t->set_var('bduedate_fld','bduedate'.$i);
		$t->set_var('bsoamount_fld','bsoamount'.$i);
		$t->set_var('bb_amount_fld','bb_amount'.$i) ;
		$t->set_var('bnewbamount_fld','bnewbamount'.$i);
		$t->set_var('bsonumber',$dt['bsonumber'.$i]) ;
		$bsoid = $dt['bsoid'.$i] ;
		$t->set_var('bsoid',$bsoid) ;
		$t->set_var('bduedate',$dt['bduedate'.$i]) ;
		$t->set_var('bsoamount',$dt['bsoamount'.$i]) ;
		$t->set_var('bb_amount',$dt['bb_amount'.$i]) ;
		$bnewbamount = $dt['bnewbamount'.$i] ;
		if (is_numeric($bnewbamount))		$t->set_var('bnewbamount',"") ;
			else				$t->set_var('bnewbamount',$bnewbamount) ;
		if (strlen($bnewbamount)>0 and is_numeric($bnewbamount)) {
			For ($j=1;isset($dt['ubsoid'.$j]);$j++) {
				if ($bsoid==$dt['ubsoid'.$j]) {
					$dt['ubb_amount'.$j] = $bnewbamount ;
					$dt['ubbilledamt'.$j]= $dt['ubb_amount'.$j] + $dt['ubb_othamt'.$j];
					$dt['ubosamount'.$j] = $dt['ubsoamount'.$j] - $dt['ubbilledamt'.$j] ;
					break ;
					}
				}
			if (!isset($dt['ubsoid'.$j])) {
				$user = $ckapi[hostsys][username];
				$tmp = "${pre}ism".$user.time() ;
				$fields = "sonumber,id,duedate,amount" ;
				$sql = "CREATE TABLE $tmp AS " ;
				$sql.=	"SELECT $fields,0.00 as b_amount,sum(b_amount) as billedamt " ;
				$sql.=	"FROM ${pre}so,${pre}ismatch " ;
				$sql.=	"WHERE id='$bsoid' and soid='$bsoid' GROUP BY $fields" ;
				$adodb->query($sql);
				$sql = "INSERT INTO $tmp " ;
				$sql.=	"SELECT $fields,b_amount,0.00 as billedamt " ;
				$sql.=	"FROM ${pre}so,${pre}ismatch ";
				$sql.=	"WHERE id='$bsoid' and soid='$bsoid' and invoiceid='$dt[id]' " ;
				$adodb->query($sql);
				$sql ="SELECT $fields,sum(b_amount) as b_amount,sum(billedamt) as billedamt ";
				$sql.= "FROM $tmp GROUP BY $fields " ;
				$result = $adodb->query($sql) ;

				While ($rs=$result->fetchRow()) {
					$dt['ubsonumber'.$j]	=	$rs['sonumber'] ;
					$dt['ubsoid'.$j]	=	$rs['id'] ;
					$dt['ubduedate'.$j]	=	$rs['duedate'] ;
					$dt['ubsoamount'.$j]	=	$rs['amount'] ;
					$dt['ubb_amount'.$j]	=	$bnewbamount ;
					$dt['ubb_othamt'.$j]	=	$rs['billedamt']-$rs['b_amount'];
					$dt['ubbilledamt'.$j]	=$dt['ubb_amount'.$j] + $dt['ubb_othamt'.$j];
					$dt['ubosamount'.$j]	=$dt['ubsoamount'.$j] - $dt['ubbilledamt'.$j];
					$j++ ;
					}
				$adodb->query("DROP TABLE $tmp");
				}
			$t->set_var('bb_amount',$bnewbamount) ;
			$dt['bb_amount'.$i] = $bnewbamount ;
			}
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('billedlist_section','billedlist', True);
		$sum_bsoamount		+= $dt['bsoamount'.$i] ;
		$sum_bb_amount		+= $dt['bb_amount'.$i] ;
		}
	if ($i==1)	$t->set_var('billedlist_section',"");
	$movrowno = intval(str_replace($moverow_,"",$dt[move])) ;
	if ($movrowno<>0) {
		$t->set_var('bsonumber_fld','bsonumber'.$i);
		$t->set_var('bsoid_fld','bsoid'.$i);
		$t->set_var('bduedate_fld','bduedate'.$i);
		$t->set_var('bsoamount_fld','bsoamount'.$i);
		$t->set_var('bb_amount_fld','bb_amount'.$i) ;
		$t->set_var('bnewbamount_fld','bnewbamount'.$i);
		$t->set_var('bsonumber',$dt['ubsonumber'.$movrowno]) ;
		$t->set_var('bsoid',$dt['ubsoid'.$movrowno]) ;
		$t->set_var('bduedate',$dt['ubduedate'.$movrowno]) ;
		$t->set_var('bsoamount',$dt['ubsoamount'.$movrowno]) ;
		$t->set_var('bb_amount',0) ;
		$t->set_var('bnewbamount',"") ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('billedlist_section','billedlist', True);
		$sum_bsoamount	+= $dt['ubsoamount'.$movrowno] ;
		}
	$msg = ($dt[amount]>$sum_bb_amount) ? exapi_lang("[Invoice underallocated to SO]") : "" ;
	$t->set_var('lang_total',exapi_lang('Total Amount')." ".$msg);
	$t->set_var('sum_bsoamount',$sum_bsoamount);
	$t->set_var('sum_bb_amount',$sum_bb_amount);
	$t->set_var('sum_bnewbamount',$sum_bnewbamount);
	$t->set_var('lang_ubltitle',exapi_lang('List of Fully/Partially UNBILLED %1 SO accrued on this customer',$dt[isocode]));
	$t->set_var('lang_ubsonumber',exapi_lang('SO#'));
	$t->set_var('lang_ubsoid',exapi_lang('SO ID'));
	$t->set_var('lang_ubduedate',exapi_lang('Due Date'));
	$t->set_var('lang_ubfullamount',exapi_lang('Full SO Amount'));
	$t->set_var('lang_ubb_amount',exapi_lang('Amount Billed via this Invoice'));
	$t->set_var('lang_ubb_othamt',exapi_lang('Amount Billed via other Invoices'));
	$t->set_var('lang_ubbilledamt',exapi_lang('Total Amount Billed'));
	$t->set_var('lang_ubosamount',exapi_lang('Outstanding Unbilled Amount'));
	$t->set_var('lang_ubmove2billed',exapi_lang('Move to Billed List'));
	For ($i=1;isset($dt['ubsoid'.$i]);$i++) {
		$t->set_var('ubsonumber_fld','ubsonumber'.$i);
		$t->set_var('ubsoid_fld','ubsoid'.$i);
		$t->set_var('ubduedate_fld','ubduedate'.$i);
		$t->set_var('ubsoamount_fld','ubsoamount'.$i);
		$t->set_var('ubb_amount_fld','ubb_amount'.$i);
		$t->set_var('ubb_othamt_fld','ubb_othamt'.$i);
		$t->set_var('ubbilledamt_fld','ubbilledamt'.$i) ;
		$t->set_var('ubosamount_fld','ubosamount'.$i);
		$t->set_var('ubsonumber',$dt['ubsonumber'.$i]) ;
		$t->set_var('ubsoid',$dt['ubsoid'.$i]) ;
		$t->set_var('ubduedate',$dt['ubduedate'.$i]) ;
		$t->set_var('ubsoamount',$dt['ubsoamount'.$i]) ;
		$t->set_var('ubb_amount',$dt['ubb_amount'.$i]) ;
		$t->set_var('ubb_othamt',$dt['ubb_othamt'.$i]) ;
		$t->set_var('ubbilledamt',$dt['ubbilledamt'.$i]) ;
		$t->set_var('ubosamount',$dt['ubosamount'.$i]) ;
		$t->set_var('rowno',$moverow_.$i) ;
		For ($j=1;isset($dt['bsoid'.$j]);$j++) {
			if ($dt['ubsoid'.$i]==$dt['bsoid'.$j]) $t->set_var('rowno',exapi_lang("already in the list"));
			}
		if ($movrowno==$i)		$t->set_var('rowno',exapi_lang("already in the list")) ;
		if ($posted)			$t->set_var('rowno',exapi_lang("done")) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('unbilledlist_section','unbilledlist', True);
		}
	if ($i==1)	$t->set_var('unbilledlist_section',"");
	}

//---- Perform Invoice/SO Matching on Balance Amount by Matching Equal Amount

    function match_equal() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;

	if (!isset($dt[ubsoid1]))	$message1 = exapi_lang("All SOs already settled") ;
	   else {
		$temp = $dt ;
		For ($j=1;isset($dt['ubsoid'.$j]);$j++)	$duedate[$j] = $temp['ubduedate'.$j] ;
		asort($duedate) ;
		reset($duedate) ;
		$j = 1 ;
		while (list($key,$val)=each($duedate)) {
			$dt['ubsonumber'.$j]	=	$temp['ubsonumber'.$key] ;
			$dt['ubsoid'.$j]	=	$temp['ubsoid'.$key] ;
			$dt['ubduedate'.$j]	=	$val ;
			$dt['ubsoamount'.$j]	=	$temp['ubsoamount'.$key] ;
			$dt['ubb_amount'.$j]	=	$temp['ubb_amount'.$key] ;
			$dt['ubb_othamt'.$j]	=	$temp['ubb_othamt'.$key] ;
			$dt['ubbilledamt'.$j]	=	$temp['ubbilledamt'.$key] ;
			$dt['ubosamount'.$j]	=	$temp['ubosamount'.$key] ;
			$j++ ;
			}
		}
	$bal = $dt[amount] ;
	For ($i=1;isset($dt['bsoid'.$i]);$i++)	{
		$bal -= $dt['bb_amount'.$i] ;
		$dt['bnewbamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = exapi_lang("Invoice is alreadly fully allocated") ;
	   else {
		For ($j=1;isset($dt['ubsoid'.$j]);$j++) {
			if ($dt['ubosamount'.$j]==$bal) {
				$dt['ubb_amount'.$j] += $bal ;
				$dt['ubbilledamt'.$j] += $bal ;
				$dt['ubosamount'.$j]  = 0 ;
				$soid = $dt['ubsoid'.$j] ;
				For ($i=1;isset($dt['bsoid'.$i]);$i++) {
					if ($dt['bsoid'.$i]==$soid) {
						$dt['bb_amount'.$i] += $bal ;
						$dt['bnewbamount'.$i] = "" ;
						break ;
						}
					}
				if (!isset($dt['bsoid'.$i])) {
					$dt['bsonumber'.$i]	= $dt['ubsonumber'.$j] ;
					$dt['bsoid'.$i]		= $dt['ubsoid'.$j] ;
					$dt['bduedate'.$i]	= $dt['ubduedate'.$j] ;
					$dt['bsoamount'.$i]	= $dt['ubsoamount'.$j];
					$dt['bb_amount'.$i]	= $bal ;
					$dt['bnewbamount'.$i]	= "" ;
					}
				break ;
				}
			}
		}
	if (isset($dt['ubsoid'.$j]))
		$message3 = exapi_lang("Matching completed.  If result OK, click POST button to update.") ;
	$message = exapi_lang("No (equal) matching item found") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	if (isset($message3))		$message = $message3 ;
	return "<b>$message</b>" ;
	}

//---- Perform Invoice/SO Matching on Balance Amount by FIFO Scheme

    function match_fifo() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;

	if (!isset($dt[ubsoid1]))	$message1 = exapi_lang("All SOs already settled") ;
	   else {
		$temp = $dt ;
		For ($j=1;isset($dt['ubsoid'.$j]);$j++)	$duedate[$j] = $temp['ubduedate'.$j] ;
		asort($duedate) ;
		reset($duedate) ;
		$j = 1 ;
		while (list($key,$val)=each($duedate)) {
			$dt['ubsonumber'.$j]	=	$temp['ubsonumber'.$key] ;
			$dt['ubsoid'.$j]	=	$temp['ubsoid'.$key] ;
			$dt['ubduedate'.$j]	=	$val ;
			$dt['ubsoamount'.$j]	=	$temp['ubsoamount'.$key] ;
			$dt['ubb_amount'.$j]	=	$temp['ubb_amount'.$key] ;
			$dt['ubb_othamt'.$j]	=	$temp['ubb_othamt'.$key] ;
			$dt['ubbilledamt'.$j]	=	$temp['ubbilledamt'.$key] ;
			$dt['ubosamount'.$j]	=	$temp['ubosamount'.$key] ;
			$j++ ;
			}
		}
	$bal = $dt[amount] ;
	For ($i=1;isset($dt['bsoid'.$i]);$i++)	{
		$bal -= $dt['bb_amount'.$i] ;
		$dt['bnewbamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = exapi_lang("Invoice is alreadly fully allocated") ;
	   else {
		For ($j=1;isset($dt['ubsoid'.$j]);$j++) {
			$ubosamt = $dt['ubosamount'.$j] ;
			if ($ubosamt>0) {
				if ($bal>=$ubosamt) {
					$dt['ubb_amount'.$j] += $ubosamt ;
					$dt['ubbilledamt'.$j] += $ubosamt ;
					$dt['ubosamount'.$j]  = 0 ;
					$soid = $dt['ubsoid'.$j] ;
					For ($i=1;isset($dt['bsoid'.$i]);$i++) {
						if ($dt['bsoid'.$i]==$soid) {
							$dt['bb_amount'.$i] += $ubosamt ;
							$dt['bnewbamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($dt['bsoid'.$i])) {
						$dt['bsonumber'.$i]	= $dt['ubsonumber'.$j] ;
						$dt['bsoid'.$i]		= $soid ;
						$dt['bduedate'.$i]	= $dt['ubduedate'.$j] ;
						$dt['bsoamount'.$i]	= $dt['ubsoamount'.$j];
						$dt['bb_amount'.$i]	+= $ubosamt ;
						$dt['bnewbamount'.$i]	= "" ;
						}
					$bal -= $ubosamt ;
					}
				   else {
					$dt['ubb_amount'.$j] += $bal ;
					$dt['ubbilledamt'.$j] += $bal ;
					$dt['ubosamount'.$j]  -= $bal ;
					$soid = $dt['ubsoid'.$j] ;
					For ($i=1;(isset($dt['bsoid'.$i]) and $bal>0);$i++) {
						if ($dt['bsoid'.$i]==$soid) {
							$dt['bb_amount'.$i] += $bal ;
							$dt['bnewbamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($dt['bsoid'.$i])) {
						$dt['bsonumber'.$i]	= $dt['ubsonumber'.$j] ;
						$dt['bsoid'.$i]		= $soid ;
						$dt['bduedate'.$i]	= $dt['ubduedate'.$j] ;
						$dt['bsoamount'.$i]	= $dt['ubsoamount'.$j];
						$dt['bb_amount'.$i]	= $bal ;
						$dt['bnewbamount'.$i]	= "" ;
						}
					$bal = 0 ;
					}
				}
			}
		}
	$message = exapi_lang("Matching completed.  If result OK, click POST button to update") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	return "<b>$message</b>" ;
	}

//---- Clear current on-screen Invoice/SO Matching

    function match_clear() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;

	For ($i=1;isset($dt['bsoid'.$i]);$i++)	{
		$soid = $dt['bsoid'.$i] ;
		$bbamt = $dt['bb_amount'.$i] ;
		For ($j=1;isset($dt['ubsoid'.$j]);$j++) {
			if ($dt['ubsoid'.$j]==$soid) {
				$dt['ubb_amount'.$j] = 0 ;
				$dt['ubbilledamt'.$j] -= $bbamt ;
				$dt['ubosamount'.$j]  += $bbamt ;
				break ;
				}
			}
		if (!isset($dt['ubsoid'.$j])) {
			$dt['ubsonumber'.$j]	=	$dt['bsonumber'.$i] ;
			$dt['ubsoid'.$j]	=	$soid ;
			$dt['ubduedate'.$j]	=	$dt['bduedate'.$i] ;
			$dt['ubsoamount'.$j]	=	$dt['bsoamount'.$i] ;
			$dt['ubb_amount'.$j]	=	0 ;
			$dt['ubb_othamt'.$j]	=	$dt['bsoamount'.$i] - $bbamt ;
			$dt['ubbilledamt'.$j]	=	$dt['ubb_othamt'.$j] ;
			$dt['ubosamount'.$j]	=	$bbamt ;
			}
		unset($dt['bsoid'.$i]) ;
		}
	$message = exapi_lang("All (on-screen) matchings for current Invoice cleared") ;
	return "<b>$message</b>" ;
	}

//---- ISmatch Post - PreCommit Routine

    function ismatch_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$id = &$ckapi[params_post][id] ;
	$op = &$ckapi[params_post][op] ;

	$adodb->query("DELETE from ${pre}ismatch where invoiceid=$id");
	if ($op<>'clear') {
		For ($i=1;isset($dt['bsoid'.$i]);$i++) {
			$b_amt = $dt['bnewbamount'.$i]=="" ? $dt['bb_amount'.$i] : $dt['bnewbamount'.$i] ;
			if ($b_amt<>0) {
				$soid	= $dt['bsoid'.$i] ;
				$sql = "INSERT INTO ${pre}ismatch (soid,invoiceid,b_amount) " ;
				$sql.= "VALUES ('$soid','$id','$b_amt')";
				$adodb->query($sql);
				}
			}
		}
	}

    }

?>
