<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// ismatchfilter.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-ar' ;
	$tran = 'ismatch' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"			) ;
	$ckapi[phrases] = array('lang_title'=> exapi_lang("Search among posted Invoices with and w/o SO matched :"),
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Done") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$warning=exapi_lang("Make sure you have completed all invoice allocation (to SOs) before checking on unallocated invoices") ;
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$ckapi[filter][] = array(criteria	=>	exapi_lang('Customer') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.selectlist('customer','name','','','id','name','id') ,
				varname		=>	'customer' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Select the appropriate customer') );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Currency') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.selectlist('currency','isocode','','','isocode','isocode','description') ,
				varname		=>	'isocode' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Select the appropriate currency') );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Invoice Date (from)') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Must be a valid date')."; $dateformat" );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Invoice Date (to)') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Must be a valid date')."; $dateformat" );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Invoice Number') ,
				type		=>	'input' ,
				varname		=>	'invnumber' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for target key word/number in the invoice number field') );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Unallocated Invoices Only') ,
				type		=>	'checkbox' ,
				varname		=>	'opentran' ,
				defval		=>	"" ,
				note		=>	exapi_lang("Click box if only non fully allocated invoices are to be retrieved")."<br><b>".$warning."</b>" );

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
