<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// receiptoff.php 0.15.1 2005/09/30 C K Wu
	
	$app = 'ck-ar' ;
	$tran = 'receipt' ;
	$noheader = $nonavbar = True ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$email = ($_GET["email"]) ? $_GET["email"] : $_POST["email"] ;
	$filter=stripslashes($filter);

	$t = exapi_tpl($app);
	$t->set_file(array(	'report'	=> "${tran}off.tpl",
				'items'		=> "${tran}off.tpl"));
	$t->set_block('items','item_row','item_section');
	$t->set_block('items','done','done_section');
	$charset = exapi_lang('charset') ;
	$t->set_var('charset',$charset);
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$logofile = $ckapi[hostsys][dataarea]."/images/logo.png" ;
	$logourl = exapi_link("/ck-api/view_image.php","imgfile=$logofile") ;	
	$t->set_var('logo',$logourl);

/*------------- Write Receipt Header to Screen Display ----------------------------*/

	$t->set_var('lang_receipt',exapi_lang('*** OFFICIAL RECEIPT ***'));
	$t->set_var('lang_rptnumber',exapi_lang('Receipt Number'));
	$t->set_var('lang_rdate',exapi_lang('Receipt Date'));
	$t->set_var('lang_customer',exapi_lang('Customer:'));

	$result = $adodb->query("SELECT * FROM ${pre}defaults");
	$company = exapi_dbflds($result,'company') ;
	$comemail = exapi_dbflds($result,'email') ;
	$footer = exapi_dbflds($result,'inv_remark') ;

	$result = $adodb->query("SELECT * FROM ${pre}receipt WHERE id='$id'");
	$t->set_var('rptnumber',exapi_dbflds($result,'rptnumber')) ;
	$customer = exapi_dbflds($result,'customer') ;
	$rptamount = $amount = exapi_dbflds($result,'amount') ;
	$cheque = exapi_dbflds($result,'cheque') ;
	$t->set_var('rdate',exapi_dbflds($result,'transdate')) ;
	$t->set_var('amount',exapi_dbflds($result,'amount')) ;
	$currency = exapi_dbflds($result,'isocode') ;

	$result = $adodb->query("SELECT * FROM ${pre}customer a, ${pre}org b WHERE a.id='$customer' and contactid=b.id");
	if (exapi_dbrc($result)>0) {
		$name = exapi_dbflds($result,'orgname') ;
		$emailname = exapi_lang('Accounts Department')." - $name" ;
		$contactid = exapi_dbflds($result,'contactid') ;
		}
	  else	{
		$result = $adodb->query("SELECT * FROM ${pre}customer a,${pre}person b WHERE a.id='$customer' and contactid=b.id");
		$name = $emailname = strtoupper(exapi_dbflds($result,'family'))." ".exapi_dbflds($result,'given') ;
		$contactid = exapi_dbflds($result,'contactid') ;
		}

	$t->set_var('name',$name) ;
	$result = $adodb->query("SELECT * FROM ${pre}comm WHERE contactid='$contactid' and commcode='bemail'");
	$custemail = exapi_dbflds($result,'commdata') ;
	$billaddr = exapi_lang('billaddr') ;
	$result = $adodb->query("SELECT * FROM ${pre}address WHERE contactid='$contactid' and addresscode='$billaddr'");
	$t->set_var('addr1',exapi_dbflds($result,'line1')) ;
	$t->set_var('addr2',exapi_dbflds($result,'line2')) ;
	$t->set_var('addr3',exapi_dbflds($result,'line3')) ;
	$t->set_var('addr4',exapi_dbflds($result,'line4')) ;

	$comment1 = exapi_lang("Thank you for your payment!") ;
	$comment1 = "<font size=+1>$comment1</font>" ;
	$t->set_var('comment1',$comment1) ;
	$t->set_var('comment2',"") ;
	$comment3 = exapi_lang("The validity of this receipt is subject to the clearance") ;
	$comment4 = exapi_lang("of all included cheques, remittance and pending funds.") ;
	$comment3 = "<font size=-1>$comment3</font>" ;
	$comment4 = "<font size=-1>$comment4</font>" ;
	$t->set_var('comment3',$comment3) ;
	$t->set_var('comment4',$comment4) ;

/*-----Translating $amount into $longhand------------------------------------------------*/


	$unit =		 array (9 => 'Hundred', 8 => '*', 7 => 'Million',
				6 => 'Hundred', 5 => '*', 4 => 'Thousand',
				3 => 'Hundred', 2 => '*', 1 => '' ) ;
	$digitword = array (	9 => 'Nine', 8 => 'Eight', 7 => 'Seven', 6 => 'Six',  5 => 'Five',
				4 => 'Four', 3 => 'Three', 2 => 'Two',   1 => 'One',  0 => '' ) ;
	$tens =		 array (9 => 'Ninety', 8 => 'Eighty', 7 => 'Seventy', 6 =>'Sixty', 5 =>'Fifty',
				4 => 'Forty', 3 => 'Thirty', 2 => 'Twenty', 1 => 'Ten', 0 =>'' ) ;
	$tenplus =	 array (9 => 'Nineteen', 8 => 'Eighteen', 7 => 'Seventeen',
				6 => 'Sixteen', 5 =>'Fifteen', 4 => 'Forteen',
				3 => 'Thirteen', 2 => 'Twelve', 1 => 'Eleven', 0 =>'' ) ;

$pamount = '$'.sprintf("%01.2f",$amount) ;
$cents  = round(($amount - floor($amount))* 100) % 100 ;

$divider = 100000000 ;
For ($i=9;$divider>=1;$i--)	{
	$digit[$i]=floor($amount/$divider) ;
	$word[$i] = $unit[$i]=='*'? $tens[$digit[$i]] : $digitword[$digit[$i]] ;
	$word[$i] = ($unit[$i+1]=='*' and $digit[$i+1]==1) ? $tenplus[$digit[$i]] : $word[$i] ;
	$word[$i+1] = ($word[$i+1]=='Ten' and $digit[$i]<>0) ? "" : $word[$i+1] ;
	if ($unit[$i]=="Hundred" and $digit[$i]==0) $unit[$i] = "" ;
	if ($unit[$i]=="Million" and $digit[$i]==0 and $digit[$i+1]==0 and $digit[$i+2]==0) $unit[$i]="" ;
	if ($unit[$i]=="Thousand" and $digit[$i]==0 and $digit[$i+1]==0 and $digit[$i+2]==0) $unit[$i]="" ;

	$amount = $amount % $divider ;
	$divider = $divider / 10 ;
	}
$longhand = "" ;
For ($i=9;$i>=1;$i--)	{$longhand .= "$word[$i] $unit[$i] " ; }
$longhand = str_replace("*","",$longhand);

$divider = 10 ;
For ($i=2;$divider>=1;$i--)	{
	$digit[$i]=floor($cents/$divider) ;
	$word[$i] = $unit[$i]=='*'? $tens[$digit[$i]] : $digitword[$digit[$i]] ;
	$word[$i] = ($unit[$i+1]=='*' and $digit[$i+1]==1) ? $tenplus[$digit[$i]] : $word[$i] ;
	$word[$i+1] = ($word[$i+1]=='Ten' and $digit[$i]<>0) ? "" : $word[$i+1] ;
	$cents = $cents % $divider ;
	$divider = $divider / 10 ;
	}
$centhand = "" ;
For ($i=2;$i>=1;$i--)	{$centhand .= "$word[$i] $unit[$i] " ; }
$centhand = str_replace("*","",$centhand) ;
$longhand = trim($centhand)=="" ? $longhand : $longhand." And Cents ".$centhand ;

/*---------------Write Receipt Wording--------------------------------------------------------------*/

	$sql= "SELECT invnumber from ${pre}r_match a, ${pre}ar b WHERE a.receiptid=$id and a.invoiceid=b.id ";
	$result = $adodb->query($sql);
	$invlist = "" ;
	While ($rs=$result->fetchRow())		$invlist .= $rs['invnumber'].", " ;
	$memo1 = exapi_lang("Received from,")." <b>$name</b>" ;
	$memo2 = exapi_lang("the sum of,")." <b>$currency$rptamount====</b>" ;
	$memo3 = ($cheque<>"") ? exapi_lang("as cheque numbered,")." <b>$cheque</b>" : exapi_lang("in cash") ;
	$memo = "<br>$memo1<br>$memo2<br>$memo3<br>" ;
	$invmemo = ($invlist<>"") ? exapi_lang("in payment of the invoice(s),")." $invlist.<br><br>" : ".<br><br>" ;
	$amtword = exapi_lang("Amount in words,")."<br>$currency <b>$longhand</b> ".exapi_lang("ONLY") ;

	$t->set_var('memo',$memo) ;
	$t->set_var('invmemo',$invmemo) ;
	$t->set_var('amtword',$amtword) ;

/*--------------------Write bottom Section------------------------------------------*/

	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$title=exapi_lang('Official Receipt Image (Use browser print function to output receipt shown above):');
	$t->set_var('lang_title',$title);
	$note1=exapi_lang('[This is a sample subject to tailoring per individual printer & receipt format]');
	$note1a=exapi_lang('For email function to work, your email/SMTP/DNS environment must be properly setup.');
	$t->set_var('lang_note1',"$note1<br>$note1a");
	$note2=exapi_lang('<b>Warning:  Make sure that the receipt had been properly allocated to the appropriate invoices, before generating, mailing or emailing the official receipt.</b>');
	$t->set_var('lang_note2',$note2);

	$t->set_var('email_action',exapi_link("/$app/${tran}off.php","id=$id&filter=$filter")) ;
	$t->set_var('lang_email',exapi_lang('Email Receipt'));
	$t->set_var('done_action',exapi_link("/$app/${tran}list.php","filter=$filter")) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	if ($email)	{
		$err = (!($err=="")) ? $err : "" ;
		$error=exapi_lang("Error") ; $noemail=exapi_lang("No email sent") ;
		$custmsg = exapi_lang("Customer") ;	$rptmsg = exapi_lang("Receipt") ;
		$successmsg = exapi_lang("Email successfully queued for despatch to") ;
		$failuremsg = exapi_lang("Email fails to deliver to") ;

		if (!$custemail)				$err = exapi_lang("Customer email missing") ;
		if ($custemail and strpos($custemail,'@')=='')	$err = exapi_lang("Invalid customer email") ;
		if (!$comemail)					$err = exapi_lang("Company return email missing");
		if ($comemail and strpos($comemail,'@')=='')	$err = exapi_lang("Invalid company return email");
		if ($err) {
			$note1 = "$custmsg/$name -- $rptmsg/$id -- $noemail -- $error: $err" ;
			$t->set_var('lang_note1',$note1) ;
			}
		   else {
			$recipient = "$emailname < $custemail >" ;
			$subject = exapi_lang("Receipt from %1",$company) ;
			$bdmarker = "CK-ERP_".md5(uniqid(time())) ;
			$headers = "From: $company < $comemail >\n" ;
			$headers.= "Bcc: $company < $comemail >\n" ;
			$headers.= "Return-Path: $company < $comemail >\n" ;
			$headers.= "MIME-Version: 1.0\n" ;
			$headers.= "Content-Type: multipart/mixed; boundary=\"$bdmarker\"\n" ;
			$message = "--$bdmarker\n" ;
			$message.= "Content-Type: text/html; charset=$charset\n" ;
			$message.= "Content-Transfer-Encoding: 7bit\n" ;
			$contentid = md5(uniqid(time())) ;
			$htmlpart = str_replace($logourl,"cid:$contentid",$t->parse('out','items',report)) ;
			$message.= str_replace('{done_section}','',$htmlpart) ;
			$message.= "--$bdmarker\n" ;
			$message.= "Content-Type: image/png\n" ;
			$message.= "Content-Transfer-Encoding: base64\n" ;
			$message.= "Content-ID: $contentid\n\n" ;
			$fd = fopen("$logofile","r");
			$message.= chunk_split(base64_encode(fread($fd,filesize($logofile))))."\n";
			$message.= "--$bdmarker--\n" ;
			$headers.= "Return-Path: $company < $comemail >\n" ;
			$result = mail($recipient,$subject,$message,$headers) ;
			if ($result)	$note1 = "$custmsg/$name -- $rptmsg/$id -- $successmsg $custemail" ;
				else	$note1 = "$custmsg/$name -- $rptmsg/$id -- $failuremsg $custemail" ;
			$t->set_var('lang_note1',$note1);
			}
		}
	$t->parse('done_section','done',true);
	$t->pparse('out','items',report);
	exapi_footer() ;

?>
