<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.suspense.inc.php 0.15.1 2005/09/30 C K Wu

    class suspense {

//---- Suspense Item List SQL Formation

    function suspense_list_sql() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_bankac',exapi_lang('Bank Account'));
	list($dummy,$chart_id) = explode("'",$where) ;
	$result = $adodb->query("SELECT accno,description FROM ${pre}chart WHERE id='$chart_id'");
	$bankac = exapi_dbflds($result,'accno')."--".exapi_dbflds($result,'description') ;
	$t->set_var('bankac',$bankac);

	$sql =  "SELECT * FROM ${pre}bkr_trans WHERE substring(source,1,2)='SU' $where ORDER BY $order $sort" ;
	return $sql ;
	}

//---- Suspense Item Read

    function suspense_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$result = $adodb->query("select * from ${pre}bkr_trans where trans_id='$id'");
	return $result->fetchRow() ;
	}

//---- Suspense Item Detail Validation Checks

    function suspense_validate() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	if (!$dt[transdate])			$err=exapi_lang("Transaction date missing") ;
	if (!$dt[amount])			$err=exapi_lang("Amount missing") ;
	if ($dt[transdate] and input2date($dt[transdate])=="")
						$err=exapi_lang("Invalid transaction date");
	if ($dt[amount] and !is_numeric($dt[amount]))	$err=exapi_lang("Amount must be numeric");
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write Suspense Item Detail

    function suspense_write() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',exapi_lang('Audit ID'));
	$t->set_var('lang_chart_id',exapi_lang('Bank Account'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_transdate',exapi_lang('Transaction Date'));
	$t->set_var('lang_refnumber',exapi_lang('Reference#'));
	$t->set_var('lang_source',exapi_lang('Source'));
	$t->set_var('lang_cheque',exapi_lang('Cheque#'));
	$t->set_var('lang_amount',exapi_lang('Amount'));

	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$default = ($dt[chart_id]) ? "$dt[chart_id]" : "" ;
	$where = "WHERE (link like '%AP_paid%' or link like '%AR_paid%') and category='A'" ;
	$chart_id_sl = selectlist('chart','accno',$where,$default,'id','accno','description') ;
	$t->set_var('chart_id_selectlist',$chart_id_sl);
	$t->set_var('description',$dt[description]);
	$t->set_var('transdate',$dt[transdate]);
	$t->set_var('refnumber',$dt[refnumber]);
	$selectlist = "<OPTION value='SUSP'>".exapi_lang('Suspense Item')."</OPTION>";
	$source_sl = str_replace("'$dt[source]'","'$dt[source]'"." selected",$selectlist) ;
	$t->set_var('source_selectlist',$source_sl);
	$t->set_var('cheque',$dt[cheque]);
	$t->set_var('amount',$dt[amount]);
	$t->parse('out','report',True);
	}

//---- Suspense Item Post Initialisation

    function suspense_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][trans_id] = $ckapi[params_post][dt][id] ;
	}

//---- Suspense Item Post - PreCommit Routine

    function suspense_post_precommit() {
	global $ckapi,$adodb ;

	$table = $ckapi[params][table] ;
	if ($ckapi[params_post][op]=='new')	$adodb->query("UPDATE $table SET trans_id=id") ;
	}



    }

?>
