<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// ledgerlist.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-bank' ;
	$tran = 'ledger' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}bkr_trans" ,
				'doneexit'	=> "${tran}bulk.php"			);
	$msg1 = exapi_lang("Individual item edit -> click edit link;") ;
	$msg2 = exapi_lang("Bulk Update -> click column heading to arrange list in proper order, then click Bulk Update button.");
	$msg3 = exapi_lang("Non-payment items that (had) appeared in bank statement should also be flagged 'Cleared'.") ;

	$ckapi[phrases] = array('lang_title'	=> exapi_lang("List of Ledger Items") ,
				'lang_add'	=> exapi_lang("Bulk Update") ,
				'message'	=> "$msg1  $msg2<br>$msg3"		) ;
	$ckapi[columns] = array('transdate'	=> exapi_lang('Ledger Date') ,
				'source'	=> exapi_lang('Source') ,
				'description'	=> exapi_lang('Description') ,
				'refnumber'	=> exapi_lang('Ref Number') ,
				'cheque'	=> exapi_lang('Cheque') ,
				'amount'	=> exapi_lang('Amount (Dr being +ve)'),
				'status'	=> exapi_lang('Status') ,
				'id'		=> exapi_lang('Audit ID') 		);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> exapi_lang("View") ,
				'lang_edit'	=> exapi_lang("Edit") ,
				'lang_copy'	=> exapi_lang("Copy/Modify") ,
				'lang_delete'	=> exapi_lang("Delete") ,
				'lang_log'	=> exapi_lang("Log")				) ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_list() ;
	exapi_footer() ;

?>
