<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// importorgprsbulk.php 0.15.1 2005/09/30 C K Wu
	
	$app = 'ck-contact' ;
	$class = 'import' ;
	$tran = 'importorgprs' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)

	$imporgprs = newobj($app,$class) ;
	$ckapi[objects][tranobj] = &$imporgprs ;
	$t = exapi_tpl($app);
	$ckapi[objects][template] = &$t ;
	$proc1 = newobj('ck-api','process1') ;

	$reminder1 = exapi_lang("Don't forget to update the relevant Related Person / Assoicated Org Code for the imported links.") ;
	$reminder2 = exapi_lang("These information are not available from the host system.") ;
	$t->set_file('question','confirm.tpl');
	$t->set_var('lang_title',exapi_lang("Import Organization<=>Person Linkage Items"));
	$t->set_var('message','');
	$t->set_var('readonly',"readonly");
	$t->set_var('disabled',"disabled");

/*------------- Request contactimport lock ----------------------------*/

	$user = $ckapi[hostsys][username];
	$where1 = "WHERE resource='contactimport'" ;
	$result = $adodb->query("SELECT * FROM ${pre}resourcelock $where1");
	$used_by = exapi_dbflds($result,'used_by') ;
	if ($used_by=="")	
		$adodb->query("UPDATE ${pre}resourcelock SET used_by='$user' $where1");
	  else	{
		$error=exapi_lang("Error");	$err=exapi_lang("Contact Import is being accessed by ").$used_by;
		$t->set_var('lang_confirm',"$error:  $err");
		$t->set_var('lang_yes',exapi_lang('done'));
		$t->set_var('lang_no',exapi_lang('done'));
		$t->set_var('yes_action',exapi_link("/$app/importfilter.php")) ;
		$t->set_var('no_action',exapi_link("/$app/importfilter.php")) ;
		$t->pparse('out','question',True);
		exit() ;
		}

/*------------- Build $commcode, $addrcode array ----------------------------*/
	
	$user = $ckapi[hostsys][username];
	$temp = $ckapi[params][temp] = "${pre}importorgprsbulk".$user.time() ;

	$sql =	"CREATE TABLE $temp AS " ;
	$sql.=	"SELECT org_id, a.person_id, b.id as orid, c.id as pid,orgnumber,prsnumber,title,department " ;
	$sql.=	"FROM exapi_contact_org_person a, ${pre}org b, ${pre}person c, exapi_contact_person d " ;
	$sql.=	"WHERE org_id=substring(b.note,position('=' in b.note)+1) " ;
	$sql.=	"and a.person_id=substring(c.note,position('=' in c.note)+1) and a.person_id=d.person_id" ;
	$adodb->query($sql);
	$fields = "orid,pid,a.title,a.department,'n' as preferred " ;
	if ($ckapi[hostsys][dbtype]=="mysql") {
		$sql =	"SELECT $fields " ;
		$sql.=	"FROM ($temp a LEFT JOIN ${pre}org_person b ON orid=b.contactid and pid=personid) " ;
		$sql.=		"LEFT JOIN ${pre}person_org c ON pid=c.contactid and orid=orgid " ;
		$sql.=	"WHERE b.personid IS NULL and c.orgid IS NULL " ;
		}
	  else
		{	
		$sql =	"SELECT $fields " ;
		$sql.=	"FROM ($temp a LEFT JOIN ${pre}org_person b ON orid=b.contactid and pid=personid) " ;
		$sql.=		"LEFT JOIN ${pre}person_org c ON pid=c.contactid and orid=orgid " ;
		$sql.=	"EXCEPT " ;
		$sql.=	"SELECT $fields FROM $temp a, ${pre}org_person b, ${pre}person_org c " ;
		$sql.=	"WHERE orid=b.contactid and pid=personid and pid=c.contactid and orid=orgid " ;
		}

	$result = $adodb->query($sql);
	while ($org_person[] = $result->fetchRow())	;

/*------------- Import Contact Data into CK-ERP tables ---------------------*/

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $class ,
				'tran'		=> $tran ,
				'table'		=> "${pre}org"				) ;
	$ckapi[tables]["parents"] = array("${pre}org"=> "skipskip" 	);
	$ckapi[tables]["children"] = array("${pre}org_person"=> "contactid" 		);
	$ckapi[params_post][op] = "edit" ;

	$i = 0 ;
	foreach ($org_person as $key => $val) {
		$dt[id] = $id = $val[orid] ;
		$result = $adodb->query("SELECT * FROM ${pre}org where id='$id'");
		$dt[control] = exapi_dbflds($result,'control') ;
		$result = $adodb->query("SELECT * FROM ${pre}org_person where contactid='$id' order by personcode");
		For ($j=1;$rs=$result->fetchRow();$j++) {
			$dt['preferred'.$j]	=	$rs['preferred'] ;
			$dt['personid'.$j]	=	$rs['personid'] ;
			$dt['personcode'.$j]	=	$rs['personcode'] ;
			$dt['title'.$j]		=	$rs['title'] ;
			$dt['department'.$j]	=	$rs['department'] ;
			} 
		$dt['preferred'.$j]	=	$val['preferred'] ;
		$dt['personid'.$j]	=	$val['pid'] ;
		$dt['personcode'.$j]	=	"" ;
		$dt['title'.$j]		=	$val['title'] ;
		$dt['department'.$j]	=	$val['department'] ;
		$ckapi[params_post][dt] = $dt ;
		
		$proc1->process1_post() ;
		$i++ ;
		}
		
	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $class ,
				'tran'		=> "importprsorg" ,
				'table'		=> "${pre}person"				) ;
	$ckapi[tables]["parents"] = array("${pre}person"=> "skipskip" 	);
	$ckapi[tables]["children"] = array("${pre}person_org"=> "contactid" 		);
	$ckapi[params_post][op] = "edit" ;

	foreach ($org_person as $key => $val) {
		$dt[id] = $id = $val[pid] ;
		$result = $adodb->query("SELECT * FROM ${pre}person where id='$id'");
		$dt[control] = exapi_dbflds($result,'control') ;
		$result = $adodb->query("SELECT * FROM ${pre}person_org where contactid='$id' order by orgcode");
		For ($j=1;$rs=$result->fetchRow();$j++) {
			$dt['preferred'.$j]	=	$rs['preferred'] ;
			$dt['orgid'.$j]		=	$rs['orgid'] ;
			$dt['orgcode'.$j]	=	$rs['orgcode'] ;
			$dt['title'.$j]		=	$rs['title'] ;
			$dt['department'.$j]	=	$rs['department'] ;
			} 
		$dt['preferred'.$j]	=	$val['preferred'] ;
		$dt['orgid'.$j]		=	$val['orid'] ;
		$dt['orgcode'.$j]	=	"" ;
		$dt['title'.$j]		=	$val['title'] ;
		$dt['department'.$j]	=	$val['department'] ;
		$ckapi[params_post][dt] = $dt ;
		
		$proc1->process1_post() ;
		}


	$adodb->query("UPDATE ${pre}resourcelock SET used_by='' WHERE resource='contactimport'");
	
	if ($ckapi[params][temp]<>"") {
		$temp = $ckapi[params][temp] ;
		$adodb->query("DROP TABLE $temp");
		}

/*--------------------Write bottom Section------------------------------------------*/

	$link_confirm = "$i  ".exapi_lang('Contact Organization<=>Person Link(s) Imported') ;
	$reminder = exapi_lang('Please remember to rectify the org code and the person code for the imported links.');
	$t->set_var('lang_confirm',"$link_confirm<br><br>$reminder");
	$t->set_var('lang_yes',exapi_lang('done'));
	$t->set_var('lang_no',exapi_lang('done'));
	$t->set_var('yes_action',exapi_link("/$app/importfilter.php")) ;
	$t->set_var('no_action',exapi_link("/$app/importfilter.php")) ;
	$t->pparse('out','question',True);
	exapi_footer() ;

?>
