<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.import.inc.php 0.15.1 2005/09/30 C K Wu

    class import {

//---- Import Organization Summary List SQL Formation

    function importorgs_list_sql() {
	global $ckapi,$exapi ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$markter="zzDnAzz";
	$where = str_replace($markter,"substring(name,1,1)",$where) ;
	$sql =	"SELECT *,org_id as hostsysid FROM exapi_contact_org " ;
	$sql.=	"WHERE active='Y' $where ORDER BY $order $sort" ;
	
	return $sql ;
	}

//---- Import Organization Summary List Link Adjustement

    function importorgs_list_adjust() {
	global $ckapi,$exapi ;

	foreach ($ckapi[params_list] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;
	
	$t->set_var('orgnumber',str_replace(" ","_",$dt[name])) ;
	}

//---- Import Organization Detail List SQL Formation

    function importorgd_list_sql() {
	global $ckapi,$exapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$user = $ckapi[hostsys][username];
	$temp1 = $ckapi[params][temp1] = "${pre}importorg1".$user.time() ;

	$lang_comm = exapi_lang("communication") ;
	$lang_address = strtolower(exapi_lang("address")) ;
	$lang_others = exapi_lang("others") ;
	$lang_category = exapi_lang("category") ;
	if ($ckapi[hostsys][dbtype]=="mysql") {
		$addrflds = "concat(add1,'..',city,'..',country)" ;
		$inmask = "instr" ;
		$catmatched = "instr(b.cat_id,concat(',',c.cat_id,','))>0" ;
		}
	  else	{
		$addrflds = "add1||'..'||city||'..'||country" ;
		$inmask = "strpos" ;
		$catmatched = "strpos(b.cat_id,','||c.cat_id||',')>0" ;
	  	}
	$fields = "a.org_id as hostsysid,name,active" ;

	$sql =	"CREATE TABLE $temp1 AS " ;
	$sql.=	"SELECT $fields,'$lang_comm' as type,descr as nature,comm_data as data " ;
	$sql.=	"FROM exapi_contact_org a,exapi_contact_comm b,exapi_contact_comm_descr c ";
	$sql.=	"WHERE org_id=contact_id and b.comm_descr_id=c.comm_descr_id";
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp1 " ;
	$sql.=	"SELECT $fields,'$lang_address' as type,description as nature,$addrflds as data " ;
	$sql.=	"FROM exapi_contact_org a,exapi_contact_addr b,exapi_contact_addr_type c ";
	$sql.=	"WHERE org_id=contact_id and b.addr_type_id=c.addr_type_id";	
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp1 " ;
	$sql.=	"SELECT $fields,'$lang_others' as type,other_name as nature,other_value as data " ;
	$sql.=	"FROM exapi_contact_org a,exapi_contact_others b ";
	$sql.=	"WHERE org_id=contact_id";
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp1 " ;
	$sql.=	"SELECT $fields,'$lang_category' as type,cat_name as nature, cat_description as data ";
	$sql.=	"FROM exapi_contact_org a,exapi_contact b,exapi_categories c ";
	$sql.=	"WHERE org_id=b.contact_id and $catmatched and cat_appname='addressbook'";
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp1 " ;
	$sql.=	"SELECT $fields,'$lang_category' as type,cat_name as nature, cat_description as data ";
	$sql.=	"FROM exapi_contact_org a,exapi_contact b,exapi_categories c ";
	$sql.=	"WHERE org_id=b.contact_id and b.cat_id=c.cat_id and cat_appname='addressbook'";
	$adodb->query($sql);

	$markter="zzDnAzz";
	$where = str_replace($markter,"substring(name,1,1)",$where) ;
	$where = str_replace("(name","(a.name",$where) ;
	$sql = "SELECT org_id as hostsysid,a.name,a.active,type,nature,data ";	
	$sql.= "FROM exapi_contact_org a LEFT JOIN $temp1 b ON org_id=b.hostsysid " ;
	$sql.= "WHERE a.active='Y' $where ORDER BY $order $sort" ;

	return $sql ;
	}
			
//---- Import Organization Detail List Link Adjustement

    function importorgd_list_adjust() {
	global $ckapi,$exapi ;

	foreach ($ckapi[params_list] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;
	
	if ($dt[hostsysid]==$ckapi[params][lasthostsysid]) {
		$t->set_var('hostsysid',"") ;
		$t->set_var('name',"") ;
		$t->set_var('orgnumber',"") ;
		}
	  else	$t->set_var('orgnumber',str_replace(" ","_",$dt[name])) ;
	$ckapi[params][lasthostsysid] = $dt[hostsysid] ;
	}

//---- Import Contact Org Item Post - PreCommit Routine

    function importorg_post_precommit() {
	global $ckapi,$exapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	foreach ($dt[comm] as $key => $val) {
		$commdata = addslashes($val[commdata]) ;
		$adodb->query("INSERT INTO ${pre}comm(contactid,commdata,commcode) VALUES ('$id','$commdata','$val[commcode]')");
		}
	foreach ($dt[addr] as $key => $val) {
		$line1 = addslashes($val[line1]) ;
		$line2 = addslashes($val[line2]) ;
		$line3 = addslashes($val[line3]) ;
		$line4 = addslashes($val[line4]) ;
		$zip = addslashes($val[zip]) ;
		$sql ="INSERT INTO ${pre}address (contactid,line1,line2,line3,line4,addresscode,zip) ";
		$sql.= "VALUES ('$id','$line1','$line2','$line3','$line4','$val[addresscode]','$zip')" ;
		$adodb->query($sql);
		}
	foreach ($dt[cat] as $key => $val)
		$adodb->query("INSERT INTO ${pre}status (contactid,cttcode) VALUES ('$id','$val[cttcode]')");
	foreach ($dt[othr] as $key => $val) {
		$desc = addslashes($val[description]) ;
		$adodb->query("INSERT INTO ${pre}others (contactid,description,value) VALUES ('$id','$desc','$val[value]')");
		}
	}

//---- Import Person Summary List SQL Formation

    function importprss_list_sql() {
	global $ckapi,$exapi ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	if ($ckapi[hostsys][dbtype]=="mysql") {
		$family = "IFNULL(last_name,'')" ;
		$first = "IFNULL(first_name,'')" ;
		$middle = "IFNULL(middle_name,'')" ;
		$initials = "IFNULL(initials,'')" ;
		$given = "CONCAT($first,' ',$middle,' ',$initials) as given" ;
		$prsnumber = "CONCAT($family,'_',$first) as prsnumber" ;
		}
	  else	{
		$family = "COALESCE(last_name,'')" ;
		$first = "COALESCE(first_name,'')" ;
		$middle = "COALESCE(middle_name,'')" ;
		$initials = "COALESCE(initials,'')" ;
		$given = "$first || ' ' || $middle || ' ' || $initials as given" ;
		$prsnumber = "$family || '_' || $first as prsnumber" ;
		}
	$fields = "a.person_id as hostsysid,account_lid as username," ;
	$fields.= "last_name as family,$given,birthday,pubkey,$prsnumber";
	$markter="zzDnAzz";
	$where = str_replace($markter,"substring(last_name,1,1)",$where) ;
	$sql =	"SELECT $fields FROM exapi_contact_person a LEFT JOIN exapi_accounts b " ;
	$sql.=	"ON a.person_id=b.person_id WHERE active='Y' $where ORDER BY $order $sort" ;
	
	return $sql ;
	}

//---- Import Person Detail List SQL Formation

    function importprsd_list_sql() {
	global $ckapi,$exapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$user = $ckapi[hostsys][username];
	$temp1 = $ckapi[params][temp1] = "${pre}importprs1".$user.time() ;
	$temp2 = $ckapi[params][temp2] = "${pre}importprs2".$user.time() ;

	$lang_comm = exapi_lang("communication") ;
	$lang_address = strtolower(exapi_lang("address")) ;
	$lang_others = exapi_lang("others") ;
	$lang_category = exapi_lang("category") ;
	if ($ckapi[hostsys][dbtype]=="mysql") {
		$family = "IFNULL(last_name,'')" ;
		$first = "IFNULL(first_name,'')" ;
		$middle = "IFNULL(middle_name,'')" ;
		$initials = "IFNULL(initials,'')" ;
		$given = "CONCAT($first,' ',$middle,' ',$initials) as given" ;
		$prsnumber = "CONCAT($family,'_',$first) as prsnumber" ;
		$addrflds = "concat(add1,'..',city,'..',country)" ;
		$catmatched = "instr(b.cat_id,concat(',',c.cat_id,','))>0" ;
		}
	  else	{
		$family = "COALESCE(last_name,'')" ;
		$first = "COALESCE(first_name,'')" ;
		$middle = "COALESCE(middle_name,'')" ;
		$initials = "COALESCE(initials,'')" ;
		$given = "$first || ' ' || $middle || ' ' || $initials as given" ;
		$prsnumber = "$family || '_' || $first as prsnumber" ;
		$addrflds = "add1||'..'||city||'..'||country" ;
		$catmatched = "strpos(b.cat_id,','||c.cat_id||',')>0" ;
		}
	$fields = "a.person_id as hostsysid,last_name as family,$given,birthday,pubkey,$prsnumber,active";
	$sql =	"CREATE TABLE $temp1 AS " ;
	$sql.=	"SELECT $fields,'$lang_comm' as type,descr as nature,comm_data as data " ;
	$sql.=	"FROM exapi_contact_person a,exapi_contact_comm b,exapi_contact_comm_descr c ";
	$sql.=	"WHERE person_id=contact_id and b.comm_descr_id=c.comm_descr_id";
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp1 " ;
	$sql.=	"select $fields,'$lang_address' as type,description as nature,$addrflds as data " ;
	$sql.=	"FROM exapi_contact_person a,exapi_contact_addr b,exapi_contact_addr_type c ";
	$sql.=	"WHERE person_id=contact_id and b.addr_type_id=c.addr_type_id";	
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp1 " ;
	$sql.=	"SELECT $fields,'$lang_others' as type,'title' as nature,title as data " ;
	$sql.=	"FROM exapi_contact_person a WHERE title<>'' ";
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp1 " ;
	$sql.=	"SELECT $fields,'$lang_others' as type,'department' as nature,department as data " ;
	$sql.=	"FROM exapi_contact_person a WHERE department<>'' ";
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp1 " ;
	$sql.=	"SELECT $fields,'$lang_others' as type,'prefix' as nature,prefix as data " ;
	$sql.=	"FROM exapi_contact_person a WHERE prefix<>'' ";
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp1 " ;
	$sql.=	"SELECT $fields,'$lang_others' as type,'suffix' as nature,suffix as data " ;
	$sql.=	"FROM exapi_contact_person a WHERE suffix<>'' ";
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp1 " ;
	$sql.=	"SELECT $fields,'$lang_others' as type,'sound' as nature,sound as data " ;
	$sql.=	"FROM exapi_contact_person a WHERE sound<>''";
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp1 " ;
	$sql.=	"SELECT $fields,'$lang_others' as type,other_name as nature,other_value as data " ;
	$sql.=	"FROM exapi_contact_person a,exapi_contact_others b ";
	$sql.=	"WHERE person_id=contact_id";
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp1 " ;
	$sql.=	"SELECT $fields,'$lang_category' as type,cat_name as nature,cat_description as data " ;
	$sql.=	"FROM exapi_contact_person a,exapi_contact b,exapi_categories c ";
	$sql.=	"WHERE person_id=b.contact_id and $catmatched and cat_appname='addressbook'";
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp1 " ;
	$sql.=	"SELECT $fields,'$lang_category' as type,cat_name as nature,cat_description as data " ;
	$sql.=	"FROM exapi_contact_person a,exapi_contact b,exapi_categories c ";
	$sql.=	"WHERE person_id=b.contact_id and b.cat_id=c.cat_id and cat_appname='addressbook'";
	$adodb->query($sql);

	$sql =	"CREATE TABLE $temp2 AS " ;
	$sql.=	"SELECT $fields,account_lid as username " ;
	$sql.=	"FROM exapi_contact_person a LEFT JOIN exapi_accounts b " ;
	$sql.=	"ON a.person_id=b.person_id" ;
	$adodb->query($sql);

	$markter="zzDnAzz";
	$where = str_replace($markter,"substring(last_name,1,1)",$where) ;
	$where = str_replace("(last_name","(a.family",$where) ;
	$sql = "SELECT a.hostsysid,a.family,a.given,a.birthday,a.pubkey,a.prsnumber,a.active," ;
	$sql.= "username,type,nature,data ";	
	$sql.= "FROM $temp2 a LEFT JOIN $temp1 b ON a.hostsysid=b.hostsysid " ;
	$sql.= "WHERE a.active='Y' $where ORDER BY $order $sort" ;
	
	return $sql ;
	}

//---- Import Person List Link Adjustement

    function importprsd_list_adjust() {
	global $ckapi,$exapi ;

	foreach ($ckapi[params_list] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;
	
	if ($dt[hostsysid]==$ckapi[params][lasthostsysid]) {
		$t->set_var('hostsysid',"") ;
		$t->set_var('username',"") ;
		$t->set_var('family',"") ;
		$t->set_var('given',"") ;
		$t->set_var('birthday',"") ;
		$t->set_var('pubkey',"") ;
		$t->set_var('prsnumber',"") ;
		}
	$ckapi[params][lasthostsysid] = $dt[hostsysid] ;
	if ($dt[hostsysid]=='') {
		$t->set_var('hostsysid',$dt[hostsysid]) ;
		$t->set_var('username',$dt[username]) ;
		$t->set_var('family',$dt[family]) ;
		$t->set_var('given',$dt[given]) ;
		$t->set_var('birthday',$dt[birthday]) ;
		$t->set_var('pubkey',$dt[pubkey]) ;
		$t->set_var('prsnumber',$dt[prsnumber]) ;
		}
	}

//---- Import Contact Person Item Post - PreCommit Routine

    function importprs_post_precommit() {
	global $ckapi,$exapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	foreach ($dt[comm] as $key => $val) {
		$commdata = addslashes($val[commdata]) ;
		$sql="INSERT INTO ${pre}comm(contactid,commdata,commcode) ";
		$sql.= "VALUES ('$id','$commdata','$val[commcode]')" ;
		$adodb->query($sql);
		}
	foreach ($dt[addr] as $key => $val) {
		$line1 = addslashes($val[line1]) ;
		$line2 = addslashes($val[line2]) ;
		$line3 = addslashes($val[line3]) ;
		$line4 = addslashes($val[line4]) ;
		$zip = addslashes($val[zip]) ;
		$sql ="INSERT INTO ${pre}address (contactid,line1,line2,line3,line4,addresscode,zip) ";
		$sql.= "VALUES ('$id','$line1','$line2','$line3','$line4','$val[addresscode]','$zip')" ;
		$adodb->query($sql);
		}
	foreach ($dt[cat] as $key => $val) {
		$sql ="INSERT INTO ${pre}status (contactid,cttcode) VALUES ('$id','$val[cttcode]')" ;
		$adodb->query($sql);
		}
	foreach ($dt[othr] as $key => $val) {
		$desc = addslashes($val[description]) ;
		$sql ="INSERT INTO ${pre}others (contactid,description,value) VALUES ('$id','$desc','$val[value]')" ;
		$adodb->query($sql);
		}
	}

//---- Import Organization<=>Person List SQL Formation

    function importorgprs_list_sql() {
	global $ckapi,$exapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$user = $ckapi[hostsys][username];
	$temp = $ckapi[params][temp] = "${pre}importorgprs".$user.time() ;

	$sql =	"CREATE TABLE $temp AS " ;
	$sql.=	"SELECT org_id, a.person_id, b.id as orid, c.id as pid, " ;
	$sql.=	"orgnumber, prsnumber, title, department " ;
	$sql.=	"FROM exapi_contact_org_person a, ${pre}org b, ${pre}person c, exapi_contact_person d " ;
	$sql.=	"WHERE org_id=substring(b.note,position('=' in b.note)+1) " ;
	$sql.=	"and a.person_id=substring(c.note,position('=' in c.note)+1)" ;
	$sql.=	"and a.person_id=d.person_id" ;
	$adodb->query($sql);
	$fields = "org_id,person_id,orid,pid,orgnumber,prsnumber,a.title,a.department" ;
	if ($ckapi[hostsys][dbtype]=="mysql") {
		$sql =	"SELECT $fields FROM " ;
		$sql.=	"($temp a LEFT JOIN ${pre}org_person b ON orid=b.contactid and pid=personid) " ;
		$sql.=	"LEFT JOIN ${pre}person_org c ON pid=c.contactid and orid=orgid " ;
		$sql.=	"WHERE b.personid IS NULL and c.orgid IS NULL " ;
		$sql.=	"ORDER BY $order $sort" ;	
		}
	  else
		{	
		$sql =	"SELECT $fields FROM " ;
		$sql.=	"($temp a LEFT JOIN ${pre}org_person b ON orid=b.contactid and pid=personid) " ;
		$sql.=	"LEFT JOIN ${pre}person_org c ON pid=c.contactid and orid=orgid " ;
		$sql.=	"EXCEPT " ;
		$sql.=	"SELECT $fields FROM $temp a, ${pre}org_person b, ${pre}person_org c " ;
		$sql.=	"WHERE orid=b.contactid and pid=personid and pid=c.contactid and orid=orgid " ;
		$sql.=	"ORDER BY $order $sort" ;
		}
	return $sql ;
	}

//---- Importorgprs Post - PreCommit Routine

    function importorgprs_post_precommit() {
	global $ckapi,$exapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')	$adodb->query("DELETE from ${pre}org_person where contactid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['personid'.$i]);$i++) {
			$personid = $dt['personid'.$i] ;
			$personcode = $dt['personcode'.$i] ;
			$preferred = $dt['preferred'.$i] ;
			$title = addslashes($dt['title'.$i]) ;
			$department = addslashes($dt['department'.$i]) ;
			$sql = "INSERT INTO ${pre}org_person (contactid,personid,personcode,preferred,title,department) " ;
			$sql.= "VALUES('$id','$personid','$personcode','$preferred','$title','$department')" ;
			$adodb->query($sql);
			}
		}
	}

//---- Importprsorg Post - PreCommit Routine

    function importprsorg_post_precommit() {
	global $ckapi,$exapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')	$adodb->query("DELETE from ${pre}person_org where contactid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['orgid'.$i]);$i++) {
			$orgid = $dt['orgid'.$i] ;
			$orgcode = $dt['orgcode'.$i] ;
			$preferred = $dt['preferred'.$i] ;
			$title = addslashes($dt['title'.$i]) ;
			$department = addslashes($dt['department'.$i]) ;
			$sql = "INSERT INTO ${pre}person_org (contactid,orgid,orgcode,preferred,title,department) " ;
			$sql.= "VALUES('$id','$orgid','$orgcode','$preferred','$title','$department')" ;
			$adodb->query($sql);
			}
		}
	}

    }

?>
