<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.contract.inc.php 0.15.1 2005/09/30 C K Wu

    class contract {

//---- Contract List SQL Formation

    function contract_list_sql() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$table = $ckapi[params][table] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$last10 = substr($where,strlen($where)-10,10) ;
	if ($last10==' AND OPEN '){
		$todayy = date("Y-m-d",mktime()) ;
		$where = substr($where,0,strlen($where)-10) ;
		$where.= " AND start<='$todayy' AND endd>='$todayy'" ;
		}
	$sql =	"SELECT * FROM $table WHERE $where ORDER BY $order $sort";
	return $sql ;
	}
	
//---- Contract Data Read

    function contract_read() {
	global $ckapi,$pre,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;

	$result = $adodb->query("SELECT * FROM $table WHERE id='$id'");
	$dt = $result->fetchRow() ;
	$table = $pre."stdterm" ;
	$result = $adodb->query("SELECT * FROM $table WHERE contractid='$id' ORDER BY id");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['stdpara'.$i]	=	$rs['stdpara'] ;
		$dt['catid'.$i]		=	$rs['catid'] ;
		}
	$table = $pre."spcterm" ;
	$result = $adodb->query("SELECT * FROM $table WHERE contractid='$id' ORDER BY id");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['spcpara'.$i]	=	$rs['spcpara'] ;
		$dt['detail'.$i]	=	$rs['detail'] ;
		}
	if ($ckapi[params_post][op]=="edit")	$dt[oldcntnumber] = $dt[cntnumber] ;
	
	return $dt ;
	}

//---- contract Detail Validation Checks

    function contract_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error");
	$stdrow = exapi_lang("stdRow") ;
	$spcrow = exapi_lang("spcRow") ;
	if ($dt[customer]=="")				$err=exapi_lang("Customer ID Missing - snhh");
	if ($dt[cntnumber]=="")				$err=exapi_lang("Contract Number Missing");
	if ($dt[start]=="")				$err=exapi_lang("Contract Starting Date Missing");
	  else	{
	  	$date=input2date( $dt[start] ) ;
		if ($date=="")				$err=exapi_lang("Invalid Contract Starting Date");
		}
	if ($dt[endd]=="")				$err=exapi_lang("Contract Ending Date Missing");
	  else	{
	  	$date=input2date( $dt[endd] ) ;
		if ($date=="")				$err=exapi_lang("Invalid Contract Ending Date");
		}
	if ($dt[start]<>"" and $dt[endd]<>"" and strtotime($dt[start])>strtotime($dt[endd]))
							$err=exapi_lang("Starting Date later than Ending Date") ; 
	For ($i=1;isset($dt["stdrowno$i"]);$i++) {
		$rowi = "[$stdrow $i]" ;
		if ($dt['stdpara'.$i]=="")		$err=$rowi.exapi_lang("Paragraph#/Reference# Missing");
		if ($dt['catid'.$i]=="")		$err=$rowi.exapi_lang("Standard Term ID Missing - snhh");
		}
	For ($i=1;isset($dt["spcrowno$i"]);$i++) {
		$rowi = "[$spcrow $i]" ;
		if ($dt['spcpara'.$i]=="")		$err=$rowi.exapi_lang("Paragraph#/Reference# Missing");
		if ($dt['detail'.$i]=="")		$err=$rowi.exapi_lang("Special Term Description Missing");
		}
	if ($dt[cntnumber]<>$dt[oldcntnumber]) {
		$result = $adodb->query("SELECT * from ${pre}scontract where cntnumber='$dt[cntnumber]'");
		if (exapi_dbrc($result)>0)		$err = exapi_lang("Contract Name/# already exists") ;
		}
	
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- contract Delete Validation Checks

    function delete_validate() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Contract Header

    function contract_header_write() {
	global $ckapi ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',exapi_lang('Audit ID').':');
	$t->set_var('lang_customer',exapi_lang('Customer'));
	$t->set_var('lang_cntnumber',exapi_lang('Contract Name/#'));
	$t->set_var('lang_start',exapi_lang('Starting Date'));
	$t->set_var('lang_endd',exapi_lang('Ending Date'));

	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('customer_selectlist',selectlist('customer','name','',$dt[customer],'id','name','id')) ;
	$t->set_var('cntnumber',$dt[cntnumber]) ;
	$t->set_var('start',$dt[start]) ;
	$t->set_var('endd',$dt[endd]) ;
	if ($ckapi[params_post][op]=="edit")		$t->set_var('oldcntnumber',$dt[oldcntnumber]) ;

	$t->parse('out','report',True);
	}

//---- Write Contract Detail to Screen

    function contract_detail_write() {
	global $ckapi ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$id = &$ckapi[params_post][id] ;
	$t = &$ckapi[objects][template] ;
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

	$t->set_block('report','stdterm','stdterm_section');
	$t->set_block('report','spcterm','spcterm_section');

	$stdrow_ = exapi_lang('stdRow')." " ;
	$spcrow_ = exapi_lang('spcRow')." " ;
	$lang_term = exapi_lang('term') ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('lang_stdterm',exapi_lang('Standard Contract Terms'));
	$t->set_var('lang_spcterm',exapi_lang('Special Contract Terms'));
	$t->set_var('lang_insert',exapi_lang('Insert before'));
	$t->set_var('lang_paranumber',exapi_lang('Paragraph# / Reference#'));
	$t->set_var('lang_std_detail',exapi_lang('Standard Term (Code -- Description -- ID)'));
	$t->set_var('lang_spc_detail',exapi_lang('Special Term Description (Manual Input)'));
	$t->set_var('lang_delete_cap',exapi_lang('Delete'));

	$catid_sl = selectlist('category','type',"WHERE app='$app' and type='$lang_term'",'','id','name','id') ;
	if (isset($insert))	$insrowno = intval(str_replace($stdrow_,"",$insert));
	if ($insrowno==0)	$insrowno = 999999 ;
	if (isset($delete))	$delrowno = intval(str_replace($stdrow_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($dt['catid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('stdinsrowno',$stdrow_.$i) ;
			$t->set_var('stdpara_fld',"stdpara$i") ;
			$t->set_var('catid_fld',"catid$i") ;
			$t->set_var('stdrowno_fld',"stdrowno$i") ;
			$t->set_var('stdpara',"") ;
			$t->set_var('catid_selectlist',$catid_sl);
			$t->set_var('stddelrowno',$stdrow_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('stdterm_section','stdterm', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;
		$stdpara	=	$dt['stdpara'.$i] ;
		$catid		=	$dt['catid'.$i] ;
		$t->set_var('stdpara_fld',"stdpara$j") ;
		$t->set_var('catid_fld',"catid$j") ;
		$t->set_var('stdrowno_fld',"stdrowno$j") ;
		$t->set_var('stdpara',$stdpara) ;
		$t->set_var('catid_selectlist',str_replace("'$catid'","'$catid' selected",$catid_sl));
		if ($posted)	$t->set_var('stdinsrowno',"done") ; else	$t->set_var('stdinsrowno',$stdrow_.$j) ;
		if ($posted)	$t->set_var('stddelrowno',"done") ; else	$t->set_var('stddelrowno',$stdrow_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('stdterm_section','stdterm', True);
		}
	if ($stdnewrow) {
		$t->set_var('stdinsrowno',$stdrow_.$i) ;
		$t->set_var('stdpara_fld','stdpara'.$i) ;
		$t->set_var('catid_fld','catid'.$i) ;
		$t->set_var('stdrowno_fld',"stdrowno$i") ;
		$t->set_var('stdpara',"") ;
		$t->set_var('catid_selectlist',$catid_sl);
		$t->set_var('stddelrowno',$stdrow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('stdterm_section','stdterm', True);
		}
	if (($i==1 and $stdnewrow=="") or ($i==2 and $delrowno==1))	$t->set_var('stdterm_section',"") ;

	if (isset($insert))	$insrowno = intval(str_replace($spcrow_,"",$insert));
	if ($insrowno==0)	$insrowno = 999999 ;
	if (isset($delete))	$delrowno = intval(str_replace($spcrow_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($dt['detail'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('spcinsrowno',$spcrow_.$i) ;
			$t->set_var('spcpara_fld',"spcpara$i") ;
			$t->set_var('detail_fld',"detail$i") ;
			$t->set_var('spcrowno_fld',"spcrowno$i") ;
			$t->set_var('spcpara',"") ;
			$t->set_var('detail',"");
			$t->set_var('spcdelrowno',$spcrow_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('spcterm_section','spcterm', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;
		$spcpara	=	$dt['spcpara'.$i] ;
		$detail		=	$dt['detail'.$i] ;
		$t->set_var('spcpara_fld',"spcpara$j") ;
		$t->set_var('detail_fld',"detail$j") ;
		$t->set_var('spcrowno_fld',"spcrowno$j") ;
		$t->set_var('spcpara',$spcpara) ;
		$t->set_var('detail',$detail) ;
		if ($posted)	$t->set_var('spcinsrowno',"done") ; else	$t->set_var('spcinsrowno',$spcrow_.$j) ;
		if ($posted)	$t->set_var('spcdelrowno',"done") ; else	$t->set_var('spcdelrowno',$spcrow_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('spcterm_section','spcterm', True);
		}
	if ($spcnewrow) {
		$t->set_var('spcinsrowno',$spcrow_.$i) ;
		$t->set_var('spcpara_fld',"spcpara$i") ;
		$t->set_var('detail_fld',"detail$i") ;
		$t->set_var('spcrowno_fld',"spcrowno$i") ;
		$t->set_var('spcpara',"") ;
		$t->set_var('detail',"");
		$t->set_var('spcdelrowno',$spcrow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('spcterm_section','spcterm', True);
		}
	if (($i==1 and $spcnewrow=="") or ($i==2 and $delrowno==1))	$t->set_var('spcterm_section',"") ;

	$t->parse('out','report',True);
	}

//---- Contract Post - PreCommit Routine

    function contract_post_precommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new') {
		$adodb->query("DELETE from ${pre}stdterm where contractid='$id'");
		$adodb->query("DELETE from ${pre}spcterm where contractid='$id'");
		}
	if ($op<>'delete') {
		For ($i=1;isset($dt["stdrowno$i"]);$i++) {
			$stdpara	=	addslashes($dt["stdpara$i"]) ;
			$catid		=	$dt["catid$i"];
			$adodb->query("INSERT INTO ${pre}stdterm (contractid,stdpara,catid) VALUES ('$id','$stdpara','$catid')");
			}
		For ($i=1;isset($dt["spcrowno$i"]);$i++) {
			$spcpara	=	addslashes($dt["spcpara$i"]) ;
			$detail		=	addslashes($dt["detail$i"]) ;
			$adodb->query("INSERT INTO ${pre}spcterm (contractid,spcpara,detail) VALUES ('$id','$spcpara','$detail')");
			}
		}
	}

    }
