<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.helpcase.inc.php 0.15.1 2005/09/30 C K Wu

    class helpcase {

//---- Callcase List SQL Formation

    function helpcase_list_sql() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$app = $ckapi[params][app] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$lang_noncustomer = exapi_lang('Non-Customer') ;
	$user = $ckapi[hostsys][username] ;
	$ckapi[params_sql][temp] = $temp = "${pre}tmphelpcase".$user.time() ;
	$fields = "casenumber,name,description,customer,start,a.id as id" ;
	$sql = "SELECT $fields FROM ${pre}helpcase a,${pre}customer b, ${pre}org c WHERE a.customer = b.id and b.contactid=c.id" ;
	$adodb->query("CREATE TABLE $temp AS $sql");
	$fields = "casenumber,name,description,customer,start,a.id as id" ;
	$sql = "SELECT $fields FROM ${pre}helpcase a,${pre}customer b, ${pre}person c WHERE a.customer = b.id and b.contactid=c.id" ;
	$adodb->query("INSERT INTO $temp $sql") ;
	$fields = "casenumber,'$lang_noncustomer' as name,description,customer,start,id" ;
	$sql = "SELECT $fields FROM ${pre}helpcase WHERE customer='0'" ;
	$adodb->query("INSERT INTO $temp $sql") ;
	$last10 = substr($where,strlen($where)-10,10) ;
	if ($last10==' AND OPEN '){
		$where = substr($where,0,strlen($where)-10) ;
		$lang_helpcall = strtolower(exapi_lang('helpcall'));	$lang_close = strtolower(exapi_lang('closure')) ;
		$result = $adodb->query("SELECT id FROM ${pre}category where app='ck-crm' and type='$lang_helpcall' and name='$lang_close'");
		$cloid = exapi_dbflds($result,'id') ;
		if ($ckapi[hostsys][dbtype]=="mysql")	{
			$sql = "SELECT a.* FROM $temp a LEFT JOIN ${pre}helpcall b " ;
			$sql.= "ON caseid=a.id and callcatid='$cloid' WHERE b.id is null and $where" ;
			}
		  else	{
		  	$sql = "SELECT * FROM $temp WHERE $where EXCEPT " ;
			$sql.= "SELECT a.* FROM $temp a, ${pre}helpcall b WHERE caseid=a.id and callcatid='$cloid'"; 
			}
		}
	  else	$sql =	"SELECT * FROM $temp WHERE $where ORDER BY $order $sort";
	return $sql ;
	}

//---- helpcase Data Read

    function helpcase_read() {
	global $ckapi,$pre,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;

	$result = $adodb->query("SELECT * FROM $table WHERE id='$id'");
	$dt = $result->fetchRow() ;
	$table = $pre."helpcall" ;
	$result = $adodb->query("SELECT * FROM $table WHERE caseid='$id' ORDER BY id");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt["calldate$i"]	=	$rs['calldate'] ;
		$dt["calltime$i"]	=	$rs['calltime'] ;
		$dt["callcatid$i"]	=	$rs['callcatid'] ;
		$dt["mediacatid$i"]	=	$rs['mediacatid'] ;
		$dt["prsfrom$i"]	=	$rs['prsfrom'] ;
		$dt["prsto$i"]		=	$rs['prsto'] ;
		$dt["statecatid$i"]	=	$rs['statecatid'] ;
		$dt["assigned$i"]	=	$rs['assigned'] ;
		$dt["actioned$i"]	=	$rs['actioned'] ;
		$dt["deadline$i"]	=	$rs['deadline'] ;
		$dt["hours$i"]		=	$rs['hours'] ;
		$dt["summary$i"]	=	$rs['summary'] ;
		$dt["rowno$i"]		=	"dummy" ;
		}
	if ($ckapi[params_post][op]=="edit")	$dt[oldcasenumber] = $dt[casenumber] ;
	
	return $dt ;
	}

//---- Write helpcase Header

    function helpcase_header_write() {
	global $ckapi ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',exapi_lang('Audit ID').':');
	$t->set_var('lang_casenumber',exapi_lang('Case Name/#'));
	$t->set_var('lang_casecat',exapi_lang('Case Category'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_start',exapi_lang('Date History Log Started'));
	$t->set_var('lang_customer',exapi_lang('Customer'));
	$t->set_var('lang_contact',exapi_lang('Contact'));
	$t->set_var('lang_item',exapi_lang('Relevant Product/Service'));
	$t->set_var('lang_priority',exapi_lang('Priority'));
	$t->set_var('lang_bill',exapi_lang('Billable'));
	$t->set_var('billmsg','');
	$t->set_var('lang_monitor',exapi_lang('Monitoring Officer'));

	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('casenumber',$dt[casenumber]) ;
	$t->set_var('description',$dt[description]) ;
	$t->set_var('start',$dt[start]) ;
	$lang_helpcase = exapi_lang('helpcase') ;
	$t->set_var('casecat_selectlist',selectlist('category','type',"WHERE id='$dt[casecatid]'",'','id','name','id')) ;
	$customer_sl = "<OPTION value='0'>".exapi_lang("Non-Customer")."</OPTION>" ;
	$customer_sl.= selectlist('customer','name',"WHERE id='$dt[customer]'",'','id','name','id') ;
	$customer_sl = str_replace("'$dt[customer]'","'$dt[customer]'"." selected",$customer_sl) ;
	$t->set_var('customer_selectlist',$customer_sl) ;
	$t->set_var('item_selectlist',item_selectlist('',$dt[itemid])) ;
	$t->set_var('priority_selectlist',selectlist('category','type',"WHERE id='$dt[pricatid]'",'','id','name','id')) ;
	$yesno_sl = "<OPTION value='y'>".exapi_lang('Yes')."</option><OPTION value='n'>".exapi_lang('No')."</option>" ;
	$yesno_sl = str_replace("'$dt[billable]'","'$dt[billable]'"." selected",$yesno_sl) ;
	$t->set_var('bill_selectlist',$yesno_sl) ;
	$t->set_var('monitor_selectlist',selectlist('employee','name',"WHERE id='$dt[monitor]'",'','id','name','id')) ;

	if ($ckapi[params_post][op]=="edit")		$t->set_var('oldcasenumber',$dt[oldcasenumber]) ;

	$t->parse('out','report',True);
	}

//---- Write Callcase Detail to Screen

    function helpcase_detail_write() {
	global $ckapi ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$id = &$ckapi[params_post][id] ;
	$t = &$ckapi[objects][template] ;
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

	$row_ = exapi_lang('Row')." " ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('lang_caselog',exapi_lang('Call Case History Log'));
	$t->set_var('lang_insert',exapi_lang('Insert before'));
	$t->set_var('lang_calldate',exapi_lang('Date'));
	$t->set_var('lang_calltime',exapi_lang('Time<br>[HHmm]'));
	$t->set_var('lang_callcatid',exapi_lang('Type'));
	$t->set_var('lang_mediacatid',exapi_lang('Media'));
	$t->set_var('lang_prsfrom',exapi_lang('Person From'));
	$t->set_var('lang_prsto',exapi_lang('Person To'));
	$t->set_var('lang_statecatid',exapi_lang('Caller State of Mind'));
	$t->set_var('lang_assigned',exapi_lang('<- Followup Action Assigned to'));
	$t->set_var('lang_deadline',exapi_lang('<- Response Deadline'));
	$t->set_var('lang_actioned',exapi_lang('<- Actioned by'));
	$t->set_var('lang_hours',exapi_lang('<- Hours Spent'));
	$t->set_var('lang_summary',exapi_lang('Summary'));
	$t->set_var('lang_delete_cap',exapi_lang('Delete'));

	$lang_helpcall = exapi_lang('helpcall') ;
	$lang_media = exapi_lang('media') ;
	$lang_state = exapi_lang('cstate') ;
	$callcatid_sl = selectlist('category','type',"WHERE app='ck-crm' and type='$lang_helpcall'",'','id','name','id') ;
	$mediacatid_sl = selectlist('category','type',"WHERE app='ck-crm' and type='$lang_media'",'','id','name','id') ;
	$statecatid_sl = "<OPTION value='0'></OPTION>".selectlist('category','type',"WHERE app='ck-crm' and type='$lang_state'",'','id','name','id') ;
	$employee_sl = "<OPTION value='0'></OPTION>".selectlist('employee','name','','','id','name','id') ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($dt["rowno$i"]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('calldate_fld',"calldate$i") ;
			$t->set_var('calltime_fld',"calltime$i") ;
			$t->set_var('callcatid_fld',"callcatid$i") ;
			$t->set_var('mediacatid_fld',"mediacatid$i") ;
			$t->set_var('prsfrom_fld',"prsfrom$i") ;
			$t->set_var('prsto_fld',"prsto$i") ;
			$t->set_var('statecatid_fld',"statecatid$i") ;
			$t->set_var('assigned_fld',"assigned$i") ;
			$t->set_var('deadline_fld',"deadline$i") ;
			$t->set_var('actioned_fld',"actioned$i") ;
			$t->set_var('hours_fld',"hours$i") ;
			$t->set_var('summary_fld',"summary$i") ;
			$t->set_var('rowno_fld',"rowno$i") ;
			$t->set_var('calldate',"") ;
			$t->set_var('calltime',"") ;
			$t->set_var('callcatid_selectlist',$callcatid_sl);
			$t->set_var('mediacatid_selectlist',$mediacatid_sl);
			$t->set_var('prsfrom',"") ;
			$t->set_var('prsto',"") ;
			$t->set_var('statecatid_selectlist',$statecatid_sl);
			$t->set_var('assigned_selectlist',$employee_sl);
			$t->set_var('deadline',"") ;
			$t->set_var('actioned_selectlist',$employee_sl);
			$t->set_var('hours',"") ;
			$t->set_var('summary',"") ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;
		$calldate	=	$dt['calldate'.$i] ;
		$calltime	=	$dt['calltime'.$i] ;
		$callcatid	=	$dt['callcatid'.$i] ;
		$mediacatid	=	$dt['mediacatid'.$i] ;
		$prsfrom	=	$dt['prsfrom'.$i] ;
		$prsto		=	$dt['prsto'.$i] ;
		$statecatid	=	$dt['statecatid'.$i] ;
		$assigned	=	$dt['assigned'.$i] ;
		$deadline	=	$dt['deadline'.$i] ;
		$actioned	=	$dt['actioned'.$i] ;
		$hours		=	$dt['hours'.$i] ;
		$summary	=	$dt['summary'.$i] ;
		$t->set_var('calldate_fld',"calldate$j") ;
		$t->set_var('calltime_fld',"calltime$j") ;
		$t->set_var('callcatid_fld',"callcatid$j") ;
		$t->set_var('mediacatid_fld',"mediacatid$j") ;
		$t->set_var('prsfrom_fld',"prsfrom$j") ;
		$t->set_var('prsto_fld',"prsto$j") ;
		$t->set_var('statecatid_fld',"statecatid$j") ;
		$t->set_var('assigned_fld',"assigned$j") ;
		$t->set_var('deadline_fld',"deadline$j") ;
		$t->set_var('actioned_fld',"actioned$j") ;
		$t->set_var('hours_fld',"hours$j") ;
		$t->set_var('summary_fld',"summary$j") ;
		$t->set_var('rowno_fld',"rowno$j") ;
		$t->set_var('calldate',$calldate) ;
		$t->set_var('calltime',$calltime) ;
		$t->set_var('callcatid_selectlist',str_replace("'$callcatid'","'$callcatid' selected",$callcatid_sl));
		$t->set_var('mediacatid_selectlist',str_replace("'$mediacatid'","'$mediacatid' selected",$mediacatid_sl));
		$t->set_var('prsfrom',$prsfrom) ;
		$t->set_var('prsto',$prsto) ;
		$t->set_var('statecatid_selectlist',str_replace("'$statecatid'","'$statecatid' selected",$statecatid_sl));
		$t->set_var('assigned_selectlist',str_replace("'$assigned'","'$assigned' selected",$employee_sl));
		$t->set_var('deadline',$deadline) ;
		$t->set_var('actioned_selectlist',str_replace("'$actioned'","'$actioned' selected",$employee_sl));
		$t->set_var('hours',$hours) ;
		$t->set_var('summary',$summary) ;
		if ($posted)	$t->set_var('insrowno',"done");  else $t->set_var('insrowno',$row_.$j);
		if ($posted)	$t->set_var('delrowno',"done");  else $t->set_var('delrowno',$row_.$j);
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('calldate_fld',"calldate$i") ;
		$t->set_var('calltime_fld',"calltime$i") ;
		$t->set_var('callcatid_fld',"callcatid$i") ;
		$t->set_var('mediacatid_fld',"mediacatid$i") ;
		$t->set_var('prsfrom_fld',"prsfrom$i") ;
		$t->set_var('prsto_fld',"prsto$i") ;
		$t->set_var('statecatid_fld',"statecatid$i") ;
		$t->set_var('assigned_fld',"assigned$i") ;
		$t->set_var('deadline_fld',"deadline$i") ;
		$t->set_var('actioned_fld',"actioned$i") ;
		$t->set_var('hours_fld',"hours$i") ;
		$t->set_var('summary_fld',"summary$i") ;
		$t->set_var('rowno_fld',"rowno$i") ;
		$t->set_var('calldate',"") ;
		$t->set_var('calltime',"") ;
		$t->set_var('callcatid_selectlist',$callcatid_sl);
		$t->set_var('mediacatid_selectlist',$mediacatid_sl);
		$t->set_var('prsfrom',"") ;
		$t->set_var('prsto',"") ;
		$t->set_var('statecatid_selectlist',$statecatid_sl);
		$t->set_var('assigned_selectlist',$employee_sl);
		$t->set_var('deadline',"") ;
		$t->set_var('actioned_selectlist',$employee_sl);
		$t->set_var('hours',"") ;
		$t->set_var('summary',"") ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if (($i==1 and $newrow=="") or ($i==2 and $delrowno==1))	$t->set_var('detail_section',"") ;

	$t->parse('out','report',True);
	}

    }
