<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.attend.inc.php 0.15.1 2005/09/30 C K Wu

    class attend {

//---- Attendance List SQL Formation

    function attend_list_sql() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$app = $ckapi[params][app] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	if (!$order) {$order = "name,transdate,time" ; }
	if (!$sort)  {$sort = "ASC" ; }
	$sql =  "SELECT b.name,d.description as dept,transdate,time,a.type," ;
	$sql.=	"c.description as reason, a.id as id " ;
	$sql.=  "FROM ${pre}attendance a,${pre}employee b,${pre}category c,${pre}department d ";
	$sql.=  "WHERE empid=b.id and a.type=c.type and c.app='$app' and " ;
	$sql.=	"b.dept=d.id and a.reason=c.name $where" ;
	$sql.=	"order by $order $sort" ;
	return $sql ;
	}

//---- Attendance Read

    function attend_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;

	$result = $adodb->query("SELECT * from $table WHERE id='$id'");
	$dt = $result->fetchRow() ;
	$dt[signin] = $dt[signout] = $dt[reason] ;
	if (!is_array($uniqueflds))	return $dt ;
	  else  {foreach ($uniqueflds as $key => $val)	$dt["old$val"]=$dt["$val"];	return $dt ;}
	}

//---- attend Detail Validation Checks

    function attend_validate() {
	global $ckapi ;

//	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$lang_si = exapi_lang('sign-in') ;
	$lang_so = exapi_lang('sign-out') ;
	$err=""; $error = exapi_lang("Error") ;
	$time = $dt[time] ;
	$hr = substr($time,0,2) ;
	$t2 = substr($time,2,1) ;
	$mn = substr($time,3,2) ;
	$t5 = substr($time,5,1) ;
	$sc = substr($time,6,2) ;
	if (input2date($dt[transdate])=="")		$err=exapi_lang("Invalid Date") ;
	if ($hr<0 or $hr>23)				$err=exapi_lang("Invalid Time") ;
	if ($mn<0 or $mn>59)				$err=exapi_lang("Invalid Time") ;
	if ($sc<0 or $sc>59)				$err=exapi_lang("Invalid Time") ;
	if ($t2<>":" or $t5<>":")			$err=exapi_lang("Invalid Time Format") ;
	if ($dt[type]=="$lang_si" and $dt[signin]=='')	$err=exapi_lang("Sign in Reason Missing") ;
	if ($dt[type]=="$lang_so" and $dt[signout]=='')	$err=exapi_lang("Sign out Reason Missing") ;
	if ($dt[signin]<>'' and $dt[signout]<>'')	$err=exapi_lang("Both Sign In & Out Reasons are active") ;
	if ($err)					$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Attendance Detail

    function attend_write() {
	global $ckapi ;

	$app = $ckapi[params][app] ;
	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$lang_si = exapi_lang('sign-in') ;
	$lang_so = exapi_lang('sign-out') ;
	$blankopt = "<OPTION value=''></OPTION>" ;
	$type_sl = "<OPTION value='$lang_si'>$lang_si</OPTION>" ;
	$type_sl.= "<OPTION value='$lang_so'>$lang_so</OPTION>" ;
	$t->set_var('lang_empid',exapi_lang('Employee Name/#'));
	$t->set_var('lang_id',exapi_lang('ID#'));
	$t->set_var('lang_transdate',exapi_lang('Date'));
	$t->set_var('lang_time',exapi_lang('Time'));
	$t->set_var('lang_type',exapi_lang('Type'));
	$t->set_var('lang_signin',exapi_lang('Sign In Reason'));
	$t->set_var('lang_signout',exapi_lang('Sign Out Reason'));

	$where = (!$uniwhere) ? " WHERE id='$dt[empid]' " : $uniwhere;
	$t->set_var('empid_selectlist',selectlist('employee','name',$where,$dt[empid],'id','name','id')) ;
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('transdate',$dt[transdate]);
	$t->set_var('time',$dt[time]);
	$t->set_var('type_selectlist',str_replace("'$dt[type]'","'$dt[type]' selected",$type_sl));

	$signin_sl = $blankopt.selectlist('category','name',"WHERE app='$app' and type='$lang_si'",'','name','name','substring(description,1,25)') ;
	$signin_sl = str_replace("'$dt[signin]'","'$dt[signin]' selected",$signin_sl) ;
	$t->set_var('signin_selectlist',$signin_sl);
	$signout_sl = $blankopt.selectlist('category','name',"WHERE app='$app' and type='$lang_so'",'','name','name','substring(description,1,25)') ;
	$signout_sl = str_replace("'$dt[signout]'","'$dt[signout]' selected",$signout_sl) ;
	$t->set_var('signout_selectlist',$signout_sl);

	$t->parse('out','report',True);
	}

//---- Attendance Post Initialisation

    function attend_post_init() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;

	$lang_si = exapi_lang('sign-in') ;
	$lang_so = exapi_lang('sign-out') ;
	$ckapi[params_post][dt][reason] = ($dt[type]=="$lang_si") ? $dt[signin] : $dt[signout] ;
	}

    }

?>
