<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.category.inc.php 0.15.1 2005/09/30 C K Wu

    class category {

//---- HR Code Detail Validation Checks

    function category_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang("Error") ;
	$maxname = 10 ;
	$maxdesc = 40 ;
	$desc = $dt[description] ;
	if ($dt[name]=="")			$err = exapi_lang("HR code name Missing") ;
	   else if (strlen($dt[name])>$maxname)	$err = exapi_lang("HR code name too long") ;
	if ($desc=="")				$err = exapi_lang("HR code description Missing") ;
	   else if (strlen($desc)>$maxdesc)	$err = exapi_lang("HR code description too long") ;
	if ($dt[type]<>$dt[oldtype] or $dt[name]<>$dt[oldname]) {
		$result = $adodb->query("SELECT * from ${pre}category where app='ck-hr' and type='$dt[type]' and name='$dt[name]'");
		if (exapi_dbrc($result)>0)	$err = exapi_lang("Type/Name Combo already exists") ;
		}
	if ($dt[app]<>$ckapi[params][app])	$err = exapi_lang("Invalid hidden app var -> Inform system admin") ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- HR Code Delete Validation Checks

    function delete_validate() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	$allow = $dt[allowdelete] ;
	if ($allow<>"y" and $allow<>"Y")	$err = exapi_lang("HR code flagged deletion not allowed");
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write HR Code Detail

    function category_write() {
	global $ckapi ;

	$app = $ckapi[params][app] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$dt[parent] = 0 ;
	$lang_comm = strtolower(exapi_lang('comm')) ;
	$noyes_sl = "<OPTION value='n'>".exapi_lang('No')."</OPTION>" ;
	$noyes_sl.= "<OPTION value='y'>".exapi_lang('Yes')."</OPTION>" ;
	$t->set_var('lang_id',exapi_lang('Audit ID').': ');
	$t->set_var('lang_type',exapi_lang('Code Type'));
	$t->set_var('lang_name',exapi_lang('Code Name'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_adelete',exapi_lang('Allow Delete'));
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('app',$app);
	$t->set_var('type_selectlist',selectlist('category','type',"WHERE app='$app' and type<>'$lang_comm'",$dt[type],'distinct type','type'));
	$t->set_var('oldtype',$dt[oldtype]);
	$t->set_var('name',$dt[name]);
	$t->set_var('oldname',$dt[oldname]);
	$t->set_var('description',$dt[description]);
	$ad_sl = str_replace("'$dt[allowdelete]'","'$dt[allowdelete]' selected",$noyes_sl) ;
	$t->set_var('adelete_selectlist',$ad_sl);
	$t->parse('out','report',True);
	}

    }

?>
