<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// leaveappfilter.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-hr' ;
	$tran = 'leaveapp' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}leaveapp" 			) ;
	$ckapi[phrases] = array('lang_title'	=> exapi_lang("Search among existing Leave Applications :") ,
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Leave Application") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$lang_leave = strtolower(exapi_lang('leave')) ;
	$type_sl = selectlist('category','name',"WHERE app='$app' and type='$lang_leave'",'','name','name','substring(description,1,25)') ;
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$leaveappmsg = exapi_lang('Leave Applications falling within (from/to) period will be listed.') ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Leave Type') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.$type_sl ,
				varname		=>	'type' ,
				defval		=>	'' ,
				note		=>	exapi_lang('Search for target Leave Type'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Period From') ,
				type		=>	'input' ,
				varname		=>	'datefrom' ,
				defval		=>	'' ,
				note		=>	"$leaveappmsg  $dateformat"		) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Period To') ,
				type		=>	'input' ,
				varname		=>	'dateto' ,
				defval		=>	'' ,
				note		=>	"$leaveappmsg  $dateformat"		) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Employee Name/#') ,
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	'' ,
				note		=>	exapi_lang('Search for target key word in the Employee Name Field'));

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
