<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// reportfilter.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-hr' ;
	$tran = 'report' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"				) ;
	$msg1 = exapi_lang('Generation of Human Resources report requires lengthy processing time.') ;
	$msg2 = exapi_lang('You should initiate report generation only during off-peak hours.') ;
	$title = exapi_lang("Choose Report to Generate and to set Report Parameters :") ;
	$ckapi[phrases] = array('lang_title'	=> $title ,
				'lang_criteria'	=> exapi_lang("Reporting Parameters") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Report Generation") ,
				'lang_add'	=> exapi_lang("Return to Index Page") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$lang_date = strtolower(exapi_lang('date')) ;
	$event_selectlist = "<OPTION value=''></OPTION>" ;
	$event_selectlist.= selectlist('category','name',"WHERE app='$app' and type='$lang_date'",'','name','name','substring(description,1,25)') ;
	$note1 = exapi_lang("If wrong report chosen, click [Report] to restart.") ;
	$note1a = exapi_lang("Press [Start Report Generation] one more time to start.") ;
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$msg9 = exapi_lang('Target date falling within (from/to) period will be listed.') ;
	$msg11 = exapi_lang('Target date: Event Notification Date') ;
	$msg12 = exapi_lang('Target date: Sign In/Out Date') ;
	if ($_POST[actnum]==1)	$msg99 = $msg9.'  '.$msg11.'  '.$dateformat ;
	if ($_POST[actnum]==2)	$msg99 = $msg9.'  '.$msg12.'  '.$dateformat ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Which Report') ,
				type		=>	'select' ,
				selectlist	=>	'' ,
				varname		=>	'actnum' ,
				defval		=>	'' ,
				note		=>	$note1				) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Which Event') ,
				type		=>	'select' ,
				selectlist	=>	$event_selectlist ,
				varname		=>	'event' ,
				defval		=>	'' ,
				note		=>	exapi_lang('Select the target event against which notification is to be issued') 									) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Period From') ,
				type		=>	'input' ,
				varname		=>	'datefrom' ,
				defval		=>	'' ,
				note		=>	$msg99				) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Period To') ,
				type		=>	'input' ,
				varname		=>	'dateto' ,
				defval		=>	'' ,
				note		=>	$msg99				) ;

	$lang_reserved = exapi_lang('Reserved') ;
	$report1 = exapi_lang('Human Resources Notification List') ;
	$report2 = exapi_lang('Daily Attendance Report') ;
	$report5 = exapi_lang('Human Resources Audit Control Report') ;
	$ckapi[filter][actlist] = array (	1=>	"<OPTION value='1'>1 -- $report1</OPTION>",
						2=>	"<OPTION value='2'>2 -- $report2</OPTION>",
						3=>	"<OPTION value='3'>3 -- $lang_reserved</OPTION>",
						4=>	"<OPTION value='4'>4 -- $lang_reserved</OPTION>",
						5=>	"<OPTION value='5'>5 -- $report5</OPTION>"	) ;
	$ckapi[filter][actstring] = array(	"0",	/* initial entry	*/
						"0123",	/* report 1	*/
						"023",	/* report 2	*/
						"0",	/* report 3	*/
						"0",	/* report 4	*/
						"0"	/* report 5	*/			) ;
	if ($_POST[actnum]<>"")	$ckapi[filter][0][note] = $note1a ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_filter() ;
	exapi_footer() ;

?>
