<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// adminins.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-i18n' ;
	$tran = 'admin' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$t = exapi_tpl($app);
	$t->set_file('report','confirm.tpl') ;
	$t->set_file('msg','message.tpl');

	$roothdl = opendir($basedir) ;
	while ($sdir = readdir($roothdl))	{if (!strstr($sdir,'ck-')) continue;	$modules[]=$sdir;}	
	$langcode = $_GET['lang'] ;

	$user = $ckapi[hostsys][username];
	$temp = $pre.'adminins'.$user.time() ;
	$sql = "CREATE TABLE $temp (module text,langcode text, i18nkey text, i18nval text,iptime text)" ;
	$adodb->query($sql);
	$ip =($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'] ;
	$now = mktime() ;
	$iptime0 = "$ip=$now=$script" ;
	$len_iptime0 = strlen($iptime0) ;

	$sql = ($ckapi[hostsys][dbtype]=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$adodb->query($sql);

	$i=0; $msg=''; $errors=array();
	foreach ($modules as $module) {
		$filer = "$basedir/$module/setup/${module}_$langcode.lang" ;
		if (!is_file($filer))		continue ;
		$fdr = fopen($filer,"r") ;
		$j = 0 ;
		while (!feof($fdr)) {
			$liner = fgets($fdr,10240);
			$marker = "\t" ;
			list($i18nkey,$i18napp,$i18nlang,$i18nval) = explode($marker,$liner) ;
			if (trim($liner==''))		continue ;
			if ($i18napp<>$module)		{$errors[] = array($filer,$liner,'1');	continue ;}
			if ($i18nlang<>$langcode)	{$errors[] = array($filer,$liner,'2');	continue ;}
			$i18nkey = trim($i18nkey) ;
			if ($i18nkey=="")		continue ;
			$headerarr[$pre.'i18n'] = array('module'=>$module,'langcode'=>$langcode,'i18nkey'=>$i18nkey,'i18nval'=>$i18nval,'control'=>100);
			$header = addslashes(serialize($headerarr));
			$i18nkey = addslashes(strtolower(trim($i18nkey))) ;
			$i18nval = addslashes($i18nval) ;
			$iptime = "$iptime0=$module=$i18nkey" ;
			$sql = "INSERT INTO $temp (module,langcode,i18nkey,i18nval,iptime) " ;
			$sql.=		"VALUES ('$module','$langcode','$i18nkey','$i18nval','$iptime')";
			$adodb->query($sql);
			$sql = "INSERT INTO ${pre}log (app,script,ip,userid,op,timestamp,header,iptime) " ;
			$sql.= "VALUES ('$app','$script','$ip','$user','new','$now','$header','$iptime')";
			$adodb->query($sql) ;
			$j++ ;
			}
		fclose($fdr) ;
		$sql = "INSERT INTO ${pre}i18n " ;
		$sql.= "SELECT id,module,langcode,i18nkey,i18nval,100 FROM $temp a,${pre}log b " ;
		$sql.= "WHERE id>30000 and a.iptime=b.iptime";
		$adodb->query($sql);
		$adodb->query("DELETE FROM $temp");
		$msg.= "[$langcode] language set for $module generated -- $j phrases added<br>" ;
		$i++ ;
		}
	$adodb->query("UPDATE ${pre}log SET trans_id=id WHERE substring(iptime,1,$len_iptime0)='$iptime0'");

	$sql = ($ckapi[hostsys][dbtype]=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$adodb->query($sql);

	$cfmmsg = "$i ".exapi_lang('language files parsed') ;
	$cfmmsg.= '<br>'."$langcode ".exapi_lang('language installation completed') ;

	$t->set_var('lang_confirm',$cfmmsg) ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_yes',exapi_lang('done'));
	$t->set_var('lang_no',exapi_lang('done'));
	$t->set_var('yes_action',exapi_link("/$app/adminfilter.php")) ;
	$t->set_var('no_action',exapi_link("/$app/adminfilter.php")) ;
	
	$t->pparse('out','report',True);

	$invmod = exapi_lang('Invalid Module') ;
	$invlang = exapi_lang('Invalid Language Code') ;
	$msg.= '<br><br>' ;
	foreach($errors as $error) {
		if ($error[2]=='1')	$msg.= "$invmod -- $error[0] -- $error[1]<br>" ;
		if ($error[2]=='2')	$msg.= "$invlang -- $error[0] -- $error[1]<br>" ;
		}
	$t->set_var('message',$msg);
	$t->pparse('out','msg',True);

	if ($temp<>"") $adodb->query("DROP TABLE $temp");
	exapi_footer() ;

?>
