<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// tiplist.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-i18n' ;
	$tran = 'tip' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}i18nnew"			) ;
	$lang_intcharset = exapi_lang('internal charset format') ;
	$lang_guicharset = exapi_lang('current GUI charset format') ;
	$msg1 = exapi_lang('Common Phrases are those that are common across all modules') ;
	$msg2 = exapi_lang('Common Phrases are kept within the language files of ck-api') ;
	$msg3 = exapi_lang('Words in Phrase Key (normally in English) should all be in lower case') ;
	$ckapi[phrases] = array('lang_title'	=> exapi_lang("List of TIPs") ,
				'lang_add'	=> exapi_lang("Add New TIP") ,
				'message'	=> $msg1.'...'.$msg2.'...'.$msg3	) ;
	$ckapi[columns] = array('i18nkey'	=> exapi_lang('Phrase Key') ,
				'i18nval'	=> exapi_lang('Phrase Translation')."<br/>[$lang_intcharset]" ,
				'i18nvalgui'	=> exapi_lang('Phrase Translation')."<br/>[$lang_guicharset]" ,
				'langcode'	=> exapi_lang('Language Code') ,
				'charset'	=> exapi_lang('Internal Charset') ,
				'module'	=> exapi_lang('Module') ,
				'id'		=> exapi_lang('Audit ID') 		);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> exapi_lang("View") ,
				'lang_edit'	=> exapi_lang("Edit") ,
				'lang_copy'	=> exapi_lang("Copy/Modify") ,
				'lang_delete'	=> exapi_lang("Delete") ,
				'lang_log'	=> exapi_lang("Log")				) ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_list() ;
	exapi_footer() ;

?>
