<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// accountfilter.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-ledger' ;
	$tran = 'account' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$ckapi[phrases] = array('lang_title'	=> exapi_lang("Search among existing Accounts :") ,
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Account") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$blankopt = "<OPTION value='ALL'></OPTION>" ;
	$asset = exapi_lang("Asset") ;
	$liab = exapi_lang("Liability") ;
	$equity = exapi_lang("Equity") ;
	$income = exapi_lang("Income") ;
	$expense = exapi_lang("Expense") ;
	$cat_sl = $blankopt ;
	$cat_sl.= "<OPTION value='A'>A -- $asset</OPTION>" ;
	$cat_sl.= "<OPTION value='L'>L -- $liab</OPTION>" ;
	$cat_sl.= "<OPTION value='Q'>Q -- $equity</OPTION>" ;
	$cat_sl.= "<OPTION value='I'>I -- $income</OPTION>" ;
	$cat_sl.= "<OPTION value='E'>E -- $expense</OPTION>" ;
	$posting = exapi_lang("posting account") ;
	$heading = exapi_lang("heading account") ;
	$type_sl = $blankopt ;
	$type_sl.= "<OPTION value='A'>A -- $posting</OPTION>" ;
	$type_sl.= "<OPTION value='H'>H -- $heading</OPTION>" ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Account# from') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	"" ,
				note		=>exapi_lang('Account search starts from this # (format:9999)') );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Account# to') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	"" ,
				note		=>exapi_lang('Account search ends at this # (format:9999)') ) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Description') ,
				type		=>	'input' ,
				varname		=>	'description' ,
				defval		=>	"" ,
				note =>exapi_lang('Search for target key word in the account description field') ) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Category') ,
				type		=>	'select' ,
				selectlist	=>	$cat_sl ,
				varname		=>	'category' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for specific category of account')	) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Type') ,
				type		=>	'select' ,
				selectlist	=>	$type_sl ,
				varname		=>	'type' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for specific type of account')) ;

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
