<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// incomestatement.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-ledger' ;
	$tran = 'incomestatement' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$start_this_period = ($_GET["start_this_period"]) ? $_GET["start_this_period"] : $_POST["start_this_period"] ;
	$end_this_period = ($_GET["end_this_period"]) ? $_GET["end_this_period"] : $_POST["end_this_period"] ;
	$start_last_period = ($_GET["start_last_period"]) ? $_GET["start_last_period"] : $_POST["start_last_period"] ;
	$end_last_period = ($_GET["end_last_period"]) ? $_GET["end_last_period"] : $_POST["end_last_period"] ;
	$attrib1 = ($_GET["attrib1"]) ? $_GET["attrib1"] : $_POST["attrib1"] ;
	$attrib2 = ($_GET["attrib2"]) ? $_GET["attrib2"] : $_POST["attrib2"] ;
	$attrib3 = ($_GET["attrib3"]) ? $_GET["attrib3"] : $_POST["attrib3"] ;

	$t = exapi_tpl($app);
	$t->set_file('report', 'incomestatement.tpl') ;
	$t->set_block('report','income_row','income_section') ;
	$t->set_block('report','expense_row','expense_section') ;

/*---------------------------------------------------------------------------------*/

	$title = exapi_lang('Income Statement') ;
	if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
		$result = $adodb->query("Select * from ${pre}defaults");
		$a1cap = exapi_dbflds($result,'attrib1cap');	$a1tbl = exapi_dbflds($result,'attrib1tbl');	$a1ldf = exapi_dbflds($result,'attrib1ldesc');
		$a2cap = exapi_dbflds($result,'attrib2cap');	$a2tbl = exapi_dbflds($result,'attrib2tbl');	$a2ldf = exapi_dbflds($result,'attrib2ldesc');
		$a3cap = exapi_dbflds($result,'attrib3cap');	$a3tbl = exapi_dbflds($result,'attrib3tbl');	$a3ldf = exapi_dbflds($result,'attrib3ldesc');
		if ($attrib1<>'') {
			$result = $adodb->query("Select * from $a1tbl where id=$attrib1");
			$ldesc = exapi_dbflds($result,"$a1ldf") ;
			$t->set_var('attrib1line',"$a1cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib1line',"");
		if ($attrib2<>'') {
			$result = $adodb->query("Select * from $a2tbl where id=$attrib2");
			$ldesc = exapi_dbflds($result,"$a2ldf") ;
			$t->set_var('attrib2line',"$a2cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib2line',"");
		if ($attrib3<>'') {
			$result = $adodb->query("Select * from $a3tbl where id=$attrib3");
			$ldesc = exapi_dbflds($result,"$a3ldf") ;
			$t->set_var('attrib3line',"$a3cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib3line',"");
		}
	   else {
		$t->set_var('attrib1line',"");
		$t->set_var('attrib2line',"");
		$t->set_var('attrib3line',"");
		}
	$t->set_var('lang_income_statement', exapi_lang('Income Statement'));
	$t->set_var('lang_from',exapi_lang('From :').' ');
	$t->set_var('lang_to',exapi_lang('To :').' ');
	$t->set_var('lang_income', exapi_lang('INCOME'));
	$t->set_var('lang_total_income', exapi_lang('Total Income'));
	$t->set_var('lang_expense', exapi_lang('EXPENSES'));
	$t->set_var('lang_total_expense', exapi_lang('Total Expenses'));
	$t->set_var('lang_profit_loss', exapi_lang('TOTAL PROFIT/(LOSS) FOR THE PERIOD'));
	$t->set_var('start_this_period',$start_this_period);
	$t->set_var('start_last_period',$start_last_period);
	$t->set_var('end_this_period',$end_this_period);
	$t->set_var('end_last_period',$end_last_period);

	$user = $ckapi[hostsys][username];
	$temp1 = "${pre}gl1".$user.time() ;
	$temp2 = "${pre}gl2".$user.time() ;
	$temp3 = "${pre}gl3".$user.time() ;

/*-----------------Write Income Section----------------------------------------------*/

$select = "SELECT accno,b.description,sum(amount) as this_period, 0.00 as last_period " ;
$select.= "FROM ${pre}acc_trans a, ${pre}chart b " ;
$where = "WHERE category='I' and a.transdate>='$start_this_period' and " ;
$where.= "a.transdate<='$end_this_period' and a.chart_id=b.id ";
if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
	$select .= ",${pre}gl c " ;
	$where  .= "and a.trans_id=c.id " ;
	}
if ($attrib1<>'')	$where .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$where .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$where .= " and attrib3=$attrib3 " ;
$sql =	"CREATE TABLE $temp2 AS " .$select.$where. "GROUP BY accno,b.description ORDER BY accno" ;
$adodb->query($sql);

$select = "SELECT accno,b.description,0.00 as this_period, sum(amount) as last_period " ;
$select.= "FROM ${pre}acc_trans a, ${pre}chart b " ;
$where = "WHERE category='I' and a.transdate>='$start_last_period' and " ;
$where.= "a.transdate<='$end_last_period' and a.chart_id=b.id ";
if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
	$select .= ",${pre}gl c " ;
	$where  .= "and a.trans_id=c.id " ;
	}
if ($attrib1<>'')	$where .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$where .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$where .= " and attrib3=$attrib3 " ;
$sql =	"CREATE TABLE $temp3 AS " .$select.$where. "GROUP BY accno,b.description ORDER BY accno" ;
$adodb->query($sql);

$adodb->query("INSERT INTO $temp2 (accno,description,this_period,last_period) SELECT * FROM $temp3");
$sql =  "CREATE TABLE $temp1 AS " .
	"SELECT description, sum(this_period) as this_period, sum(last_period) as last_period " .
		"from $temp2 group by accno, description order by accno" ;
$adodb->query($sql);
$result = $adodb->query("SELECT * from $temp1");

if (exapi_dbrc($result)==0) {
	$t->set_var('income_account','') ;
	$t->set_var('income_this_period','-') ;
	$t->set_var('income_last_period','-') ;
	$t->parse('income_section','income_row',true);
	}
$thisperiod_total = 0;
$lastperiod_total = 0;
While ($rs=$result->fetchRow()) {
	$account_name		= $rs['description'];
	$this_period_amount	= sprintf("%01.2f",$rs['this_period']);
	$last_period_amount	= sprintf("%01.2f",$rs['last_period']);
	$thisperiod_total	+=$this_period_amount ;
	$lastperiod_total	+=$last_period_amount ;
	$t->set_var('income_account',$account_name) ;
	if ($this_period_amount==0) {$this_period_amount='-'; }
	if ($last_period_amount==0) {$last_period_amount='-'; }
	$t->set_var('income_this_period',$this_period_amount) ;
	$t->set_var('income_last_period',$last_period_amount) ;
	$t->parse('income_section','income_row',true);
	}

$t->set_var('total_income_this_period',sprintf("%01.2f",$thisperiod_total)) ;
$t->set_var('total_income_last_period',sprintf("%01.2f",$lastperiod_total)) ;
$total_income_this_period = $thisperiod_total ;
$total_income_last_period = $lastperiod_total ;

$adodb->query("DROP TABLE $temp1");
$adodb->query("DROP TABLE $temp2");
$adodb->query("DROP TABLE $temp3");

/*--------------------Write Expense Section------------------------------------------*/

$select = "SELECT accno,b.description,sum(amount) as this_period, 0.00 as last_period " ;
$select.= "FROM ${pre}acc_trans a, ${pre}chart b " ;
$where = "WHERE category='E' and a.transdate>='$start_this_period' and " ;
$where.= "a.transdate<='$end_this_period' and a.chart_id=b.id ";
if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
	$select .= ",${pre}gl c " ;
	$where  .= "and a.trans_id=c.id " ;
	}
if ($attrib1<>'')	$where .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$where .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$where .= " and attrib3=$attrib3 " ;
$sql =	"CREATE TABLE $temp2 AS " .$select.$where. "GROUP BY accno,b.description ORDER BY accno" ;
$adodb->query($sql);

$select = "SELECT accno,b.description,0.00 as this_period, sum(amount) as last_period " ;
$select.= "FROM ${pre}acc_trans a, ${pre}chart b " ;
$where = "WHERE category='E' and a.transdate>='$start_last_period' and " ;
$where.= "a.transdate<='$end_last_period' and a.chart_id=b.id ";
if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
	$select .= ",${pre}gl c " ;
	$where  .= "and a.trans_id=c.id " ;
	}
if ($attrib1<>'')	$where .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$where .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$where .= " and attrib3='$attrib3' " ;
$sql =	"CREATE TABLE $temp3 AS " .$select.$where. "GROUP BY accno,b.description ORDER BY accno" ;
$adodb->query($sql);

$adodb->query("INSERT INTO $temp2 (accno,description,this_period,last_period) SELECT * FROM $temp3");
$sql =  "CREATE TABLE $temp1 AS " .
	"SELECT description, sum(this_period) as this_period, sum(last_period) as last_period " .
		"from $temp2 group by accno, description order by accno" ;
$adodb->query($sql);
$result = $adodb->query("SELECT * from $temp1");

if (exapi_dbrc($result)==0) {
	$t->set_var('expense_account','') ;
	$t->set_var('expense_this_period','-') ;
	$t->set_var('expense_last_period','-') ;
	$t->parse('expense_section','expense_row',true);
	}
$thisperiod_total = 0;
$lastperiod_total = 0;
While ($rs=$result->fetchRow()) {
	$account_name		= $rs['description'];
	$this_period_amount	= sprintf("%01.2f",-$rs['this_period']);
	$last_period_amount	= sprintf("%01.2f",-$rs['last_period']);
	if ($this_period_amount==0) {$this_period_amount='-'; }
	if ($last_period_amount==0) {$last_period_amount='-'; }
	$t->set_var('expense_account',$account_name) ;
	$thisperiod_total	+=$this_period_amount ;
	$lastperiod_total	+=$last_period_amount ;
	$t->set_var('expense_this_period',$this_period_amount) ;
	$t->set_var('expense_last_period',$last_period_amount) ;
	$t->set_var(array(	'expense_account'	=> $account_name,
				'expense_this_period'	=> $this_period_amount,
            	    		'expense_last_period'	=> $last_period_amount ));
	$t->parse('expense_section','expense_row',True);
	}
$t->set_var('total_expense_this_period',sprintf("%01.2f",$thisperiod_total)) ;
$t->set_var('total_expense_last_period',sprintf("%01.2f",$lastperiod_total)) ;

/*--------------------Write Profit/Loss Section------------------------------------------*/

$t->set_var('total_profit_loss_this_period',sprintf("%01.2f",$total_income_this_period-$thisperiod_total));
$t->set_var('total_profit_loss_last_period',sprintf("%01.2f",$total_income_last_period-$lastperiod_total));

$adodb->query("DROP TABLE $temp1");
$adodb->query("DROP TABLE $temp2");
$adodb->query("DROP TABLE $temp3");

/*--------------------Write bottom Section------------------------------------------*/

    $t->set_var('done_action',exapi_link("/$app/reportfilter.php")) ;
    $t->set_var('lang_done',exapi_lang('Done'));
    $t->pparse('out','report',true);
	exapi_footer() ;

?>
