<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// ledgerlisting.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-ledger' ;
	$tran = 'ledgerlisting' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$start_date = ($_GET["start_date"]) ? $_GET["start_date"] : $_POST["start_date"] ;
	$end_date = ($_GET["end_date"]) ? $_GET["end_date"] : $_POST["end_date"] ;
	$account = ($_GET["account"]) ? $_GET["account"] : $_POST["account"] ;
	$attrib1 = ($_GET["attrib1"]) ? $_GET["attrib1"] : $_POST["attrib1"] ;
	$attrib2 = ($_GET["attrib2"]) ? $_GET["attrib2"] : $_POST["attrib2"] ;
	$attrib3 = ($_GET["attrib3"]) ? $_GET["attrib3"] : $_POST["attrib3"] ;

	$t = exapi_tpl($app);
	$t->set_file('report','ledgerlisting.tpl') ;
	$t->set_block('report','account_row','account_section');

/*---------------------------------------------------------------------------------*/

	$report_period = "......(".$start_date." <-> ".$end_date.")" ;
	$t->set_var('lang_ledger_listing', exapi_lang('LEDGER LISTING')." $report_period");
	if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
		$result = $adodb->query("Select * from ${pre}defaults");
		$a1cap = exapi_dbflds($result,'attrib1cap');	$a1tbl = exapi_dbflds($result,'attrib1tbl');	$a1ldf = exapi_dbflds($result,'attrib1ldesc');
		$a2cap = exapi_dbflds($result,'attrib2cap');	$a2tbl = exapi_dbflds($result,'attrib2tbl');	$a2ldf = exapi_dbflds($result,'attrib2ldesc');
		$a3cap = exapi_dbflds($result,'attrib3cap');	$a3tbl = exapi_dbflds($result,'attrib3tbl');	$a3ldf = exapi_dbflds($result,'attrib3ldesc');
		if ($attrib1<>'') {
			$result = $adodb->query("Select * from $a1tbl where id=$attrib1"); 
			$ldesc = exapi_dbflds($result,"$a1ldf") ;
			$t->set_var('attrib1line',"$a1cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib1line',"");
		if ($attrib2<>'') {
			$result = $adodb->query("Select * from $a2tbl where id=$attrib2"); 
			$ldesc = exapi_dbflds($result,"$a2ldf") ;
			$t->set_var('attrib2line',"$a2cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib2line',"");
		if ($attrib3<>'') {
			$result = $adodb->query("Select * from $a3tbl where id=$attrib3"); 
			$ldesc = exapi_dbflds($result,"$a3ldf") ;
			$t->set_var('attrib3line',"$a3cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib3line',"");
		}
	   else {
		$t->set_var('attrib1line',"");
		$t->set_var('attrib2line',"");
		$t->set_var('attrib3line',"");
		}
	$t->set_var('lang_notes',exapi_lang('Press [done] button at View Detail screen to go on to transaction maintenance'));
	$t->set_var('lang_date', exapi_lang('DATE'));
	$t->set_var('lang_desc', exapi_lang('ACCOUNT'));
	$t->set_var('lang_comment',exapi_lang('JOURNAL DESCRIPTION'));
	$t->set_var('lang_dr', exapi_lang('DEBIT'));
	$t->set_var('lang_cr', exapi_lang('CREDIT'));
	$t->set_var('lang_balance', exapi_lang('BALANCE [dr/cr]'));
	$t->set_var('lang_viewdetail', exapi_lang('View Detail'));
	$lang_begin = exapi_lang('Beginning') ;
	$lang_end = exapi_lang('Ending') ;
	$lang_dr = exapi_lang('dr') ;
	$lang_cr = exapi_lang('cr') ;

/*-----------------Build Ledger Listing table--------------------------------
	flag = 0	->	Starting account balance
	flag = 1	->	detail intra period transactions
	flag = 2	->	summary amount of intra period transaction
	flag = 9	->	Ending account balance

------------------------------------------------------------------------------*/
$user = $ckapi[hostsys][username];
$temp1 = "${pre}gl1".$user.time() ;
$temp2 = "${pre}gl2".$user.time() ;
$temp3 = "${pre}gl3".$user.time() ;
$temp4 = "${pre}gl4".$user.time() ;
$getattrib1 = ($attrib1=='')? "" : " and attrib1=$attrib1 " ;
$getattrib2 = ($attrib2=='')? "" : " and attrib2=$attrib2 " ;
$getattrib3 = ($attrib3=='')? "" : " and attrib3=$attrib3 " ;
$getaccount = ($account==0) ? "" : " and chart_id=$account " ;
/*------------Create intra period detail transactions ----------------------------*/
$sql =	"CREATE TABLE $temp1 AS " ;
$sql.=	"SELECT 1 as flag, chart_id, a.transdate, amount, b.description, trans_id, substring(source,1,4) as transcode " ;
$sql.=	"FROM ${pre}acc_trans a, ${pre}gl b " ;
$sql.=	"WHERE a.transdate >= '$start_date' and a.transdate <= '$end_date' and a.trans_id=b.id " ;
$sql.=	"$getattrib1 $getattrib2 $getattrib3 $getaccount" ;
/*		"chart_id=$account and a.trans_id=b.id" ;		*/
$adodb->query($sql);
/*-------------Create -ve intra period summary transactions -----------------------*/
$sql =	"CREATE TABLE $temp2 AS " .
	"SELECT 2 as flag, chart_id, -sum(amount) as amount from $temp1 " .
	"GROUP BY chart_id ORDER BY chart_id" ;
$adodb->query($sql);
/*-------------Create Ending Balance -----------------------------------------------*/
$sql =	"CREATE TABLE $temp3 AS " ;
$sql.=	"SELECT 9 as flag, chart_id, sum(amount) as amount FROM ${pre}acc_trans " ;
$sql.=	"WHERE transdate <= '$end_date' " ;
$sql.=	"$getattrib1 $getattrib2 $getattrib3 $getaccount" ;
$sql.=	"GROUP BY chart_id ORDER BY chart_id" ;
$adodb->query($sql);
/*-------------Merging Ending Balance trans with -ve intra period summary trans -----*/
$sql =	"INSERT INTO $temp2 SELECT * from $temp3" ;
$adodb->query($sql);
/*-------------Summing up to create Beginning Balance -------------------------------*/
$sql =	"CREATE TABLE $temp4 AS " .
	"SELECT 0 as flag, chart_id, sum(amount) as amount from $temp2 " .
	"GROUP BY chart_id ORDER BY chart_id" ;
$adodb->query($sql);
/*-------------Merging Ending Balance into main working table -----------------------*/
$sql =	"INSERT INTO $temp1 (flag, chart_id, transdate, amount, description) " .
	"SELECT flag, chart_id, '$end_date', amount, '$lang_end' FROM $temp3" ;
$adodb->query($sql);
/*-------------Merging Begining Balance into main working table ----------------------*/
$sql =	"INSERT INTO $temp1 (flag, chart_id, transdate, amount, description) " .
	"SELECT flag, chart_id, '$start_date', amount, '$lang_begin' FROM $temp4" ;
$adodb->query($sql);
/*-------------Transfer completed working table with a/c description ------------------*/
$sql =  "SELECT a.flag, b.accno, a.transdate, a.amount, a.description as j_description, " .
		"b.description as a_description, trans_id, transcode " .
	"FROM $temp1 a, ${pre}chart b " .
	"WHERE a.chart_id=b.id order by accno, flag, transdate" ;
$result = $adodb->query($sql);
if (exapi_dbrc($result)==0) {
	$t->set_var('desc','') ;
	$t->set_var('date','') ;
	$t->set_var('comment',exapi_lang('No account selected')) ;
	$t->set_var('dr','') ;
	$t->set_var('cr','') ;
	$t->set_var('balance','') ;
	$t->set_var('lang_journal','') ;
	$t->set_var('lang_origin','') ;
	$t->parse('account_section','account_row',True);
	}
While ($rs=$result->fetchRow()) {
	$flag		=	$rs['flag'] ;
	$date		=	$rs['transdate'] ;
	$desc		=	$rs['accno'] . ' ' . $rs['a_description'] ;
	$comment	=	$rs['j_description'] ;
	$cr		=	sprintf("%01.2f",$rs['amount']);
	$dr		=	sprintf("%01.2f",-$cr) ;
	$balance	=	sprintf("%01.2f",$cr) ;
	$trans_id	=	$rs['trans_id'] ;
	$transcode	=	$rs['transcode'] ;
	$lang_journal	=	exapi_lang("Journal") ;
	$lang_origin	=	exapi_lang("Origin") ;
	$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
//	$filter = "${markpri}0id=$chart_id";
	if ($flag==0)	{
		$dr=''; $cr='';
		if ($balance>0) { $balance = $balance." [$lang_cr]"; }
		if ($balance<0) { $balance = sprintf("%01.2f",-$balance) ." [$lang_dr]"; }
		$lang_journal = $lang_origin = "" ;
		$journal = $origin = "" ;
		}
	if ($flag==1) {
		$desc=''; $balance = '' ;
		if ($cr>=0) {$dr=''; } else {$cr=''; }
		$jfilter = "${markpri}0id=$trans_id";
		$sfilter = "${markpri}1a.id$marksec$trans_id";
		$journal = exapi_link("/$app/journalview.php","id=$trans_id&filter=$jfilter");
		switch ($transcode) :
			case "GLJL" :	$script = "/$app/journalview.php" ; $sfilter=$jfilter ;	break ;
			case "APNT" :	$script = "/ck-ap/invoicentview.php" ;			break ;
			case "APWT" :	$script = "/ck-ap/invoicewtview.php" ;			break ;
			case "APPY" :	$script = "/ck-ap/paymentview.php" ;			break ;
			case "ARNT" :	$script = "/ck-ar/invoicentview.php" ;			break ;
			case "ARWT" :	$script = "/ck-ar/invoicewtview.php" ;			break ;
			case "ARRT" :	$script = "/ck-ar/receiptview.php" ;			break ;
			case "CSNT" :	$script = "/ck-pos-c/csntview.php" ;			break ;
			case "CSWT" :	$script = "/ck-pos-c/cswtview.php" ;			break ;
			case "CBTR" :	$script = "/ck-pos-m/cbtranview.php" ;			break ;
			case "PYRO" :	$script = "/$app/journalview.php" ; $sfilter=$jfilter ;	break ;
			case "PYPY" :	$script = "/$app/journalview.php" ; $sfilter=$jfilter ;	break ;
			default : 	$script = "error" ;					break ;
			endswitch ;
		$origin = exapi_link("$script","id=$trans_id&filter=$sfilter");
		if ($script=="error")	{$lang_origin = "<b>".exapi_lang("Error")."</b>" ; $origin = "" ; }
		}
	if ($flag==9) {
		$desc=''; $dr=''; $cr='';
		if ($balance>0) { $balance = $balance." [$lang_cr]";}
		if ($balance<0) { $balance = sprintf("%01.2f",-$balance) ." [$lang_dr]";}
		$balance = "<b><u>$balance</u></b>" ;
		$lang_journal = $lang_origin = $journal = $origin = "" ;
		}
	$t->set_var('date',$date) ;
	$t->set_var('desc',$desc);
	$t->set_var('comment',$comment) ;
	$t->set_var('dr',$dr) ;
	$t->set_var('cr',$cr) ;
	$t->set_var('balance',$balance) ;
	$t->set_var('journal',$journal) ;
	$t->set_var('origin',$origin) ;
	$t->set_var('lang_journal',$lang_journal) ;
	$t->set_var('lang_origin',$lang_origin) ;

	$t->parse('account_section','account_row', True);
	if ($flag==9) {
		$t->set_var('date','') ;
		$t->set_var('comment','') ;
		$t->set_var('balance','<br><br>') ;
		$t->parse('account_section','account_row',True);
		}
	}
$adodb->query("DROP TABLE $temp1");
$adodb->query("DROP TABLE $temp2");
$adodb->query("DROP TABLE $temp3");
$adodb->query("DROP TABLE $temp4");
$adodb->query("UPDATE ${pre}resourcelock SET used_by='' WHERE resource='ledgerlisting'");

/*--------------------Write bottom Section------------------------------------------*/

    $t->set_var('done_action',exapi_link("/$app/reportfilter.php")) ;
    $t->set_var('lang_done',exapi_lang('Done'));
    $t->pparse('out','report');
	exapi_footer() ;

?>
