<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// bulkpayrollfilter.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-payroll' ;
	$tran = 'bulkpayroll' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}bulkpayroll" ,
				'doneexit'	=> "index.php"				) ;
	$msg1 = exapi_lang("Payroll Generation normally requires lengthy processing time.") ;
	$msg2 = exapi_lang("You should initiate Payroll Generation only during off-peak hours.");
	$msg3 = exapi_lang("Salary advice for previous period may be regenerated.") ;
	$ckapi[phrases] = array('lang_title'=>exapi_lang("Choose Action to perform and to set Action Parameters :"),
				'lang_criteria'	=> exapi_lang("Action Parameters") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Action") ,
				'lang_add'	=> exapi_lang("Done") ,
			'lang_search_message'	=> "$msg1<br>$msg2<br>$msg3" ,
				'message'	=> ""					);

	$warning1 = exapi_lang("Since Payroll Generation is irreversible, please perform database backup first then follow the strict sequence of Step 1-2-3.");
	$warning1a = exapi_lang("All payroll related data modification should also be stopped.") ;
	$warning2 = exapi_lang("Inaccurate Date will affect subsequent period's payroll.") ;
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$note1 = exapi_lang("If wrong action chosen, click (Generate Bulk Payroll) to restart.") ;
	$note2 = exapi_lang('Operate on all staff or staff with the choosen pay period') ;
	$note4 = exapi_lang("For cheque generation, this step needs to be repeated for all staff that require a payroll check.");
	$note4a = exapi_lang("Cheques for past payroll period may be regenerated.") ;
	$note5 = exapi_lang("For any one employee's cheque, payment journal should only be generated once.") ;
	$note7 = exapi_lang("Choose which ledger (bank) account to put through Cr (cheque amount).") ;
	$note7a = exapi_lang("Please ignore if payment journal is not to be generated.") ;
	$nullopt = "<OPTION value=''></OPTION>" ;
	$selectlist = "<OPTION value='mn'>".exapi_lang('Month')." -- mn</OPTION>" ;
	$selectlist.= "<OPTION value='sm'>".exapi_lang('Semi-monthly')." -- sm</OPTION>" ;
	$selectlist.= "<OPTION value='wk'>".exapi_lang('Week')." -- wk</OPTION>" ;
	$selectlist.= "<OPTION value='dy'>".exapi_lang('Day')." -- dy</OPTION>" ;
	$selectlist.= "<OPTION value='hr'>".exapi_lang('Hour')." -- hr</OPTION>" ;

	$note3 = exapi_lang('Immediate past payroll period') ;
	$result = $adodb->query("SELECT max(trans_id) as id FROM ${pre}pyrohist");
	$id = exapi_dbflds($result,'id') ;
	$result = $adodb->query("SELECT description FROM ${pre}gl WHERE id='$id'");
	$pastdesc = exapi_dbflds($result,'description') ;
	$frommarker = strtolower(exapi_lang('*from*')).'::' ;
	$tomarker = strtolower(exapi_lang('*to*')).'::' ;
	list($dummy,$fromto) = explode($frommarker,$pastdesc) ;
	list($from,$to) = explode($tomarker,$fromto) ;
	$perifrom = trim($from);
	$perito = trim($to);

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Which Action') ,
				type		=>	'select' ,
				selectlist	=>	'' ,
				varname		=>	'actnum' ,
				defval		=>	'' ,
				note		=>	"<b>$warning1  $warning1a</b>  $note1"	);

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Pay Period') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.$selectlist ,
				varname		=>	'period' ,
				defval		=>	'' ,
				note		=>	$note2					);

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Useful Information') ,
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	exapi_lang('[No input required]') ,
				note		=>	"$note3:  $perifrom => $perito"		) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Period From') ,
				type		=>	'input' ,
				varname		=>	'datefrom' ,
				defval		=>	'' ,
				note		=>	"<b>$warning2</b>  $dateformat"		) ;

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Period To') ,
				type		=>	'input' ,
				varname		=>	'dateto' ,
				defval		=>	'' ,
				note		=>	"<b>$warning2</b>  $dateformat"		) ;

	$step1 = exapi_lang('Step 1 - Test Run on Current Period Payroll Generation') ;
	$step2 = exapi_lang('Step 2 - Generate Current Period Payroll, Journal and History Data') ;
	$step3 = exapi_lang('Step 3 - Email Salary Advice to Staff') ;
	$ckapi[filter][actlist] = array (	1=>	"<OPTION value='1'>$step1</OPTION>",
						2=>	"<OPTION value='2'>$step2</OPTION>",
						3=>	"<OPTION value='3'>$step3</OPTION>"	);
	$ckapi[filter][actstring] = array("0",		/* first entry	*/
					"01234",	/* Step 1	*/
					"01234",	/* Step 2	*/
					"02"		/* Step 3	*/			) ;

	if ($_POST[actnum]>2)	$ckapi[filter][3][note] = $ckapi[filter][4][note] = $dateformat ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_filter() ;
	exapi_footer() ;

?>


