<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// cbtranfilter.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-pos-m' ;
	$tran = 'cbtran' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$ckapi[phrases] = array('lang_title'=> exapi_lang("Search among posted Cash Box Transactions :"),
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Cash Box Transaction") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);
	$morning = exapi_lang('Morning') ;
	$afternoon = exapi_lang('Afternoon') ;
	$overnight = exapi_lang('Overnight') ;
	$shift_sl = "<OPTION value='ALL'></OPTION>" ;
	$shift_sl.= "<OPTION value='1'>1 - $morning</OPTION>" ;
	$shift_sl.= "<OPTION value='2'>2 - $afternoon</OPTION>" ;
	$shift_sl.= "<OPTION value='3'>3 - $overnight</OPTION>" ;
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$ckapi[filter][] = array(criteria	=>	exapi_lang('Shift') ,
				type		=>	'select' ,
				selectlist	=>	$shift_sl ,
				varname		=>	'shift' ,
				defval		=>	"ALL" ,
				note		=>	exapi_lang('Select the appropriate shift'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Manager') ,
				type		=>	'input' ,
				varname		=>	'manager' ,
				defval		=>	"" ,
				note		=>exapi_lang('Search for target key word in the manager field'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Cashier') ,
				type		=>	'input' ,
				varname		=>	'cashier' ,
				defval		=>	"" ,
				note		=>exapi_lang('Search for target key word in the cashier field'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Cash Box Name') ,
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	"" ,
				note	=>exapi_lang('Search for target key word in the cash box name field'));

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Cash Sale Date (from)') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Must be a valid date')."; $dateformat" );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Cash Sale Date (to)') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Must be a valid date')."; $dateformat" );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Cash Box Transaction Number') ,
				type		=>	'input' ,
				varname		=>	'cbtnumber' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for target key word/number in the cashbox transaction number field'));

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
