<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// cbtranlist.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-pos-m' ;
	$tran = 'cbtran' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}cbtran" 			) ;
	$note1 = exapi_lang('[Shift]:  1 - Morning, 2 - Afternoon, 3 - Overnight') ;
	$note2 = exapi_lang('[Tran Type]: s - start-of-shift, +/- => Cash in/out, e - end-of-shift') ;
	$ckapi[phrases] = array('lang_title'	=> exapi_lang("List of Cash Box Transactions") ,
				'lang_add'	=> exapi_lang("Add New Cash Box Transaction") ,
				'lang_note1'	=> $note1 ,
				'lang_note2'	=> $note2				) ;
	$ckapi[columns] = array('cbtnumber'	=> exapi_lang('CashBox Tran#') ,
				'name'		=> exapi_lang('CashBox Name') ,
				'manager'	=> exapi_lang('Manager') ,
				'cashier'	=> exapi_lang('Cashier') ,
				'transdate'	=> exapi_lang('Cash Sale Date') ,
				'shift'		=> exapi_lang('Shift') ,
				'trantype'	=> exapi_lang('Tran Type') ,
				'amount'	=> exapi_lang('Amount') ,
				'id'		=> exapi_lang('Audit ID') 			) ;
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'acctran'	=> "/$app/${tran}acctran.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> exapi_lang("View") ,
				'lang_acctran'	=> exapi_lang('View Accounting Entries') ,
				'lang_edit'	=> exapi_lang("Edit") ,
				'lang_copy'	=> exapi_lang("Copy/Modify") ,
				'lang_delete'	=> exapi_lang("Delete") ,
				'lang_log'	=> exapi_lang("Log")				) ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_list() ;
	exapi_footer() ;

?>
