<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.cashbox.inc.php 0.15.1 2005/09/30 C K Wu

    class cashbox {

//---- Cash Box Detail Validation Checks

    function cashbox_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err="";  $error = exapi_lang("Error") ;
	if (!$dt[name] or $dt[name]=="")	$err=exapi_lang('Cash Box Name missing');
		else	{
			$name = addslashes($dt[name]) ;
			$result = $adodb->query("SELECT * from ${pre}cashbox WHERE name='$name'") ;
			if (exapi_dbrc($result)<>0 and $dt[name]<>$dt[oldname])
				$err=exapi_lang('Cash Box name already in use');
			}
	if (!$dt[cashier] or $dt[cashier]=="")	$err=exapi_lang('Cashier missing');
		else	{
			$cashier = addslashes($dt[cashier]) ;
			$result = $adodb->query("SELECT * from ${pre}cashbox WHERE cashier='$cashier'") ;
			if (exapi_dbrc($result)<>0 and $dt[cashier]<>$dt[oldcashier])
				$err=exapi_lang('Cashier already assigned to other cashbox');
			}
	if ($dt[maxcash] and !is_numeric($dt[maxcash]))	$err=exapi_lang('Cash Warning Level must be numeric');
	if (!exapi_is_admin($ckapi[hostsys][username]))	$err=exapi_lang('Action restricted to admin level user');

	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Qcash Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=exapi_lang('Error') ;
	$cashsale = exapi_lang('cash sale') ; $cbtran = exapi_lang('CashBox Transaction') ;
	$errmsg1 = exapi_lang("This cashbox is in use within an existing") ;
	$id = $dt[id] ;
	$result = $adodb->query("SELECT * from ${pre}pos WHERE cboxid='$id'");
	if (exapi_dbrc($result)>0)	$err = "$errmsg1 $cashsale id#".exapi_dbflds($result,'id') ;
	$result = $adodb->query("SELECT * from ${pre}cbtran WHERE cboxid='$id'");
	if (exapi_dbrc($result)>0)	$err = "$errmsg1 $cbtran id#".exapi_dbflds($result,'id') ;

	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Cash Box Detail

    function cashbox_write() {
	global $ckapi ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',exapi_lang('Audit ID').': ');

	$t->set_var('lang_name',exapi_lang('Name'));
	$t->set_var('lang_cashier',exapi_lang('Cashier for Current Shift'));
	$t->set_var('lang_remark',exapi_lang('[to assign this cashier to a different cashbox, enter N/A here]'));
	$t->set_var('lang_location',exapi_lang('Location'));
	$t->set_var('lang_shift',exapi_lang('Current Shift'));
	$t->set_var('lang_maxcash',exapi_lang('Cash Full Warning Level'));
	$t->set_var('lang_notes',exapi_lang('Notes'));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('name',$dt[name]);
	$t->set_var('cashier',$dt[cashier]);
	$t->set_var('shift',$dt[shift]);
	$selectlist = "<OPTION value='1'>1 - ".exapi_lang('Morning')."</OPTION>" ;
	$selectlist.= "<OPTION value='2'>2 - ".exapi_lang('Afternoon')."</OPTION>" ;
	$selectlist.= "<OPTION value='3'>3 - ".exapi_lang('Overnight')."</OPTION>" ;
	$selectlist = str_replace("'$dt[shift]'","'$dt[shift]'"." selected",$selectlist) ;
	$t->set_var('shift_sl',$selectlist);
	$t->set_var('location',$dt[location]);
	$t->set_var('maxcash',$dt[maxcash]);
	$t->set_var('notes',$dt[notes]);
	$t->parse('out','report',True);
	}

    }

?>
