<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// repballist.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-pos-m' ;
	$tran = 'repballist' ;
	require_once('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	
	$proc = newobj('ck-api','process') ;
	$where = $proc->decode_where(urldecode(stripslashes($filter))) ;
	$t = exapi_tpl($app);
	$t->set_file(array('report'=>"$tran.tpl", 'repbal'=>"$tran.tpl"));
	$t->set_block('repbal','repbal_row','repbal_section');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$db_type = $ckapi[hostsys][dbtype] ;

//---------------------------- list variable template-declarations -------------------------

	$t->set_var('lang_title',exapi_lang('List of Shift End (Completed) Cash Balances'));
	$t->set_var('lang_sorthead',exapi_lang('[click column heading to re-sort table]'));
	$t->set_var('lang_add',exapi_lang('Done'));
	$t->set_var('add_action',exapi_link("/$app/reportfilter.php"));
	$t->set_var('lang_note1',exapi_lang('[Shift]:  1 - Morning, 2 - Afternoon, 3 - Overnight'));
	$t->set_var('lang_view', exapi_lang('View Detail'));

	$script = "/$app/${tran}.php" ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var('sort_transdate',$proc->sortlink(exapi_lang('Date'),$script,'transdate',$sort,$getstr));
	$t->set_var('sort_shift',$proc->sortlink(exapi_lang('Shift'),$script,'shift',$sort,$getstr));
	$t->set_var('sort_cashbox',$proc->sortlink(exapi_lang('Cashbox'),$script,'cashbox',$sort,$getstr));
	$t->set_var('sort_cashier',$proc->sortlink(exapi_lang('Cashier'),$script,'cashier',$sort,$getstr));
	$t->set_var('sort_cashamt',$proc->sortlink(exapi_lang('Cash Tendered<br>by Customer'),$script,'cashamt',$sort,$getstr));
	$t->set_var('sort_changeamt',$proc->sortlink(exapi_lang('Cash Returned<br>to Customer'),$script,'changeamt',$sort,$getstr));
	$t->set_var('sort_cbtamt',$proc->sortlink(exapi_lang('Bulk Cash<br>Transferred in/out'),$script,'cbtamt',$sort,$getstr));
	$t->set_var('sort_balance',$proc->sortlink(exapi_lang('Cash Shortfall (+ve)<br>Cash Surplus (-ve)'),$script,'balance',$sort,$getstr));

	$user = $ckapi[hostsys][username];
	$temp1 = "${pre}repbal1".$user.time() ;
	$temp2 = "${pre}repbal2".$user.time() ;
	$temp3 = "${pre}repbal3".$user.time() ;
	$temp4 = "${pre}repbal4".$user.time() ;
	$format = '000000000000.00' ;
	$lang_cash = exapi_lang('Cash') ;

	$sql =	"CREATE TABLE $temp1 AS " ;
	$sql.=  "SELECT a.cboxid as cboxid,a.transdate as transdate,a.shift as shift " ;
	$sql.=	"FROM ${pre}cbtran a,${pre}cashbox b WHERE $where and a.cboxid=b.id and trantype='e'" ;
	$adodb->query($sql);
	$sql =	"CREATE TABLE $temp2 AS " ;
	$sql.=	"SELECT d.cboxid as cboxid,d.transdate as transdate,d.shift as shift,sum(qty*a.value) as cashamt " ;
	$sql.=	"FROM ${pre}positem a,${pre}pos b,${pre}qcash c,$temp1 d " ;
	$sql.=	"WHERE b.cboxid=d.cboxid and b.transdate=d.transdate and b.shift=d.shift and " ;
	$sql.=		"name='$lang_cash' and a.trans_id=b.id and a.itemid=c.id " ;
	$sql.=	"GROUP BY d.transdate,d.shift,d.cboxid,itemid" ;
	$adodb->query($sql);
	$sql =	"CREATE TABLE $temp3 AS " ;
	$sql.=	"SELECT c.cboxid as cboxid,c.transdate as transdate,c.shift as shift,cashamt, " ;
	$sql.=		"sum(qty*value) as changeamt FROM ${pre}positem a,${pre}pos b,$temp2 c " ;
	$sql.=	"WHERE b.cboxid=c.cboxid and b.transdate=c.transdate and b.shift=c.shift and " ;
	$sql.=		"itemtype='c' and a.trans_id=b.id " ;
	$sql.=	"GROUP BY c.transdate,c.shift,c.cboxid,itemid,cashamt" ;
	$adodb->query($sql);
	$sql =	"CREATE TABLE $temp4 AS " ;
	$sql.=	"SELECT a.cboxid as cboxid,a.transdate as transdate,a.shift as shift,name,b.cashier as cashier," ;
	$sql.=		"cashamt,changeamt,sum(amount) as cbtamt, $format as balance " ;
	$sql.=	"FROM $temp3 a, ${pre}cbtran b, ${pre}cashbox c " ;
	$sql.=	"WHERE a.cboxid=b.cboxid and a.transdate=b.transdate and a.shift=b.shift and a.cboxid=c.id " ;
	$sql.=	"GROUP BY a.transdate,a.shift,a.cboxid,name,b.cashier,cashamt,changeamt " ;
	$adodb->query($sql) ;
	$adodb->query("UPDATE $temp4 SET balance=cashamt+changeamt+cbtamt") ;

	if (!$order) {$order = "transdate" ; }
	if (!$sort)  {$sort = "ASC" ; }
	$result = $adodb->query("SELECT * FROM $temp4 order by $order $sort") ;

// -------------------------------- end declaration -----------------------------------------

if (exapi_dbrc($result)==0) {
	$t->set_var(array(	'transdate'	=> exapi_lang("No Matching Item Found"),
				'shift'		=> "",
				'cashbox'	=> "",
				'cashier'	=> "",
				'cashamt'	=> "",
				'changeamt'	=> "",
				'cbtamt'	=> "",
				'balance'	=> "",
				'lang_item'	=> ""	)) ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('repbal_section','repbal_row',True);
	}
While ($rs=$result->fetchRow()) {
	$transdate = $rs['transdate'] ;
	$shift = $rs['shift'] ;
	$cboxid = $rs['cboxid'] ;
	$t->set_var(array(	'transdate'	=> $transdate,
				'shift'		=> $shift,
				'cashbox'	=> $rs['name'],
				'cashier'	=> $rs['cashier'],
				'cashamt'	=> number_format($rs['cashamt'],2,".",''),
				'changeamt'	=> number_format($rs['changeamt'],2,".",''),
				'cbtamt'	=> number_format($rs['cbtamt'],2,".",''),
				'balance'	=> $rs['balance'] ,
				'lang_item'	=> exapi_lang('View Detail')	)) ;
	$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
	$ifilter = "${markpri}01=1" ;
	$ifilter.= "${markpri}1shift${marksec}${shift}" ;
	$ifilter.= "${markpri}1transdate${marksec}${transdate}" ;
	$ifilter.= "${markpri}1cboxid${marksec}${cboxid}";
	$ifilter =urlencode($ifilter) ;
	$item = exapi_link("/$app/cashballist.php","filter=$ifilter");
	$t->set_var('item',$item);
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('repbal_section','repbal_row',true);
	}

$adodb->query("DROP TABLE $temp1") ;
$adodb->query("DROP TABLE $temp2") ;
$adodb->query("DROP TABLE $temp3") ;
$adodb->query("DROP TABLE $temp4") ;

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','repbal','report');
	exapi_footer() ;

?>
