<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// quotewtfilter.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-quote' ;
	$tran = 'quotewt' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'quote' ,
				'tran'		=> $tran			) ;
	$ckapi[phrases] = array('lang_title'	=> exapi_lang("Search among posted Quotations [with Tax] :") ,
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Quotation [with Tax]") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);
	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$warning = exapi_lang("Make sure you have completed all SO/Quotation Matching before checking on open quotations") ;
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$ckapi[filter][] = array(criteria	=>	exapi_lang('Customer') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.selectlist('customer','name','','','id','name','id') ,
				varname		=>	'customer' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Select the appropriate customer') );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Currency') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.selectlist('currency','isocode','','','isocode','isocode','description') ,
				varname		=>	'isocode' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Select the appropriate currency') );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Quotation Date (from)') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Must be a valid date')."; $dateformat" );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Quotation Date (to)') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Must be a valid date')."; $dateformat" );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Quotation Number') ,
				type		=>	'input' ,
				varname		=>	'quotenumber' ,
				defval		=>	"" ,
				note		=>	exapi_lang('Search for target key word/number in the sales order # field') );

	$ckapi[filter][] = array(criteria	=>	exapi_lang('Open Quotation Only') ,
				type		=>	'checkbox' ,
				varname		=>	'opentran' ,
				defval		=>	"" ,
				note		=>	exapi_lang("Click box if only Open Quotations are to be retrieved")."<br><b>$warning</b>" );

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
