<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// sontlist.php 0.15.1 2005/09/30 C K Wu

	$app = 'ck-so' ;
	$tran = 'sont' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'so' ,
				'tran'		=> $tran ,
				'table'		=> "${pre}so" 		);
	$ckapi[phrases] = array('lang_title'	=> exapi_lang("List of Sales Orders (SO) [no Tax]") ,
				'lang_add'	=> exapi_lang("Add New Sales Order [no Tax]") ,	);
	$ckapi[columns] = array('transdate'	=> exapi_lang('SO Date') ,
				'duedate'	=> exapi_lang('Due Date') ,
				'name'		=> exapi_lang('Customer') ,
				'sonumber'	=> exapi_lang('SO#') ,
				'isocode'	=> exapi_lang('Currency') ,
				'amount'	=> exapi_lang('Amount') ,
				'id'		=> exapi_lang('Audit ID') 		);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'billhist'	=> "/$app/sobillhist.php" ,
				'ordack'	=> "/$app/${tran}ordack.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'edit_addtax'	=> "/$app/sowtedit.php" , /* dummy */
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> exapi_lang("View") ,
				'lang_billhist'	=> exapi_lang('Billing History') ,
				'lang_ordack'	=> exapi_lang('Order Acknowledgement') ,
				'lang_bulk'	=> exapi_lang("Bulk Despatch") ,
				'lang_edit'	=> exapi_lang("Edit") ,
				'lang_edit_addtax'=>exapi_lang('Edit (Add Tax)') ,
				'lang_copy'	=> exapi_lang("Copy/Modify") ,
				'lang_delete'	=> exapi_lang("Delete") ,
				'lang_log'	=> exapi_lang("Log")				) ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_list() ;

	$temp1 = $ckapi[params_sql][temp1];
	$temp2 = $ckapi[params_sql][temp2];
	if ($temp1<>"")	$adodb->query("DROP TABLE $temp1");
	if ($temp2<>"")	$adodb->query("DROP TABLE $temp2");
	exapi_footer() ;

?>
